unit MainForm;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls, Math, Menus, TntStdCtrls, TNTForms, TNTClasses, StrUtils, TntSysUtils,
   TntButtons, ProcessViewer, TntCheckLst, TntComCtrls, CommCtrl, ShellApi, ActiveX, ComObj,
   ComCtrls, Buttons, xmldom, XMLIntf, msxmldom, XMLDoc, ImgList, Wininet, Dialogs, TNTClipbrd,
   TntMenus;

function GetEnvVarValue(const VarName: WideString): WideString;
function FindDriveWithVendorProductSize(const drvName: AnsiString): ShortInt;
procedure FindDrives;
function GetDriveSize(const hDrive: THandle): Int64;
function GetDriveVendorAndProductID(const hDrive: THandle): AnsiString;
function IsUSBDrive(const hDrive: THandle): Boolean;
function GenGuid: AnsiString;
function GenID: AnsiString;
procedure Replacebks(var ws: WideString; const len: Integer);
procedure GetVBVersion;
function GetLangTextDef(const IntBaseParam: Integer; const StrParams: array of AnsiString; const DefStr: AnsiString): WideString;
function GetLangTextFormatDef(const IntBaseParam: Integer; const StrParams: array of AnsiString; const VarRec: array of TVarRec; const DefStr: AnsiString): WideString;
function CStyleEscapes(const InputText: WideString): WideString;

type
   LastUsedIDS = record
      fdCID: AnsiString;
      fdGUID: AnsiString;
      sdCID: AnsiString;
      sdGUID: AnsiString;
   end;
   VMentry = record
      Name: WideString;
      Ptype: Byte;
      ModeLoadVM: Byte;
      VMID: WideString;
      VMName: WideString;
      VMPath: WideString;
      ExeParams: WideString;
      FirstDriveName: AnsiString;
      FirstDriveFound: Boolean;
      SecondDriveName: AnsiString;
      SecondDriveFound: Boolean;
      InternalHDD: WideString;
      CDROMName: WideString;
      CDROMType: Byte;
      Memory: Word;
      Audio: Byte;
      Run: Byte;
      Priority: Byte;
      luIDS: LastUsedIDS;
      VBCPUVirtualization: Byte;
   end;
   VolumeInfo = record
      Letter: AnsiChar;
      Handle: THandle;
      DriveProp: AnsiString;
   end;
   _STORAGE_DEVICE_NUMBER = record
      DeviceType: DWORD;
      DeviceNumber: DWORD;
      PartitionNumber: DWORD;
   end;
   STORAGE_DEVICE_NUMBER = _STORAGE_DEVICE_NUMBER;
   _GET_LENGTH_INFORMATION = record
      Length: Int64;
   end;
   TGetLengthInformation = _GET_LENGTH_INFORMATION;
   PDevBroadcastHdr = ^DEV_BROADCAST_HDR;
   DEV_BROADCAST_HDR = packed record
      dbch_size: DWORD;
      dbch_devicetype: DWORD;
      dbch_reserved: DWORD;
   end;
   PDevBroadcastVolume = ^TDevBroadcastVolume;
   TDevBroadcastVolume = packed record
      dbcv_size: DWORD;
      dbcv_devicetype: DWORD;
      dbcv_reserved: DWORD;
      dbcv_unitmask: DWORD;
      dbcv_flags: Word;
   end;
   PDevBroadcastDeviceInterface = ^DEV_BROADCAST_DEVICEINTERFACE;
   DEV_BROADCAST_DEVICEINTERFACE = record
      dbcc_size: DWORD;
      dbcc_devicetype: DWORD;
      dbcc_reserved: DWORD;
      dbcc_classguid: TGUID;
      dbcc_name: array[0..255] of Char;
   end;

type
   TfrmMain = class(TTNTForm)
      btnAdd: TTntSpeedButton;
      btnEdit: TTntSpeedButton;
      btnDelete: TTntSpeedButton;
      btnOptions: TTntSpeedButton;
      btnExit: TTntSpeedButton;
      btnStart: TTntSpeedButton;
      xmlGen: TXMLDocument;
      xmlVBox: TXMLDocument;
      xmlVBoxCompare: TXMLDocument;
      lvVMs: TTntListView;
      imlV: TImageList;
      xmlLanguage: TXMLDocument;
      pmVMs: TTntPopupMenu;
      pmHeaders: TTntPopupMenu;
      mmRefresh: TTntMenuItem;
      mmOptions: TTntMenuItem;
      mmHelp: TTntMenuItem;
      mmNumPlus: TTntMenuItem;
      mmEsc: TTntMenuItem;
      mmEnter: TTntMenuItem;
      mmUp: TTntMenuItem;
      mmDown: TTntMenuItem;
      mmMoveDownH: TTntMenuItem;
      mmMoveUpH: TTntMenuItem;
      mmDeleteH: TTntMenuItem;
      mmEditH: TTntMenuItem;
      mmMoveDown: TTntMenuItem;
      mmMoveUp: TTntMenuItem;
      mmDelete: TTntMenuItem;
      mmEdit: TTntMenuItem;
      mmAdd: TTntMenuItem;
      mmSecondDrive: TTntMenuItem;
      mmDrive: TTntMenuItem;
      mmVMName: TTntMenuItem;
      mmName: TTntMenuItem;
      mmCrt: TTntMenuItem;
      procedure btnExitClick(Sender: TObject);
      procedure btnAddClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure btnEditClick(Sender: TObject);
      procedure btnDeleteClick(Sender: TObject);
      procedure MoveUp(Sender: TObject);
      procedure MoveDown(Sender: TObject);
      procedure btnStartClick(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
      procedure lvVMsDragDrop(Sender, Source: TObject; X, Y: Integer);
      procedure lvVMsDragOver(Sender, Source: TObject; X, Y: Integer;
         State: TDragState; var Accept: Boolean);
      procedure TntFormMouseDown(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: Integer);
      procedure WindProc(var Message: TMessage);
      procedure TntFormResize(Sender: TObject);
      procedure pmHeadersPopup(Sender: TObject);
      procedure mmHeadersClick(Sender: TObject);
      procedure lvVMsColumnClick(Sender: TObject; Column: TListColumn);
      procedure lvVMsContextPopup(Sender: TObject; MousePos: TPoint;
         var Handled: Boolean);
      procedure lvVMsCustomDrawSubItem(Sender: TCustomListView;
         Item: TListItem; SubItem: Integer; State: TCustomDrawState;
         var DefaultDraw: Boolean);
      procedure mmDownClick(Sender: TObject);
      procedure mmUpClick(Sender: TObject);
      procedure mmEnterClick(Sender: TObject);
      procedure mmEscClick(Sender: TObject);
      procedure mmNumPlusClick(Sender: TObject);
      procedure btnOptionsClick(Sender: TObject);
      procedure mmHelpClick(Sender: TObject);
      procedure mmOptionsClick(Sender: TObject);
      procedure mmRefreshClick(Sender: TObject);
      procedure AcceptFiles(var msg: TMessage); message WM_DROPFILES;
   private
      { Private declarations }
      procedure Sort(const ColumnIndex: Integer);
      procedure SortAfterType;
      procedure pmChangeMessageBox(var Msg: TMessage); message WM_USER + 1024;
   public
      { Public declarations }
      procedure LoadVMentries(const FileName: WideString);
      procedure SaveVMentries(const FileName: WideString);
      function LoadCFG(const FileName: WideString): Boolean;
      procedure SaveCFG(const FileName: WideString);
      function LockVolume(const vi: VolumeInfo): Boolean;
      procedure AppActDeactModBegModEnd(Sender: TObject);
      procedure OpenInternetHelp(const OwnerWindowHandle: THandle; const SiteHelp: array of WideString);
      function FindCDROMLetter(const CDROMName: AnsiString): Char;
      procedure AppException(Sender: TObject; E: Exception);
      procedure ChangeCompLang;
   end;

type
   TComponentDrive = class(TComponent)
   private
      FWindowHandle: HWND;
      FHandle: Pointer;
      procedure WndProc(var Msg: TMessage);
      procedure DriveRegister;
   protected
      procedure WMDeviceChange(var Msg: TMessage); dynamic;
   public
      constructor Create(AOwner: TComponent); override;
      destructor Destroy; override;
   end;

const
   appVersion = ' 1.51';
   MAX_IDE_DRIVES = 16;
   METHOD_BUFFERED = 0;
   FILE_ANY_ACCESS = 0;
   FILE_DEVICE_FILE_SYSTEM = $00000009;
   FILE_DEVICE_MASS_STORAGE = $0000002D;
   IOCTL_STORAGE_BASE = FILE_DEVICE_MASS_STORAGE;
   IOCTL_STORAGE_GET_DEVICE_NUMBER = ((IOCTL_STORAGE_BASE shl 16) or (FILE_ANY_ACCESS shl 14) or
      ($0420 shl 2) or METHOD_BUFFERED);
   FILE_READ_ACCESS = $00000001;
   IOCTL_DISK_BASE = $00000007;
   IOCTL_DISK_GET_LENGTH_INFO = ((IOCTL_DISK_BASE shl 16) or FILE_READ_ACCESS shl 14) or ($0017 shl 2) or METHOD_BUFFERED; { CTL_CODE }
   IOCTL_STORAGE_QUERY_PROPERTY = (IOCTL_STORAGE_BASE shl 16) or (FILE_ANY_ACCESS shl 14) or ($0500 shl 2) or (METHOD_BUFFERED);
   IOCTL_DISK_UPDATE_PROPERTIES = ((IOCTL_DISK_BASE shl 16) or (FILE_ANY_ACCESS shl 14) or ($0050 shl 2) or METHOD_BUFFERED);
   defvmdk: array[1..6] of AnsiString = ('# Disk DescriptorFile'#10'version=1'#10'CID=',
      #10'parentCID=ffffffff'#10'createType="fullDevice"'#10#10'# Extent description'#10'RW ',
      ' FLAT "\\.\PhysicalDrive',
      '" 0'#10#10'# The disk Data Base'#10'#DDB'#10#10'ddb.virtualHWVersion = "4"'#10'ddb.adapterType="ide"'#10'ddb.geometry.cylinders="',
      '"'#10'ddb.geometry.heads="16"'#10'ddb.geometry.sectors="63"'#10'ddb.uuid.image="',
      '"'#10'ddb.uuid.parent="00000000-0000-0000-0000-000000000000"'#10'ddb.uuid.modification="00000000-0000-0000-0000-000000000000"'#10'ddb.uuid.parentmodification="00000000-0000-0000-0000-000000000000"'#10);
   DefSiteHelp: array[1..2] of WideString = ('http://reboot.pro/topic/18736-virtual-machine-usb-boot/',
      'http://reboot.pro/index.php?showtopic=18736');
   GUID_DEVINTERFACE_USB_DEVICE: TGUID = '{A5DCBF10-6530-11D2-901F-00C04FB951ED}';
   GUID_DEVINTERFACE_DISK: TGUID = '{53F56307-B6BF-11D0-94F2-00A0C91EFB8B}';
   DBT_DEVICEARRIVAL = $8000; // system detected a new device
   DBT_DEVICEREMOVECOMPLETE = $8004; // device is gone
   DBT_DEVTYP_DEVICEINTERFACE = $00000005; // device interface class
   DBT_DEVTYP_VOLUME = $00000002; // volume interface class

var
   frmMain: TfrmMain;
   fOldTWndMethod: TWndMethod;
   VMentries: array of VMentry;
   VMentriesFile, CfgFile, psEntries, psCFG, ExeVBPath, ExeQPath: WideString;
   QEMUDefaultParameters: WideString = '-name "USB Boot Test" -boot c -m 512 -soundhw sb16';
   LastError: Integer;
   OSDrive: Byte;
   MainLeft, MainTop, MainHeight, MainWidth, IntLeft, IntTop, IntHeight, IntWidth: Integer;
   MainMaximized: Boolean;
   DriveMessageShowed: Boolean = False;
   StartMessageShowed: Boolean = False;
   AddSecondDrive: Boolean = False;
   LockVolumes: Boolean = True;
   LastSelected: Integer = 0;
   UpdateVM: Byte = 0;
   isInstalledVersion: Boolean;
   Randomized: Boolean = False;
   VolumesInfo: array of VolumeInfo;
   ShowingProgress, ProgressCancelled, MainActivated: Boolean;
   VBVMWasClosed: TTime;
   SaveMaximized: Boolean = True;
   FlushWaitTime: Integer = 500;
   msgBoxCaption: WideString = 'Warning';
   BackupOldEntries: Boolean = True;
   DontWarn: Boolean = False;
   DefaultVMType: Byte = 0;
   ShowVBCPUVirtualizationOption: Boolean = False;
   RemoveDrive: Boolean = False;
   WaitForVBSVC: Boolean = True;
   VBSVC2x: Boolean = True;
   DriveDetect: TComponentDrive;
   FindDrivesScheduled: Boolean;
   ListOnlyUSBDrives: Boolean = True;
   CFGFoundAndLoaded: Boolean = False;
   AutomaticFont: Boolean = True;
   FontName: AnsiString;
   FontSize: Word;
   FontBold, FontItalic, FontUnderline, FontStrikeOut: Boolean;
   FontColor: TColor;
   FontScript: Word;
   DefaultFontName: AnsiString;
   DefaultFontSize: Word;
   DefaultFontBold, DefaultFontItalic, DefaultFontUnderline, DefaultFontStrikeOut: Boolean;
   DefaultFontColor: TColor;
   DefaultFontScript: Word;
   EscapeKeyClosesMain: Boolean = True;
   FHash: array[0..255] of array of array[1..2] of Word;
   DriveToAdd: Integer = -1;
   idxInterface: Integer = 1;
   idxLanguage: Integer = 0;
   idxMain: Integer = 1;
   idxAddEdit: Integer = 2;
   idxOptions: Integer = 3;
   idxMessagesType: Integer = 4;
   idxProgress: Integer = 5;
   idxInfoMess: Integer = 6;
   OKCaption: WideString = 'OK';
   LngFolder: WideString;
   CurrLanguageFile: WideString = 'ENGLISH';

implementation

uses AddEdit, Progress, Options, InfoMess;

{$R *.dfm}

procedure TfrmMain.OpenInternetHelp(const OwnerWindowHandle: THandle; const SiteHelp: array of WideString);
const
   INTERNET_CONNECTION_MODEM = 1;
   INTERNET_CONNECTION_LAN = 2;
   INTERNET_CONNECTION_PROXY = 4;
   INTERNET_CONNECTION_MODEM_BUSY = 8;
var
   i, dwConnectionTypes: Integer;
   isConnected: Boolean;
   NetHandle: HINTERNET;
   UrlHandle: HINTERNET;
   Buffer: array[0..1024] of Char;
   BytesRead: dWord;
begin
   try
      dwConnectionTypes := INTERNET_CONNECTION_MODEM +
         INTERNET_CONNECTION_LAN +
         INTERNET_CONNECTION_PROXY;
      if InternetGetConnectedState(@dwConnectionTypes, 0) then
         isConnected := True
      else
         isConnected := False;
   except
      isConnected := False;
   end;
   if not isConnected then
   begin
      msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
      PostMessage(OwnerWindowHandle, WM_USER + 1024, 0, 0);
      MessageBoxW(OwnerWindowHandle,
         PWideChar(GetLangTextDef(idxMain, ['Messages', 'NoInternet'], 'No internet connection detected !')),
         PWideChar(msgBoxCaption),
         MB_OK or MB_ICONWARNING);
   end
   else
   begin
      for i := Low(SiteHelp) to High(SiteHelp) do
      begin
         NetHandle := InternetOpen(PAnsiChar(Application.Title), INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, 0);
         if not Assigned(NetHandle) then
            Continue;
         try
            UrlHandle := InternetOpenUrlW(NetHandle, PWideChar(SiteHelp[i]), nil, 0, INTERNET_FLAG_RELOAD, 0);
            if not Assigned(UrlHandle) then
               Continue;
            try
               try
                  InternetReadFile(UrlHandle, @Buffer, 1024, BytesRead);
                  if BytesRead <> 1024 then
                     Continue;
               except
                  Continue;
               end;
            finally
               InternetCloseHandle(UrlHandle);
            end;
         finally
            InternetCloseHandle(NetHandle);
         end;
         if ShellExecuteW(OwnerWindowHandle, 'open', PWideChar(SiteHelp[i]), nil, nil, SW_SHOW) > 32 then
            Exit;
      end;
      msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
      PostMessage(OwnerWindowHandle, WM_USER + 1024, 0, 0);
      MessageBoxW(OwnerWindowHandle,
         PWideChar(GetLangTextDef(idxMain, ['Messages', 'NoHelp'], 'Help site not found, error opening browser or your antivirus is blocking the connection !')),
         PWideChar(msgBoxCaption),
         MB_OK or MB_ICONWARNING);
   end;
end;

procedure TfrmMain.pmChangeMessageBox(var Msg: TMessage);
var
   MBRect: TRect;
   i, x, y, w, h: integer;
   ws: WideString;
   p: PAnsiChar;
begin
   GetProcessList;
   i := 0;
   try
      p := MAKEINTRESOURCE(WC_DIALOG);
      ws := WideString('#' + IntToStr(Integer(p)));
   except
      ws := '#32770';
   end;
   while i <= High(ProcessInfo) do
   begin
      if ProcessInfo[i].WClass = ws then
         if ProcessInfo[i].WCaption = msgBoxCaption then
            if GetParent(ProcessInfo[i].Handle) = Handle then
               Break;
      Inc(i);
   end;
   if i <= High(ProcessInfo) then
   begin
      try
         if not GetWindowRect(ProcessInfo[i].Handle, MBRect) then
            Exit;
      except
         Exit;
      end;
      w := MBRect.Right - MBRect.Left;
      h := MBRect.Bottom - MBRect.Top;

      x := Left + ((Width - w) div 2);
      if x < Screen.WorkAreaLeft then
         x := Screen.WorkAreaLeft
      else if x + w > Screen.WorkAreaRect.Right then
         x := Screen.WorkAreaRect.Right - w;

      y := Top + ((Height - h) div 2);
      if y < Screen.WorkAreaTop then
         y := Screen.WorkAreaTop
      else if y + h > Screen.WorkAreaRect.Bottom then
         y := Screen.WorkAreaRect.Bottom - h;
      try
         SetWindowPos(ProcessInfo[i].Handle, 0, x, y, 0, 0, SWP_NOACTIVATE or SWP_NOSIZE
            or SWP_NOZORDER);
      except
      end;
   end;
end;

procedure Replacebks(var ws: WideString; const len: Integer);
var
   i: Integer;
begin
   i := 1;
   while i <= len do
   begin
      if ws[i] = '/' then
         ws[i] := '\';
      Inc(i);
   end;
end;

function FindDriveWithVendorProductSize(const drvName: AnsiString): ShortInt;
var
   i, j, l, ls: Integer;
   sz: Double;
   hDrive: THandle;
   strTemp, csz, mu: AnsiString;

   procedure Round3;
   var
      k, n: Integer;
   begin
      k := 0;
      if sz < 100 then
      begin
         while sz < 1000 do
         begin
            sz := sz * 10;
            Inc(k);
         end;
         Dec(k);
         csz := IntToStr(Round(sz / 10));
         if k <= 2 then
            Insert('.', csz, 4 - k)
         else
         begin
            for n := 1 to k - 2 do
               csz := '0' + csz;
            Insert('.', csz, 2);
         end;
      end
      else if sz > 1000 then
      begin
         while sz > 100 do
         begin
            sz := sz / 10;
            Inc(k);
         end;
         Dec(k);
         csz := IntToStr(Round(sz * 10));
         for n := 1 to k do
            csz := csz + '0';
      end
      else
         csz := IntToStr(Round(sz));
   end;

begin
   Result := -1;
   l := Length(drvName);
   for i := 0 to MAX_IDE_DRIVES - 1 do
   begin
      if i = OSDrive then
         Continue;
      try
         hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(i)), GENERIC_READ,
            FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
      except
         hDrive := INVALID_HANDLE_VALUE;
      end;
      if hDrive <> INVALID_HANDLE_VALUE then
      begin
         if ListOnlyUSBDrives and (not IsUSBDrive(hDrive)) then
         begin
            try
               CloseHandle(hDrive);
            except
            end;
            Continue;
         end;
         strTemp := GetDriveVendorAndProductID(hDrive);
         ls := Length(strTemp);
         if ls > l then
         begin
            try
               CloseHandle(hDrive);
            except
            end;
            Continue;
         end;
         j := 1;
         while j <= ls do
         begin
            if strTemp[j] <> drvName[j] then
               Break;
            Inc(j);
         end;
         if j <= ls then
         begin
            try
               CloseHandle(hDrive);
            except
            end;
            Continue;
         end;
         sz := GetDriveSize(hDrive) / 1073741824;
         try
            CloseHandle(hDrive);
         except
         end;
         if sz <= 0 then
            Continue
         else
         begin
            if sz < 1 then
            begin
               sz := sz * 1024;
               mu := ' MB';
            end
            else if sz > 1000 then
            begin
               sz := sz / 1024;
               mu := ' TB';
            end
            else
               mu := ' GB';
            Round3;
            strTemp := strTemp + ', ' + csz + mu;
         end;
         if Length(strTemp) = l then
         begin
            while j <= l do
            begin
               if strTemp[j] <> drvName[j] then
                  Break;
               Inc(j);
            end;
            if j > l then
            begin
               Result := i;
               Exit;
            end;
         end;
      end;
   end;
end;

procedure FindDrives;
var
   i, j, k, l, lv: Integer;
   H: Cardinal;
   sz: Double;
   hDrive: THandle;
   strTemp, csz, mu: AnsiString;

   procedure Round3;
   var
      k, n: Integer;
   begin
      k := 0;
      if sz < 100 then
      begin
         while sz < 1000 do
         begin
            sz := sz * 10;
            Inc(k);
         end;
         Dec(k);
         csz := IntToStr(Round(sz / 10));
         if k <= 2 then
            Insert('.', csz, 4 - k)
         else
         begin
            for n := 1 to k - 2 do
               csz := '0' + csz;
            Insert('.', csz, 2);
         end;
      end
      else if sz > 1000 then
      begin
         while sz > 100 do
         begin
            sz := sz / 10;
            Inc(k);
         end;
         Dec(k);
         csz := IntToStr(Round(sz * 10));
         for n := 1 to k do
            csz := csz + '0';
      end
      else
         csz := IntToStr(Round(sz));
   end;
begin
   lv := Length(VMentries);
   if lv = 0 then
      Exit;
   for i := 0 to lv - 1 do
   begin
      VMentries[i].FirstDriveFound := False;
      VMentries[i].SecondDriveFound := False;
   end;
   for i := 0 to MAX_IDE_DRIVES - 1 do
   begin
      if i = OSDrive then
         Continue;
      try
         hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(i)), GENERIC_READ,
            FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
      except
         hDrive := INVALID_HANDLE_VALUE;
      end;
      if hDrive <> INVALID_HANDLE_VALUE then
      begin
         if ListOnlyUSBDrives and (not IsUSBDrive(hDrive)) then
         begin
            try
               CloseHandle(hDrive);
            except
            end;
            Continue;
         end;
         strTemp := GetDriveVendorAndProductID(hDrive);
         if strTemp = '' then
         begin
            try
               CloseHandle(hDrive);
            except
            end;
            Continue;
         end;
         sz := GetDriveSize(hDrive) / 1073741824;
         try
            CloseHandle(hDrive);
         except
         end;
         if sz <= 0 then
            Continue
         else
         begin
            if sz < 1 then
            begin
               sz := sz * 1024;
               mu := ' MB';
            end
            else if sz > 1000 then
            begin
               sz := sz / 1024;
               mu := ' TB';
            end
            else
               mu := ' GB';
            Round3;
            strTemp := strTemp + ', ' + csz + mu;
         end;
         H := 2166136261;
         l := Length(strTemp);
         for j := 1 to l do
            H := (H xor Byte(strTemp[j])) * 16777619;
         H := H and 255;
         for j := 0 to High(FHash[H]) do
         begin
            if (FHash[H][j][1] <> 1) or (Length(vmEntries[FHash[H][j][2]].FirstDriveName) <> l) then
               Continue;
            k := 1;
            while k <= l do
            begin
               if strTemp[k] <> vmEntries[FHash[H][j][2]].FirstDriveName[k] then
                  Break;
               Inc(k);
            end;
            if k > l then
               vmEntries[FHash[H][j][2]].FirstDriveFound := True;
         end;
         if AddSecondDrive then
            for j := 0 to High(FHash[H]) do
            begin
               if (FHash[H][j][1] <> 2) or (Length(vmEntries[FHash[H][j][2]].SecondDriveName) <> l) then
                  Continue;
               k := 1;
               while k <= l do
               begin
                  if strTemp[k] <> vmEntries[FHash[H][j][2]].SecondDriveName[k] then
                     Break;
                  Inc(k);
               end;
               if k > l then
                  vmEntries[FHash[H][j][2]].SecondDriveFound := True;
            end;
      end;
   end;
end;

function GetDriveSize(const hDrive: THandle): Int64;
var
   dwBytesReturned: DWORD;
   LengthInformation: TGetLengthInformation;
begin
   try
      if DeviceIoControl(hDrive, IOCTL_DISK_GET_LENGTH_INFO, nil, 0, @LengthInformation, SizeOf(TGetLengthInformation), dwBytesReturned, nil) then
         Result := LengthInformation.Length
      else
         Result := -1;
      LastError := GetLastError;
   except
      Result := -1;
   end;
end;

type
   {$Z4}
   STORAGE_QUERY_TYPE = (
      PropertyStandardQuery = 0,
      PropertyExistsQuery,
      PropertyMaskQuery,
      PropertyQueryMaxDefined
      );
   {$Z1}

   {$Z4}
   STORAGE_PROPERTY_ID = (StorageDeviceProperty = 0, StorageAdapterProperty);
   {$Z1}
type
   STORAGE_BUS_TYPE = (
      BusTypeUnknown = $00,
      BusTypeScsi,
      BusTypeAtapi,
      BusTypeAta,
      BusType1394,
      BusTypeSsa,
      BusTypeFibre,
      BusTypeUsb,
      BusTypeRAID,
      BusTypeiScsi,
      BusTypeSas,
      BusTypeSata,
      BusTypeSd,
      BusTypeMmc,
      BusTypeMax,
      BusTypeMaxReserved = $7F);
   STORAGE_PROPERTY_QUERY = record
      PropertyId: STORAGE_PROPERTY_ID;
      QueryType: STORAGE_QUERY_TYPE;
      AdditionalParameters: array[0..1 - 1] of UCHAR;
   end;
   PSTORAGE_PROPERTY_QUERY = ^STORAGE_PROPERTY_QUERY;
   STORAGE_DEVICE_DESCRIPTOR = record
      Version: Cardinal;
      Size: Cardinal;
      DeviceType: Byte;
      DeviceTypeModifier: Byte;
      RemovableMedia: Byte;
      CommandQueueing: Byte;
      VendorIdOffset: Cardinal;
      ProductIdOffset: Cardinal;
      ProductRevisionOffset: Cardinal;
      SerialNumberOffset: Cardinal;
      BusType: STORAGE_BUS_TYPE;
      RawPropertiesLength: Cardinal;
      RawDeviceProperties: array[0..1 - 1] of Byte;
   end;
   PSTORAGE_DEVICE_DESCRIPTOR = ^STORAGE_DEVICE_DESCRIPTOR;
   {$ALIGN on}

function crt_isspace(ch: Integer): Integer; cdecl; external 'crtdll.dll' name 'isspace';

function crt_tolower(ch: Integer): Integer; cdecl; external 'crtdll.dll' name 'tolower';

function crt_isprint(ch: Integer): Integer; cdecl; external 'crtdll.dll' name 'isprint';

function GetDriveVendorAndProductID(const hDrive: THandle): AnsiString;

   function tolower(ch: AnsiChar): AnsiChar;
   begin
      Result := AnsiChar(Chr(crt_tolower(Ord(ch))));
   end;

   function isspace(ch: AnsiChar): Boolean;
   begin
      Result := crt_isspace(Ord(ch)) <> 0;
   end;

   function isprint(ch: AnsiChar): Boolean;
   begin
      Result := crt_isprint(Ord(ch)) <> 0;
   end;

   function flipAndCodeBytes(str: PAnsiChar; pos: Integer; flip: Integer; buf: PAnsiChar): AnsiString;
   var
      i, j, k: Integer;
      p: Integer;
      c: AnsiChar;
      t: AnsiChar;
   begin
      j := 0;
      k := 0;

      buf[0] := Chr(0);
      if (pos <= 0) then
      begin
         Result := buf;
         exit;
      end;

      if (j = 0) then
      begin
         p := 0;

         j := 1;
         k := 0;
         buf[k] := Chr(0);
         i := pos;
         while (j <> 0) and (str[i] <> Chr(0)) do
         begin
            c := tolower(str[i]);

            if (isspace(c)) then
               c := Chr(0);

            inc(p);
            buf[k] := AnsiChar(Chr(Ord(buf[k]) shl 4));

            if ((c >= '0') and (c <= '9')) then
               buf[k] := AnsiChar(Chr(Ord(buf[k]) or Byte(Ord(c) - Ord('0'))))
            else if ((c >= 'a') and (c <= 'f')) then
               buf[k] := AnsiChar(Chr(Ord(buf[k]) or Byte(Ord(c) - Ord('a') + 10)))
            else
            begin
               j := 0;
               break;
            end;

            if (p = 2) then
            begin
               if ((buf[k] <> Chr(0)) and (not isprint(buf[k]))) then
               begin
                  j := 0;
                  break;
               end;
               inc(k);
               p := 0;
               buf[k] := Chr(0);
            end;
            inc(i);
         end;
      end;

      if (j = 0) then
      begin
         j := 1;
         k := 0;
         i := pos;
         while ((j <> 0) and (str[i] <> Chr(0))) do
         begin
            c := str[i];

            if (not isprint(c)) then
            begin
               j := 0;
               break;
            end;

            buf[(k)] := c;
            inc(k);
            inc(i);
         end;
      end;

      if (j = 0) then
         k := 0;

      buf[k] := Chr(0);

      if (flip <> 0) then
      begin
         j := 0;
         while (j < k) do
         begin
            t := buf[j];
            buf[j] := buf[j + 1];
            buf[j + 1] := t;
            j := j + 2;
         end
      end;

      i := -1;
      j := -1;
      k := 0;
      while (buf[k] <> Chr(0)) do
      begin
         if (not isspace(buf[k])) then
         begin
            if (i < 0) then
               i := k;
            j := k;
         end;
         inc(k);
      end;

      if ((i >= 0) and (j >= 0)) then
      begin
         k := i;
         while ((k <= j) and (buf[k] <> Chr(0))) do
         begin
            buf[k - i] := buf[k];
            inc(k);
         end;
         buf[k - i] := Chr(0);
      end;

      Result := buf;
   end;

var
   query: STORAGE_PROPERTY_QUERY;
   cbBytesReturned: Cardinal;
   buffer, vendorID, modelNumber: array[0..10000 - 1] of AnsiChar;
   descrip: PSTORAGE_DEVICE_DESCRIPTOR;
begin
   cbBytesReturned := 0;
   FillMemory(@query, sizeof(query), 0);
   query.PropertyId := StorageDeviceProperty;
   query.QueryType := PropertyStandardQuery;
   FillMemory(@buffer, sizeof(buffer), 0);
   try
      if DeviceIoControl(hDrive, IOCTL_STORAGE_QUERY_PROPERTY, @query, sizeof(query),
         @buffer, sizeof(buffer), cbBytesReturned, nil) then
      begin
         descrip := PSTORAGE_DEVICE_DESCRIPTOR(@buffer);
         flipAndCodeBytes(buffer, descrip^.VendorIdOffset, 0, vendorId);
         flipAndCodeBytes(buffer, descrip^.ProductIdOffset, 0, modelNumber);
         Result := AnsiString(vendorId) + ' ' + AnsiString(modelNumber);
      end
      else
         Result := '';
   except
      Result := '';
   end;
end;

procedure FlushToDisk(const hVolume: THandle);
begin
   try
      FlushFileBuffers(hVolume);
   except
   end;
end;

function TfrmMain.LockVolume(const vi: VolumeInfo): Boolean;
const
   FSCTL_LOCK_VOLUME = (9 shl 16) or (0 shl 14) or (6 shl 2) or 0;
var
   dwBytesReturned: Cardinal;
   i: Integer;
begin
   try
      Result := DeviceIoControl(vi.Handle, FSCTL_LOCK_VOLUME, nil, 0,
         nil, 0, dwBytesReturned, nil);
      LastError := GetLastError;
   except
      Result := False;
   end;
   if Result then
      Exit
   else
      LastError := GetLastError;
   ShowingProgress := False;
   ProgressCancelled := False;
   try
      if frmProgress = nil then
         Application.CreateForm(TfrmProgress, frmProgress);
      with frmProgress do
      begin
         lblMessage.Caption := GetLangTextFormatDef(idxMain, ['Messages', 'TryLock'], [vi.Letter, vi.DriveProp], 'Trying to lock volume ''%s'' on "%s"...');
         btnCancel.Caption := GetLangTextDef(idxMain, ['Messages', 'CancelLock'], 'Cancel (unsafe)');
         pbProgress.Max := 200;
         Show;
      end;
      Application.ProcessMessages;
      ShowingProgress := True;
   except
      if frmProgress.Visible then
         frmProgress.Close;
      frmProgress.Free;
      frmProgress := nil;
   end;
   for i := 1 to 200 do
   begin
      Sleep(50);
      if ShowingProgress then
      begin
         frmProgress.pbProgress.Position := i;
         Application.ProcessMessages;
         if not frmProgress.Visible then
         begin
            Sleep(100);
            Break;
         end;
      end;
      if i mod 10 = 1 then
      begin
         try
            Result := DeviceIoControl(vi.Handle, FSCTL_LOCK_VOLUME, nil, 0,
               nil, 0, dwBytesReturned, nil);
            LastError := GetLastError;
         except
            Result := False;
         end;
         if Result then
            Break;
      end;
   end;
   if ShowingProgress then
      try
         if frmProgress.Visible then
            frmProgress.Close;
         frmProgress.Free;
         frmProgress := nil;
      except
      end;
end;

function DismountVolume(const hVolume: THandle): Boolean;
const
   FSCTL_DISMOUNT_VOLUME = (9 shl 16) or (0 shl 14) or (8 shl 2) or 0;
var
   dwBytesReturned: Cardinal;
begin
   try
      Result := DeviceIoControl(hVolume, FSCTL_DISMOUNT_VOLUME, nil, 0,
         nil, 0, dwBytesReturned, nil);
   except
      Result := False;
   end;
   if not Result then
      LastError := GetLastError;
end;

procedure UpdateDrive(const aDrive: Byte);
var
   hDrive: THandle;
   dwBytesReturned: Cardinal;
begin
   hDrive := INVALID_HANDLE_VALUE;
   try
      hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(aDrive)), 0,
         FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
   except
   end;
   if hDrive <> INVALID_HANDLE_VALUE then
   begin
      try
         DeviceIoControl(hDrive, IOCTL_DISK_UPDATE_PROPERTIES, nil, 0, nil, 0, dwBytesReturned, nil);
      except
      end;
      try
         CloseHandle(hDrive);
      except
      end;
   end;
end;

function IsUSBDrive(const hDrive: THandle): Boolean;
var
   Query: STORAGE_PROPERTY_QUERY;
   dwBytesReturned: DWORD;
   Buffer: array[0..1023] of Byte;
   sdd: STORAGE_DEVICE_DESCRIPTOR absolute Buffer;
begin
   Result := False;
   dwBytesReturned := 0;
   FillChar(Query, SizeOf(Query), 0);
   FillChar(Buffer, SizeOf(Buffer), 0);
   sdd.Size := SizeOf(Buffer);
   Query.PropertyId := StorageDeviceProperty;
   Query.QueryType := PropertyStandardQuery;
   try
      if DeviceIoControl(hDrive, IOCTL_STORAGE_QUERY_PROPERTY, @Query, SizeOf(Query), @Buffer, SizeOf(Buffer), dwBytesReturned, nil) then
         Result := sdd.BusType = BusTypeUsb;
   except
   end;
end;

function GetEnvVarValue(const VarName: WideString): WideString;
var
   BufSize: Integer;
begin
   BufSize := GetEnvironmentVariableW(
      PWideChar(VarName), nil, 0);
   if BufSize > 0 then
   begin
      SetLength(Result, BufSize - 1);
      GetEnvironmentVariableW(PWideChar(VarName),
         PWideChar(Result), BufSize);
   end
   else
      Result := '';
end;

function GenGuid: AnsiString;
var
   g: TGUID;
   r: Boolean;
begin
   try
      r := CreateGUID(g) = S_OK;
   except
      r := False;
   end;
   if r then
   begin
      try
         Result := GUIDToString(g);
         Result := AnsiLowerCase(Copy(Result, 2, Length(Result) - 2));
      except
         Result := '';
      end;
   end
   else
      Result := '';
   if Result = '' then
   begin
      if not Randomized then
      begin
         Randomize;
         Randomized := True;
      end;
      Result := AnsiLowerCase(IntToHex(Random(16777216), 6) + IntToHex(Random(256), 2) + '-' +
         IntToHex(Random(65536), 4) + '-' + IntToHex(Random(65536), 4) + '-' + IntToHex(Random(65536), 4) + '-' +
         IntToHex(Random(16777216), 6) + IntToHex(Random(16777216), 6));
   end;
end;

function GenID: AnsiString;
var
   g: TGUID;
   r: Boolean;
begin
   try
      r := CreateGUID(g) = S_OK;
   except
      r := False;
   end;
   if r then
   begin
      try
         Result := GUIDToString(g);
         Result := AnsiLowerCase(Result[2] + Result[6] + Result[11] + Result[14] + Result[18] + Result[22] + Result[28] + Result[34])
      except
         Result := '';
      end;
   end
   else
      Result := '';
   if Result = '' then
   begin
      if not Randomized then
      begin
         Randomize;
         Randomized := True;
      end;
      Result := AnsiLowerCase(IntToHex(Random(16777216), 6) + IntToHex(Random(256), 2));
   end;
end;

procedure TfrmMain.LoadVMentries(const FileName: WideString);
var
   i, j, l, p, c: Integer;
   t: TTNTFileStream;
   st: WideString;
   wsa: array of WideString;
begin
   try
      t := TTNTFileStream.Create(FileName, fmOpenRead or fmShareDenyWrite);
   except
      on E: Exception do
      begin
         MessageBoxW(Handle,
            PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CantOpenToRead'], [FileName, E.Message], 'Could not open "%s" for reading !'#13#10#13#10'System message: %s')),
            PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')), MB_OK or MB_ICONERROR);
         Exit;
      end;
   end;
   l := 0;
   try
      l := Min(1048576, t.Size div 2);
      SetLength(psEntries, l);
      t.Position := 0;
      t.ReadBuffer(Pointer(psEntries)^, l * 2);
   except
      on E: Exception do
         MessageBoxW(Handle,
            PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CantRead'], [FileName, E.Message], 'Could not read from "%s" !'#13#10#13#10'System message: %s')),
            PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')),
            MB_OK or MB_ICONERROR);
   end;
   try
      t.Free;
   except
   end;

   if psEntries = '' then
      Exit;
   try
      SetLength(wsa, 0);
      p := 2;
      i := PosEx(#13, psEntries, 2);
      while i > 0 do
      begin
         SetLength(wsa, Length(wsa) + 1);
         wsa[High(wsa)] := Trim(Copy(psEntries, p, i - p));
         p := i + 1;
         if i < l then
            if psEntries[i + 1] = #10 then
               Inc(p);
         i := PosEx(#13, psEntries, p);
      end;
      if p <= l then
      begin
         SetLength(wsa, Length(wsa) + 1);
         wsa[High(wsa)] := Trim(Copy(psEntries, p, l - p + 1));
      end;
   except
   end;

   c := -1;
   for i := 0 to High(wsa) do
   begin
      l := Length(wsa[i]);
      if l < 3 then
         Continue;
      if (wsa[i][1] = '[') and (wsa[i][l] = ']') then
      begin
         st := Trim(Copy(wsa[i], 2, Min(1024, l - 2)));
         if st <> '' then
         begin
            Inc(c);
            SetLength(VMEntries, c + 1);
            with VMEntries[c] do
            begin
               Name := st;
               ModeLoadVM := 2;
               Priority := 1;
               FirstDriveName := 'Unknown';
               VBCPUVirtualization := 0;
               CDROMType := 0;
               Memory := 512;
               Audio := 0;
            end;
         end;
      end;
      if c > -1 then
         with VMEntries[c] do
         begin
            if (Pos('Type=', wsa[i]) = 1) and (l > 5) then
            begin
               st := Trim(Copy(wsa[i], 6, Min(100, l - 5)));
               if st = 'VirtualBox' then
               begin
                  Ptype := 0;
                  ModeLoadVM := 0;
               end
               else if st = 'Qemu' then
                  Ptype := 1
               else
               begin
                  Ptype := 0;
                  ModeLoadVM := 0;
               end;
            end;
            if Ptype <> 1 then
               if (Pos('ModeToLoadVM=', wsa[i]) = 1) and (l > 13) then
               begin
                  st := Trim(Copy(wsa[i], 14, Min(1024, l - 13)));
                  if st = 'VMName' then
                     ModeLoadVM := 0
                  else if st = 'PathToVM' then
                     ModeLoadVM := 1
                  else if st = 'ExeParameters' then
                     ModeLoadVM := 2
                  else if Ptype = 1 then
                     ModeLoadVM := 2
                  else
                     ModeLoadVM := 0;
               end;
            if (Pos('ExeParams=', wsa[i]) = 1) and (l > 10) then
               ExeParams := Trim(Copy(wsa[i], 11, Min(10240, l - 10)));
            if Ptype <> 1 then
            begin
               if (Pos('VMID=', wsa[i]) = 1) and (l > 5) then
                  VMID := Trim(Copy(wsa[i], 6, Min(1024, l - 5)));
               if (Pos('PathToVM=', wsa[i]) = 1) and (l > 9) then
                  VMPath := Trim(Copy(wsa[i], 10, Min(1024, l - 9)));
            end;
            if (Pos('VMName=', wsa[i]) = 1) and (l > 7) then
               VMName := Trim(Copy(wsa[i], 8, l - 7));
            if (Pos('FirstDriveName=', wsa[i]) = 1) and (l > 15) then
               FirstDriveName := Trim(Copy(wsa[i], 16, Min(1024, l - 15)));
            if (Pos('SecondDriveName=', wsa[i]) = 1) and (l > 16) then
               SecondDriveName := Trim(Copy(wsa[i], 17, Min(1024, l - 16)));
            if (Pos('EnableCPUVirtualization=', wsa[i]) = 1) and (l > 24) then
            begin
               st := Trim(Copy(wsa[i], 25, Min(1024, l - 24)));
               if st = 'Unchanged' then
                  VBCPUVirtualization := 0
               else if st = 'On' then
                  VBCPUVirtualization := 1
               else if st = 'Off' then
                  VBCPUVirtualization := 2
               else if st = 'Switch' then
                  VBCPUVirtualization := 3
               else
                  VBCPUVirtualization := 0;
            end;
            if (Pos('InternalHDD=', wsa[i]) = 1) and (l > 12) then
               InternalHDD := Trim(Copy(wsa[i], 13, Min(1024, l - 12)));
            if (Pos('CDDVDName=', wsa[i]) = 1) and (l > 10) then
               CDROMName := Trim(Copy(wsa[i], 11, Min(1024, l - 10)));
            if (Pos('CDDVDType=', wsa[i]) = 1) and (l > 10) then
               if Trim(Copy(wsa[i], 11, Min(100, l - 10))) = 'File' then
                  CDROMType := 1;

            if (Pos('Memory=', wsa[i]) = 1) and (l > 7) then
               Memory := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 8, Min(5, l - 7))), 512), 1), 65535);
            if (Pos('Audio=', wsa[i]) = 1) and (l > 6) then
            begin
               st := Trim(Copy(wsa[i], 7, Min(1024, l - 6)));
               if st = 'Creative Sound Blaster 16' then
                  Audio := 1
               else if st = 'PC speaker' then
                  Audio := 2
               else if st = 'Intel HD Audio' then
                  Audio := 3
               else if st = 'Gravis Ultrasound GF1' then
                  Audio := 4
               else if st = 'ENSONIQ AudioPCI ES1370' then
                  Audio := 5
               else if st = 'CS4231A' then
                  Audio := 6
               else if st = 'Yamaha YM3812 (OPL2)' then
                  Audio := 7
               else if st = 'Intel 82801AA AC97 Audio' then
                  Audio := 8
               else
                  Audio := 0;
            end;
            if (Pos('Run=', wsa[i]) = 1) and (l > 4) then
            begin
               st := Trim(Copy(wsa[i], 5, Min(1024, l - 4)));
               if st = 'Normal' then
                  Run := 0
               else if st = 'Minimized' then
                  Run := 1
               else if st = 'Maximized' then
                  Run := 2
               else if ((Ptype = 0) and (st = 'Maximized')) or ((Ptype = 1) and (st = 'Hidden')) then
                  Run := 3
               else
                  Run := 0;
            end;
            if (Pos('Priority=', wsa[i]) = 1) and (l > 9) then
            begin
               st := Trim(Copy(wsa[i], 10, Min(1024, l - 9)));
               if st = 'BelowNormal' then
                  Priority := 0
               else if st = 'Normal' then
                  Priority := 1
               else if st = 'AboveNormal' then
                  Priority := 2
               else if st = 'High' then
                  Priority := 3
               else
                  Priority := 1;
            end;
         end;
   end;
   for i := 0 to High(VMEntries) do
      if VMEntries[i].Ptype = 1 then
         try
            st := VMEntries[i].ExeParams;
            p := Pos('-m ', st);
            if (p = 1) or ((p > 1) and (st[p - 1] = ' ')) then
            begin
               j := p + 3;
               l := Length(st);
               while j <= l do
               begin
                  if (st[j] < '0') or (st[j] > '9') then
                     Break;
                  Inc(j);
               end;
               Delete(st, Max(1, p - 1), j - Max(1, p - 1));
            end;
            p := Pos('-soundhw ', st);
            if (p = 1) or ((p > 1) and (st[p - 1] = ' ')) then
            begin
               j := p + 9;
               l := Length(st);
               while j <= l do
               begin
                  if (st[j] = '-') or (st[j] = ' ') then
                     Break;
                  Inc(j);
               end;
               Delete(st, Max(1, p - 1), j - Max(1, p - 1));
            end;
            VMEntries[i].ExeParams := st;
         except
         end;
end;

procedure TfrmMain.SaveVMentries(const FileName: WideString);
var
   i, l: Integer;
   t: TTNTFileStream;
   s, sType, sMode, sRun, sPriority, sEnableCPUVirtualization, BaseFolder, sAudio, sCDROMType: WideString;
begin
   s := #65279;
   for i := 0 to High(VMentries) do
      with VMentries[i] do
      begin
         if Ptype = 0 then
            sType := 'VirtualBox'
         else
            sType := 'Qemu';
         case ModeLoadVM of
            1: sMode := 'PathToVM';
            2: sMode := 'ExeParameters';
         else
            sMode := 'VMName';
         end;
         case VBCPUVirtualization of
            1: sEnableCPUVirtualization := 'On';
            2: sEnableCPUVirtualization := 'Off';
            3: sEnableCPUVirtualization := 'Switch';
         else
            sEnableCPUVirtualization := 'Unchanged';
         end;
         if CDROMType = 0 then
            sCDROMType := 'Device'
         else
            sCDROMType := 'File';
         case Audio of
            1: sAudio := 'Creative Sound Blaster 16';
            2: sAudio := 'PC speaker';
            3: sAudio := 'Intel HD Audio';
            4: sAudio := 'Gravis Ultrasound GF1';
            5: sAudio := 'ENSONIQ AudioPCI ES1370';
            6: sAudio := 'CS4231A';
            7: sAudio := 'Yamaha YM3812 (OPL2)';
            8: sAudio := 'Intel 82801AA AC97 Audio';
         else
            sAudio := 'None';
         end;
         case Run of
            1: sRun := 'Minimized';
            2: sRun := 'Maximized';
            3: if Ptype = 0 then
                  sRun := 'Fullscreen'
               else
                  sRun := 'Hidden';
         else
            sRun := 'Normal';
         end;
         case Priority of
            0: sPriority := 'BelowNormal';
            2: sPriority := 'AboveNormal';
            3: sPriority := 'High';
         else
            sPriority := 'Normal';
         end;
         if AddSecondDrive then
         begin
            if Ptype = 0 then
            begin
               if ShowVBCPUVirtualizationOption then
                  s := s + '[' + Name + ']'#13#10'Type=' + sType + #13#10'ModeToLoadVM=' + sMode + #13#10'ExeParams=' + ExeParams + #13#10'VMID=' + VMID + #13#10'VMName=' + VMName + #13#10'PathToVM=' + VMPath + #13#10'FirstDriveName=' + FirstDriveName + #13#10'SecondDriveName=' + SecondDriveName + #13#10'EnableCPUVirtualization=' + sEnableCPUVirtualization + #13#10'Run=' + sRun + #13#10'Priority=' + sPriority + #13#10
               else
                  s := s + '[' + Name + ']'#13#10'Type=' + sType + #13#10'ModeToLoadVM=' + sMode + #13#10'ExeParams=' + ExeParams + #13#10'VMID=' + VMID + #13#10'VMName=' + VMName + #13#10'PathToVM=' + VMPath + #13#10'FirstDriveName=' + FirstDriveName + #13#10'SecondDriveName=' + SecondDriveName + #13#10'Run=' + sRun + #13#10'Priority=' + sPriority + #13#10;
            end
            else
               s := s + '[' + Name + ']'#13#10'Type=' + sType + #13#10'ExeParams=' + ExeParams + #13#10'VMName=' + VMName + #13#10'FirstDriveName=' + FirstDriveName + #13#10'SecondDriveName=' + SecondDriveName + #13#10'InternalHDD=' + InternalHDD + #13#10'CDDVDName=' + CDROMName + #13#10'CDDVDType=' + sCDROMType + #13#10'Memory=' + IntToStr(Memory) + #13#10'Audio=' + sAudio + #13#10'Run=' + sRun + #13#10'Priority=' + sPriority + #13#10;
         end
         else if Ptype = 0 then
         begin
            if ShowVBCPUVirtualizationOption then
               s := s + '[' + Name + ']'#13#10'Type=' + sType + #13#10'ModeToLoadVM=' + sMode + #13#10'ExeParams=' + ExeParams + #13#10'VMID=' + VMID + #13#10'VMName=' + VMName + #13#10'PathToVM=' + VMPath + #13#10'FirstDriveName=' + FirstDriveName + #13#10'EnableCPUVirtualization=' + sEnableCPUVirtualization + #13#10'Run=' + sRun + #13#10'Priority=' + sPriority + #13#10
            else
               s := s + '[' + Name + ']'#13#10'Type=' + sType + #13#10'ModeToLoadVM=' + sMode + #13#10'ExeParams=' + ExeParams + #13#10'VMID=' + VMID + #13#10'VMName=' + VMName + #13#10'PathToVM=' + VMPath + #13#10'FirstDriveName=' + FirstDriveName + #13#10'Run=' + sRun + #13#10'Priority=' + sPriority + #13#10;
         end
         else
            s := s + '[' + Name + ']'#13#10'Type=' + sType + #13#10'ExeParams=' + ExeParams + #13#10'VMName=' + VMName + #13#10'FirstDriveName=' + FirstDriveName + #13#10'InternalHDD=' + InternalHDD + #13#10'CDDVDName=' + CDROMName + #13#10'CDDVDType=' + sCDROMType + #13#10'Memory=' + IntToStr(Memory) + #13#10'Audio=' + sAudio + #13#10'Run=' + sRun + #13#10'Priority=' + sPriority + #13#10;
      end;
   if psEntries = s then
      Exit;
   if BackupOldEntries then
      try
         if WideFileExists(FileName + '.bak') then
            WideDeleteFile(FileName + '.bak');
         if WideFileExists(FileName) then
            WideRenameFile(FileName, FileName + '.bak');
      except
      end;
   if isInstalledVersion then
   begin
      try
         BaseFolder := WideExtractFilePath(FileName);
         if not WideDirectoryExists(BaseFolder) then
            WideForceDirectories(BaseFolder);
      except
      end;
      if not WideDirectoryExists(BaseFolder) then
      begin
         if not DontWarn then
         begin
            msgBoxCaption := GetLangTextDef(idxMessagesType, ['Error'], 'Error');
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            MessageBoxW(Handle,
               PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CantCreate'], [BaseFolder], 'Could not create "%s" !')),
               PWideChar(msgBoxCaption), MB_OK or MB_ICONERROR);
         end;
         Exit;
      end;
   end;
   try
      t := TTNTFileStream.Create(FileName, fmCreate or fmShareDenyWrite);
   except
      on E: Exception do
      begin
         if not DontWarn then
         begin
            msgBoxCaption := GetLangTextDef(idxMessagesType, ['Error'], 'Error');
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            MessageBoxW(Handle,
               PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CantCreateOrOpen'], [FileName, E.Message], 'Could not create or open "%s" for writing !'#13#10#13#10'System message: %s')),
               PWideChar(msgBoxCaption), MB_OK or MB_ICONERROR);
         end;
         Exit;
      end;
   end;
   try
      l := Length(s);
      t.Size := 2 * l;
      t.Position := 0;
      t.WriteBuffer(Pointer(s)^, 2 * l);
      psEntries := s;
   except
      on E: Exception do
         if not DontWarn then
         begin
            msgBoxCaption := GetLangTextDef(idxMessagesType, ['Error'], 'Error');
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            MessageBoxW(Handle,
               PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CantWrite'], [FileName, E.Message], 'Could not write into "%s" !'#13#10#13#10'System message: %s')),
               PWideChar(msgBoxCaption), MB_OK or MB_ICONERROR);
         end;
   end;
   try
      t.Free;
   except
   end;
end;

function TfrmMain.LoadCFG(const FileName: WideString): Boolean;
var
   i, j, l, p: Integer;
   t: TTNTFileStream;
   ws, wst: WideString;
   wsa: array of WideString;
begin
   Result := False;
   try
      t := TTNTFileStream.Create(FileName, fmOpenRead or fmShareDenyWrite);
   except
      on E: Exception do
      begin
         MessageBoxW(Handle,
            PWideChar(WideFormat('Could not open "%s" for reading !\r\n\r\nSystem message:', [FileName]) + ' ' + E.Message),
            'Error', MB_OK or MB_ICONERROR);
         Exit;
      end;
   end;
   l := 0;
   try
      l := Min(1048576, t.Size div 2);
      SetLength(psCFG, l);
      t.Position := 0;
      t.ReadBuffer(Pointer(psCFG)^, l * 2);
   except
      on E: Exception do
         MessageBoxW(Handle,
            PWideChar(WideFormat('Could not read from "%s" !\r\n\r\nSystem message:', [FileName]) + ' ' + E.Message),
            'Error', MB_OK or MB_ICONERROR);
   end;
   try
      t.Free;
   except
   end;

   if psCFG = '' then
      Exit;
   try
      SetLength(wsa, 0);
      p := 2;
      i := PosEx(#13, psCFG, 2);
      while i > 0 do
      begin
         SetLength(wsa, Length(wsa) + 1);
         wsa[High(wsa)] := Trim(Copy(psCFG, p, i - p));
         p := i + 1;
         if i < l then
            if psCFG[i + 1] = #10 then
               Inc(p);
         i := PosEx(#13, psCFG, p);
      end;
      if p <= l then
      begin
         SetLength(wsa, Length(wsa) + 1);
         wsa[High(wsa)] := Trim(Copy(psCFG, p, l - p + 1));
      end;
   except
   end;

   Result := Length(wsa) > 0;

   for i := 0 to High(wsa) do
   begin
      l := Length(wsa[i]);
      if l < 3 then
         Continue;
      if (Pos('DriveMessageShowed=', wsa[i]) = 1) and (l > 19) then
      begin
         DriveMessageShowed := StrToBoolDef(Trim(Copy(wsa[i], 20, Min(100, l - 19))), DriveMessageShowed);
         Continue;
      end;
      if (Pos('StartMessageShowed=', wsa[i]) = 1) and (l > 14) then
      begin
         StartMessageShowed := StrToBoolDef(Trim(Copy(wsa[i], 20, Min(100, l - 19))), StartMessageShowed);
         Continue;
      end;
      if (Pos('Width=', wsa[i]) = 1) and (l > 6) then
      begin
         MainWidth := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 7, Min(100, l - 6))), MainWidth), Constraints.MinWidth), Screen.WorkAreaWidth);
         Continue;
      end;
      if (Pos('Height=', wsa[i]) = 1) and (l > 7) then
      begin
         MainHeight := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 8, Min(100, l - 7))), MainHeight), Constraints.MinHeight), Screen.WorkAreaHeight);
         Continue;
      end;
      if (Pos('Left=', wsa[i]) = 1) and (l > 5) then
      begin
         MainLeft := Min(Max(Round(0.0001 * Screen.WorkAreaWidth * StrToIntDef(Trim(Copy(wsa[i], 6, Min(100, l - 5))), Round(10000.0 * (MainLeft - Screen.WorkAreaLeft) / Screen.WorkAreaWidth)) + Screen.WorkAreaLeft), Screen.WorkAreaLeft), Screen.WorkAreaWidth - MainWidth);
         Continue;
      end;
      if (Pos('Top=', wsa[i]) = 1) and (l > 4) then
      begin
         MainTop := Min(Max(Round(0.0001 * Screen.WorkAreaHeight * StrToIntDef(Trim(Copy(wsa[i], 5, Min(100, l - 4))), Round(10000.0 * (MainTop - Screen.WorkAreaTop) / Screen.WorkAreaHeight)) + Screen.WorkAreaTop), Screen.WorkAreaTop), Screen.WorkAreaHeight - MainHeight);
         Continue;
      end;
      if (Pos('Maximized=', wsa[i]) = 1) and (l > 10) then
      begin
         MainMaximized := StrToBoolDef(Trim(Copy(wsa[i], 11, l - 10)), MainMaximized);
         Continue;
      end;
      if (Pos('#ColumnWidth=', wsa[i]) = 1) and (l > 13) then
      begin
         pmHeaders.Items[0].Tag := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 14, Min(100, l - 13))), pmHeaders.Items[0].Tag), 10), MainWidth);
         Continue;
      end;
      if (Pos('#ColumnShow=', wsa[i]) = 1) and (l > 11) then
      begin
         pmHeaders.Items[0].Checked := StrToBoolDef(Trim(Copy(wsa[i], 13, Min(100, l - 12))), pmHeaders.Items[0].Checked);
         Continue;
      end;
      j := 1;
      while j < pmHeaders.Items.Count do
      begin
         ws := Copy(pmHeaders.Items[j].Name, 3, Length(pmHeaders.Items[j].Name) - 2) + 'ColumnWidth=';
         if (Pos(ws, wsa[i]) = 1) and (l > Length(ws)) then
         begin
            pmHeaders.Items[j].Tag := Min(Max(StrToIntDef(Trim(Copy(wsa[i], Length(ws) + 1, Min(100, l - Length(ws)))), pmHeaders.Items[j].Tag), 10), MainWidth);
            Break;
         end;
         ws := Copy(pmHeaders.Items[j].Name, 3, Length(pmHeaders.Items[j].Name) - 2) + 'ColumnShow=';
         if (Pos(ws, wsa[i]) = 1) and (l > Length(ws)) then
         begin
            pmHeaders.Items[j].Checked := StrToBoolDef(Trim(Copy(wsa[i], Length(ws) + 1, Min(100, l - Length(ws)))), pmHeaders.Items[j].Checked);
            Break;
         end;
         Inc(j);
      end;
      if j < pmHeaders.Items.Count then
         Continue;
      if (Pos('WaitTimeToFlush=', wsa[i]) = 1) and (l > 16) then
      begin
         FlushWaitTime := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 17, Min(100, l - 16))), 500), 0), 20000);
         Continue;
      end;
      if (Pos('LockTheVolumes=', wsa[i]) = 1) and (l > 15) then
      begin
         LockVolumes := StrToBoolDef(Trim(Copy(wsa[i], 16, Min(100, l - 15))), LockVolumes);
         Continue;
      end;
      if (Pos('ShowSecondDriveOption=', wsa[i]) = 1) and (l > 22) then
      begin
         AddSecondDrive := StrToBoolDef(Trim(Copy(wsa[i], 23, Min(100, l - 22))), AddSecondDrive);
         Continue;
      end;
      if (Pos('BackupOldEntries=', wsa[i]) = 1) and (l > 17) then
      begin
         BackupOldEntries := StrToBoolDef(Trim(Copy(wsa[i], 18, Min(100, l - 17))), BackupOldEntries);
         Continue;
      end;
      if (Pos('DontWarn=', wsa[i]) = 1) and (l > 9) then
      begin
         DontWarn := StrToBoolDef(Trim(Copy(wsa[i], 10, Min(100, l - 9))), DontWarn);
         Continue;
      end;
      if (Pos('DefaultVMType=', wsa[i]) = 1) and (l > 14) then
      begin
         if Trim(Copy(wsa[i], 15, Min(100, l - 14))) = 'QEMU' then
            DefaultVMType := 1;
         Continue;
      end;
      if (Pos('ListOnlyUSBDrives=', wsa[i]) = 1) and (l > 18) then
      begin
         ListOnlyUSBDrives := StrToBoolDef(Trim(Copy(wsa[i], 19, Min(100, l - 18))), ListOnlyUSBDrives);
         Continue;
      end;
      if (Pos('AutomaticFont=', wsa[i]) = 1) and (l > 14) then
      begin
         AutomaticFont := StrToBoolDef(Trim(Copy(wsa[i], 15, Min(100, l - 14))), AutomaticFont);
         Continue;
      end;
      if (Pos('FontName=', wsa[i]) = 1) and (l > 9) then
      begin
         FontName := Trim(Copy(wsa[i], 10, Min(100, l - 9)));
         if Screen.Fonts.IndexOf(FontName) = -1 then
            FontName := lvVMs.Font.Name;
         Continue;
      end;
      if (Pos('FontSize=', wsa[i]) = 1) and (l > 9) then
      begin
         FontSize := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 10, Min(100, l - 9))), FontSize), 0), 256);
         Continue;
      end;
      if (Pos('FontBold=', wsa[i]) = 1) and (l > 9) then
      begin
         FontBold := StrToBoolDef(Trim(Copy(wsa[i], 10, Min(100, l - 9))), FontBold);
         Continue;
      end;
      if (Pos('FontItalic=', wsa[i]) = 1) and (l > 11) then
      begin
         FontItalic := StrToBoolDef(Trim(Copy(wsa[i], 12, Min(100, l - 11))), FontItalic);
         Continue;
      end;
      if (Pos('FontUnderline=', wsa[i]) = 1) and (l > 14) then
      begin
         FontUnderline := StrToBoolDef(Trim(Copy(wsa[i], 15, Min(100, l - 14))), FontUnderline);
         Continue;
      end;
      if (Pos('FontStrikeOut=', wsa[i]) = 1) and (l > 14) then
      begin
         FontStrikeOut := StrToBoolDef(Trim(Copy(wsa[i], 15, Min(100, l - 14))), FontStrikeOut);
         Continue;
      end;
      if (Pos('FontColor=', wsa[i]) = 1) and (l > 10) then
      begin
         FontColor := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 11, Min(100, l - 10))), FontColor), Low(TColor)), High(TColor));
         Continue;
      end;
      if (Pos('FontScript=', wsa[i]) = 1) and (l > 11) then
      begin
         FontScript := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 12, Min(100, l - 11))), FontScript), 0), 255);
         Continue;
      end;
      if (Pos('EscapeKeyClosesMain=', wsa[i]) = 1) and (l > 20) then
      begin
         EscapeKeyClosesMain := StrToBoolDef(Trim(Copy(wsa[i], 21, Min(100, l - 20))), EscapeKeyClosesMain);
         Continue;
      end;
      if (Pos('CurrLanguageFile=', wsa[i]) = 1) and (l > 17) then
      begin
         wst := Trim(Copy(wsa[i], 18, Min(2048, l - 17)));
         if Length(wst) <= 64 then
            CurrLanguageFile := wst
         else
            CurrLanguageFile := Copy(wst, 1, 64);
         Continue;
      end;
      if (Pos('VirtualBoxPath=', wsa[i]) = 1) and (l > 15) then
      begin
         wst := Trim(Copy(wsa[i], 16, Min(2048, l - 15)));
         if Length(wst) <= 512 then
            ExeVBPath := wst
         else
            ExeVBPath := Copy(wst, 1, 512);
         Continue;
      end;
      if (Pos('MethodToUpdateTheVM=', wsa[i]) = 1) and (l > 20) then
      begin
         wst := Trim(Copy(wsa[i], 21, Min(1024, l - 20)));
         if wst = 'Use VBoxManage.exe command line (slower)' then
            UpdateVM := 1
         else if wst = 'Directly (faster, but VB Manager must be closed)' then
            UpdateVM := 2
         else if wst = 'Autodetect' then
            UpdateVM := 0
         else
            UpdateVM := 0;
         Continue;
      end;
      if (Pos('ShowCPUVirtualizationOption=', wsa[i]) = 1) and (l > 28) then
      begin
         ShowVBCPUVirtualizationOption := StrToBoolDef(Trim(Copy(wsa[i], 29, Min(100, l - 28))), ShowVBCPUVirtualizationOption);
         Continue;
      end;
      if (Pos('RemoveDriveAfterClosing=', wsa[i]) = 1) and (l > 24) then
      begin
         RemoveDrive := StrToBoolDef(Trim(Copy(wsa[i], 25, Min(100, l - 24))), RemoveDrive);
         Continue;
      end;
      if (Pos('QemuPath=', wsa[i]) = 1) and (l > 9) then
      begin
         wst := Trim(Copy(wsa[i], 10, Min(2048, l - 9)));
         if Length(wst) <= 512 then
            ExeQPath := wst
         else
            ExeQPath := Copy(wst, 1, 512);
         Continue;
      end;
      if (Pos('QemuDefaultParameters=', wsa[i]) = 1) and (l > 22) then
      begin
         wst := Trim(Copy(wsa[i], 23, Min(20480, l - 22)));
         if Length(wst) <= 10240 then
            QEMUDefaultParameters := wst
         else
            QEMUDefaultParameters := Copy(wst, 1, 10240);
         Continue;
      end;
      if (Pos('LastSelected=', wsa[i]) = 1) and (l > 13) then
         LastSelected := Min(Max(StrToIntDef(Trim(Copy(wsa[i], 14, Min(10, l - 13))), 0), -1), 65535);
   end;
end;

procedure TfrmMain.SaveCFG(const FileName: WideString);
var
   i, l: Integer;
   t: TTNTFileStream;
   ws, wsVMUpdate: WideString;
   BaseFolder: WideString;
   h: array of Integer;
   sDefaultVMType: AnsiString;
begin
   ws := #65279;
   if WindowState <> wsNormal then
      ws := ws + 'Width=' + IntToStr(IntWidth) + #13#10'Height=' + IntToStr(IntHeight) + #13#10'Left=' + IntToStr(Round(10000.0 * (IntLeft - Screen.WorkAreaLeft) / Screen.WorkAreaWidth)) + #13#10'Top=' + IntToStr(Round(10000.0 * (IntTop - Screen.WorkAreaTop) / Screen.WorkAreaHeight))
   else
      ws := ws + 'Width=' + IntToStr(Width) + #13#10'Height=' + IntToStr(Height) + #13#10'Left=' + IntToStr(Round(10000.0 * (Left - Screen.WorkAreaLeft) / Screen.WorkAreaWidth)) + #13#10'Top=' + IntToStr(Round(10000.0 * (Top - Screen.WorkAreaTop) / Screen.WorkAreaHeight));
   ws := ws + #13#10'Maximized=' + IntToStr(Integer((WindowState = wsMaximized) and SaveMaximized));
   SetLength(h, pmHeaders.Items.Count);
   for i := 0 to pmHeaders.Items.Count - 1 do
      h[i] := pmHeaders.Items[i].Tag;
   for i := 1 to lvVMs.Columns.Count - 1 do
      try
         h[lvVMs.Columns[i].Tag] := lvVMs.Columns[i].Width;
      except
      end;
   ws := ws + #13#10'#ColumnWidth=' + IntToStr(h[0]) + #13#10'#ColumnShow=' + IntToStr(Integer(mmCrt.Checked));
   for i := 1 to pmHeaders.Items.Count - 1 do
      ws := ws + #13#10 + Copy(pmHeaders.Items[i].Name, 3, Length(pmHeaders.Items[i].Name) - 2) + 'ColumnWidth=' + IntToStr(h[i]) + #13#10 + Copy(pmHeaders.Items[i].Name, 3, Length(pmHeaders.Items[i].Name) - 2) + 'ColumnShow=' + IntToStr(Integer(pmHeaders.Items[i].Checked));
   case UpdateVM of
      1: wsVMUpdate := 'Use VBoxManage.exe command line (slower)';
      2: wsVMUpdate := 'Directly (faster, but VB Manager must be closed)';
   else
      wsVMUpdate := 'Autodetect';
   end;
   if DefaultVMType = 0 then
      sDefaultVMType := 'VirtualBox'
   else
      sDefaultVMType := 'QEMU';
   ws := ws + #13#10'WaitTimeToFlush=' + IntToStr(FlushWaitTime) + #13#10'LockTheVolumes=' + IntToStr(Integer(LockVolumes)) + #13#10'ShowSecondDriveOption=' + IntToStr(Integer(AddSecondDrive)) + #13#10'BackupOldEntries=' + IntToStr(Integer(BackupOldEntries)) + #13#10'DontWarn=' + IntToStr(Integer(DontWarn)) + #13#10'DefaultVMType=' + sDefaultVMType + #13#10'ListOnlyUSBDrives=' + IntToStr(Integer(ListOnlyUSBDrives)) +
      #13#10'AutomaticFont=' + IntToStr(Integer(AutomaticFont)) + #13#10'FontName=' + FontName + #13#10'FontSize=' + IntToStr(FontSize) + #13#10'FontBold=' + IntToStr(Integer(FontBold)) + #13#10'FontItalic=' + IntToStr(Integer(FontItalic)) + #13#10'FontUnderline=' + IntToStr(Integer(FontUnderline)) + #13#10'FontStrikeOut=' + IntToStr(Integer(FontStrikeOut)) + #13#10'FontColor=' + IntToStr(Integer(FontColor)) + #13#10'FontScript=' + IntToStr(Integer(FontScript)) + #13#10'EscapeKeyClosesMain=' + IntToStr(Integer(EscapeKeyClosesMain)) +
      #13#10'CurrLanguageFile=' + CurrLanguageFile +
      #13#10'VirtualBoxPath=' + ExeVBPath + #13#10'MethodToUpdateTheVM=' + wsVMUpdate + #13#10'ShowCPUVirtualizationOption=' + IntToStr(Integer(ShowVBCPUVirtualizationOption)) + #13#10'RemoveDriveAfterClosing=' + IntToStr(Integer(RemoveDrive)) + #13#10'QemuPath=' + ExeQPath + #13#10'QemuDefaultParameters=' + QemuDefaultParameters + #13#10'LastSelected=' + IntToStr(lvVMs.ItemIndex) + #13#10'DriveMessageShowed=' + IntToStr(Integer(DriveMessageShowed)) + #13#10'StartMessageShowed=' + IntToStr(Integer(StartMessageShowed));
   if isInstalledVersion then
   begin
      try
         BaseFolder := WideExtractFilePath(FileName);
         if not WideDirectoryExists(BaseFolder) then
            WideForceDirectories(BaseFolder);
      except
      end;
      if not WideDirectoryExists(BaseFolder) then
      begin
         if not DontWarn then
         begin
            msgBoxCaption := GetLangTextDef(idxMessagesType, ['Error'], 'Error');
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            MessageBoxW(Handle,
               PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CantCreate'], [BaseFolder], 'Could not create "%s" !')),
               PWideChar(msgBoxCaption), MB_OK or MB_ICONERROR);
         end;
         Exit;
      end;
   end;
   if ws = psCFG then
      Exit;
   try
      t := TTNTFileStream.Create(FileName, fmCreate or fmShareDenyWrite);
   except
      on E: Exception do
      begin
         if not DontWarn then
         begin
            msgBoxCaption := GetLangTextDef(idxMessagesType, ['Error'], 'Error');
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            MessageBoxW(Handle,
               PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CantCreateOrOpen'], [FileName, E.Message], 'Could not create or open "%s" for writing !'#13#10#13#10'System message: %s')),
               PWideChar(msgBoxCaption), MB_OK or MB_ICONERROR);
         end;
         Exit;
      end;
   end;
   try
      l := Length(ws);
      t.Size := 2 * l;
      t.Position := 0;
      t.WriteBuffer(Pointer(ws)^, 2 * l);
      psCFG := ws;
   except
      on E: Exception do
         if not DontWarn then
         begin
            msgBoxCaption := GetLangTextDef(idxMessagesType, ['Error'], 'Error');
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            MessageBoxW(Handle,
               PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CantWrite'], [FileName, E.Message], 'Could not write into "%s" !'#13#10#13#10'System message: %s')),
               PWideChar(msgBoxCaption), MB_OK or MB_ICONERROR);
         end;
   end;
   try
      t.Free;
   except
   end;
end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
   Close;
   btnExit.Down := False;
end;

procedure TfrmMain.btnAddClick(Sender: TObject);
var
   i, p, cp, l, n1, n2, n3, a: Integer;
   H: Cardinal;
   strTemp: AnsiString;
   ws, wst, FolderName: WideString;
begin
   btnAdd.Down := True;
   try
      try
         with frmAddEdit do
         begin
            if frmAddEdit = nil then
               Application.CreateForm(TfrmAddEdit, frmAddEdit)
            else
            begin
               cmbMode.ItemIndex := 0;
               if sbVirtualBox.Down then
                  cmbModeChange(cmbMode)
               else
                  sbVirtualBox.Click;
               edtExeParams.Text := '';
               cmbVMName.ItemIndex := 0;
               edtVMPath.Text := '';
               cmbFirstDrive.ItemIndex := 0;
               cmbSecondDrive.ItemIndex := 0;
               cmbEnableCPUVirtualization.ItemIndex := 0;
               edtHDD.Text := '';
               edtMemory.Text := '512';
               cmbAudio.ItemIndex := 1;
               cmbWS.ItemIndex := 0;
               cmbPriority.ItemIndex := 1;
            end;
            Caption := GetLangTextDef(idxAddEdit, ['Caption', 'Add'], 'Add');
            isEdit := False;
            edtName.Text := 'USB Boot test';
            if DefaultVMType = 1 then
               sbQEMU.Click;
            Left := frmMain.Left + ((frmMain.Width - Width) div 2);
            if Left < Screen.WorkAreaLeft then
               Left := Screen.WorkAreaLeft
            else if Left + Width > Screen.WorkAreaRect.Right then
               Left := Screen.WorkAreaRect.Right - Width;

            Top := frmMain.Top + ((frmMain.Height - Height) div 2);
            if Top < Screen.WorkAreaTop then
               Top := Screen.WorkAreaTop
            else if Top + Height > Screen.WorkAreaRect.Bottom then
               Top := Screen.WorkAreaRect.Bottom - Height;
            if ShowModal = mrOK then
            begin
               SetLength(VMentries, Length(VMentries) + 1);
               with VMentries[High(VMentries)] do
               begin
                  Name := Trim(edtName.Text);
                  Ptype := Byte(not sbVirtualBox.Down);
                  if sbVirtualBox.Down then
                  begin
                     ModeLoadVM := cmbMode.ItemIndex;

                     case ModeLoadVM of
                        0:
                           begin
                              VMName := VMIDs[cmbVMName.ItemIndex - 1].Name;
                              VMID := VMIDs[cmbVMName.ItemIndex - 1].ID;
                              FolderName := '';
                              with frmMain.xmlGen do
                              begin
                                 if Tag = 1 then
                                    try
                                       Active := True;
                                       n1 := ChildNodes.IndexOf('VirtualBox');
                                       if n1 > -1 then
                                       begin
                                          n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                          if n2 > -1 then
                                          begin
                                             n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                             if n3 > -1 then
                                             begin
                                                a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                                if a > -1 then
                                                begin
                                                   FolderName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                                                   l := Length(FolderName);
                                                   Replacebks(FolderName, l);
                                                end;
                                             end;
                                          end;
                                       end;
                                    except
                                    end;
                                 Active := False;
                              end;

                              if WideDirectoryExists(FolderName) then
                                 VMPath := FolderName + '\' + VMName + '\' + VMName + '.vbox'
                              else
                                 VMPath := '';
                           end;
                        1:
                           begin
                              VMPath := Trim(edtVMPath.Text);
                              VMName := WideChangeFileExt(WideExtractFileName(VMPath), '');
                              i := 0;
                              while i <= High(VMIDs) do
                              begin
                                 if VMIDs[i].Name = VMName then
                                    Break;
                                 Inc(i);
                              end;
                              VMID := VMIDs[i].ID;
                           end;
                        2:
                           begin
                              ws := Trim(edtExeParams.Text);
                              p := Pos('--startvm "', ws);
                              l := Length(ws);
                              if (p > 0) and ((p + 11) < l) then
                              begin
                                 cp := PosEx('"', ws, p + 11);
                                 if cp > 0 then
                                    ws := Trim(Copy(ws, p + 11, cp - p - 11))
                                 else
                                    ws := '';
                              end
                              else
                                 ws := '';
                              if WideFileExists(ws) then
                              begin
                                 wst := WideChangeFileExt(WideExtractFileName(ws), '');
                                 GetNamesAndIDs;
                                 i := 0;
                                 while i <= High(VMIDs) do
                                 begin
                                    if VMIDs[i].Name = wst then
                                       Break;
                                    Inc(i);
                                 end;
                                 if i <= High(VMIDs) then
                                 begin
                                    VMName := VMIDs[i].Name;
                                    VMID := VMIDs[i].ID;
                                    VMPath := ws;
                                 end;
                              end
                              else
                              begin
                                 wst := '';
                                 with frmMain.xmlGen do
                                 begin
                                    if Tag = 1 then
                                       try
                                          Active := True;
                                          n1 := ChildNodes.IndexOf('VirtualBox');
                                          if n1 > -1 then
                                          begin
                                             n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                             if n2 > -1 then
                                             begin
                                                n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                                if n3 > -1 then
                                                begin
                                                   a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                                   if a > -1 then
                                                   begin
                                                      wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                                                      Replacebks(wst, Length(wst));
                                                   end;
                                                end;
                                             end;
                                          end;
                                       except
                                       end;
                                    Active := False;
                                 end;

                                 if (WideExtractFileName(ws) = ws) and (WideExtractFileExt(ws) <> '') and WideFileExists(wst + '\' + WideChangeFileExt(ws, '') + '\' + ws) then
                                 begin
                                    VMPath := wst + '\' + WideChangeFileExt(ws, '') + '\' + ws;
                                    wst := WideChangeFileExt(WideExtractFileName(ws), '');
                                    GetNamesAndIDs;
                                    i := 0;
                                    while i <= High(VMIDs) do
                                    begin
                                       if VMIDs[i].Name = wst then
                                          Break;
                                       Inc(i);
                                    end;
                                    if i <= High(VMIDs) then
                                    begin
                                       VMName := VMIDs[i].Name;
                                       VMID := VMIDs[i].ID;
                                    end
                                    else
                                    begin
                                       VMName := '';
                                       VMID := '';
                                       VMPath := '';
                                    end;
                                 end
                                 else if (WideExtractFileName(ws) = ws) and (WideExtractFileExt(ws) = '') and WideFileExists(wst + '\' + ws + '\' + ws + '.vbox') then
                                 begin
                                    VMPath := wst + '\' + ws + '\' + ws + '.vbox';
                                    wst := WideChangeFileExt(WideExtractFileName(ws), '');
                                    GetNamesAndIDs;
                                    i := 0;
                                    while i <= High(VMIDs) do
                                    begin
                                       if VMIDs[i].Name = wst then
                                          Break;
                                       Inc(i);
                                    end;
                                    if i <= High(VMIDs) then
                                    begin
                                       VMName := VMIDs[i].Name;
                                       VMID := VMIDs[i].ID;
                                    end
                                    else
                                    begin
                                       VMName := '';
                                       VMPath := '';
                                       VMID := '';
                                    end;
                                 end
                                 else if isGUID(ws) then
                                 begin
                                    i := 0;
                                    while i <= High(VMIDs) do
                                    begin
                                       if VMIDs[i].ID = ws then
                                          Break;
                                       Inc(i);
                                    end;
                                    if i <= High(VMIDs) then
                                    begin
                                       VMName := VMIDs[i].Name;
                                       VMID := VMIDs[i].ID;
                                       FolderName := '';
                                       with frmMain.xmlGen do
                                       begin
                                          if Tag = 1 then
                                             try
                                                Active := True;
                                                n1 := ChildNodes.IndexOf('VirtualBox');
                                                if n1 > -1 then
                                                begin
                                                   n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                                   if n2 > -1 then
                                                   begin
                                                      n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                                      if n3 > -1 then
                                                      begin
                                                         a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                                         if a > -1 then
                                                         begin
                                                            FolderName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                                                            l := Length(FolderName);
                                                            Replacebks(FolderName, l);
                                                         end;
                                                      end;
                                                   end;
                                                end;
                                             except
                                             end;
                                          Active := False;
                                       end;

                                       if WideDirectoryExists(FolderName) then
                                          VMPath := FolderName + '\' + VMName + '\' + VMName + '.vbox'
                                       else
                                          VMPath := '';
                                    end;
                                 end;
                              end;
                           end;
                     end;

                  end
                  else
                  begin
                     ModeLoadVM := 2;
                     VMID := '';
                     VMPath := '';
                     ws := Trim(edtExeParams.Text);
                     p := Pos('-name "', ws);
                     l := Length(ws);
                     if (p > 0) and ((p + 7) < l) then
                     begin
                        cp := PosEx('"', ws, p + 7);
                        if cp > 0 then
                           ws := Trim(Copy(ws, p + 7, cp - p - 7))
                        else
                           ws := '';
                     end
                     else
                        ws := '';
                     VMName := ws;
                  end;
                  ExeParams := Trim(edtExeParams.Text);
                  FirstDriveFound := True;
                  if cmbFirstDrive.ItemIndex > 0 then
                  begin
                     strTemp := AnsiString(cmbFirstDrive.Text);
                     i := Pos(',  [', strTemp);
                     if i = 0 then
                        FirstDriveName := strTemp
                     else
                        FirstDriveName := Copy(strTemp, 1, i - 1);
                  end
                  else
                     FirstDriveName := '';
                  l := Length(FirstDriveName);
                  if l > 0 then
                  begin
                     H := 2166136261;
                     for i := 1 to l do
                        H := (H xor Byte(FirstDriveName[i])) * 16777619;
                     H := H and 255;
                     SetLength(FHash[H], Length(FHash[H]) + 1);
                     FHash[H][High(FHash[H])][1] := 1;
                     FHash[H][High(FHash[H])][2] := High(VMentries);
                  end;
                  if AddSecondDrive then
                  begin
                     if cmbSecondDrive.ItemIndex > 0 then
                     begin
                        strTemp := AnsiString(cmbSecondDrive.Text);
                        i := Pos(',  [', strTemp);
                        if i = 0 then
                           SecondDriveName := strTemp
                        else
                           SecondDriveName := Copy(strTemp, 1, i - 1);
                     end
                     else
                        SecondDriveName := '';
                     SecondDriveFound := True;
                     l := Length(SecondDriveName);
                     if l > 0 then
                     begin
                        H := 2166136261;
                        for i := 1 to l do
                           H := (H xor Byte(SecondDriveName[i])) * 16777619;
                        H := H and 255;
                        SetLength(FHash[H], Length(FHash[H]) + 1);
                        FHash[H][High(FHash[H])][1] := 2;
                        FHash[H][High(FHash[H])][2] := High(VMentries);
                     end;
                  end;
                  InternalHDD := Trim(edtHDD.Text);
                  if cmbCDROM.ItemIndex = 0 then
                  begin
                     CDROMName := '';
                     CDROMType := 0;
                  end
                  else if CDDVDType = 0 then
                  begin
                     CDROMName := Copy(cmbCDROM.Text, 1, Length(cmbCDROM.Text) - 6);
                     CDROMType := 0;
                  end
                  else
                  begin
                     CDROMName := TMyObj(cmbCDROM.Items.Objects[cmbCDROM.Items.Count - 1]).Text;
                     CDROMType := 1;
                  end;
                  Memory := Min(Max(StrToIntDef(edtMemory.Text, 512), 1), 65535);
                  Audio := cmbAudio.ItemIndex;
                  Run := cmbWS.ItemIndex;
                  VBCPUVirtualization := cmbEnableCPUVirtualization.ItemIndex;
                  Priority := cmbPriority.ItemIndex;
                  luIDS.fdCID := '';
                  luIDS.fdGUID := '';
                  luIDS.sdCID := '';
                  luIDS.sdGUID := '';
                  lvVMS.Items.BeginUpdate;
                  with lvVMs.Items.Add do
                  begin
                     ImageIndex := Ptype;
                     with SubItems do
                        for i := 1 to lvVMS.Columns.Count - 1 do
                           case lvVMS.Columns[i].Tag of
                              0: Add(IntToStr(lvVMS.Items.Count));
                              1: Add(Name);
                              2: Add(VMName);
                              3:
                                 begin
                                    Add(FirstDriveName);
                                    SubItemImages[i - 1] := 4;
                                 end;
                              4:
                                 begin
                                    Add(SecondDriveName);
                                    if SecondDriveName <> '' then
                                       SubItemImages[i - 1] := 4
                                    else
                                       SubItemImages[i - 1] := -1;
                                 end;
                           end;
                  end;
                  lvVMS.Items.EndUpdate;
                  lvVMS.ItemIndex := lvVMS.Items.Count - 1;
                  lvVMS.Items[lvVMS.Items.Count - 1].Selected := True;
                  lvVMS.Items[lvVMS.Items.Count - 1].Focused := True;
                  lvVMs.Items[lvVMS.ItemIndex].MakeVisible(False);
                  lvVMS.SetFocus;
               end;

               SaveVMentries(VMentriesFile);
               SaveCfg(CfgFile);
            end;
         end;
      finally
         frmAddEdit.Free;
         frmAddEdit := nil;
      end;
   except
   end;
   btnAdd.Down := False;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
   i, j, l, lv, BufferLen: Integer;
   H: Cardinal;
   ws: WideString;
   c: Char;
   hVolume, hDll: THandle;
   dwBytesReturned: DWORD;
   sdn: STORAGE_DEVICE_NUMBER;
   ErrorMode: Word;
   SysMenu: HMenu;
   envProgramFiles, Buffer: WideString;
begin
   Application.OnException := AppException;
   DragAcceptFiles(Handle, True);
   DoubleBuffered := True;
   lvVMs.DoubleBuffered := True;
   lvVMS.Canvas.Font.Assign(lvVms.Font);
   Application.Title := Application.Title + appVersion;
   Caption := Application.Title;
   fOldTWndMethod := WindowProc;
   WindowProc := WindProc;

   envProgramFiles := GetEnvVarValue('ProgramFiles');
   if envProgramFiles = '' then
      envProgramFiles := 'c:\Program Files';

   ExeVBPath := GetEnvVarValue('VBOX_MSI_INSTALL_PATH');
   if ExeVBPath = '' then
      ExeVBPath := GetEnvVarValue('VBOX_INSTALL_PATH');
   if ExeVBPath = '' then
      ExeVBPath := envProgramFiles + '\Oracle\VirtualBox\';
   ExeVBPath := ExeVBPath + 'VirtualBox.exe';
   if not WideFileExists(ExeVBPath) then
      ExeVBPath := '';

   ExeQPath := GetEnvVarValue('QEMU_INSTALL_PATH');
   if ExeQPath <> '' then
      if not WideDirectoryExists(ExeQPath) then
         ExeQPath := '';
   if ExeQPath = '' then
      if WideDirectoryExists(envProgramFiles + '\qemu\') then
         ExeQPath := envProgramFiles + '\QEMU\'
      else if WideDirectoryExists(envProgramFiles + ' (x86)\qemu\') then
         ExeQPath := envProgramFiles + ' (x86)\qemu\';
   if ExeQPath <> '' then
   begin
      if WideFileExists(ExeQPath + 'qemu.exe') then
         ExeQPath := ExeQPath + 'qemu.exe'
      else if WideFileExists(ExeQPath + 'qemu-system-i386.exe') then
         ExeQPath := ExeQPath + 'qemu-system-i386.exe'
      else if WideFileExists(ExeQPath + 'qemu-system-i386w.exe') then
         ExeQPath := ExeQPath + 'qemu-system-i386w.exe'
      else if WideFileExists(ExeQPath + 'qemu-system-x86_64.exe') then
         ExeQPath := ExeQPath + 'qemu-system-x86_64.exe'
      else if WideFileExists(ExeQPath + 'qemu-system-x86_64w.exe') then
         ExeQPath := ExeQPath + 'qemu-system-x86_64w.exe'
      else
         ExeQPath := '';
   end;

   OSDrive := 0;
   ws := GetEnvVarValue('SystemDrive');
   ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
   try
      if ws <> '' then
      begin
         c := Char(ws[1]);
         if (c >= 'A') and (c <= 'Z') then
         begin
            try
               hVolume := CreateFile(PAnsiChar('\\.\' + c + ':'), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
            except
               hVolume := INVALID_HANDLE_VALUE;
            end;
            if hVolume <> INVALID_HANDLE_VALUE then
            begin
               dwBytesReturned := 0;
               try
                  if DeviceIoControl(hVolume, IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0, @sdn, sizeof(sdn), dwBytesReturned, nil) then
                     OSDrive := sdn.DeviceNumber;
               except
               end;
               try
                  CloseHandle(hVolume);
               except
               end;
            end
         end;
      end;
   finally
      SetErrorMode(ErrorMode);
   end;
   MainLeft := (Screen.WorkAreaWidth - Width) div 2 + Screen.WorkAreaLeft;
   MainTop := (Screen.WorkAreaHeight - Height) div 2 + Screen.WorkAreaTop;
   MainWidth := Width;
   MainHeight := Height;
   MainMaximized := WindowState = wsMaximized;
   mmCrt.Tag := lvVms.Canvas.TextWidth(IntToStr(Length(VMentries))) + 2 * lvVms.Canvas.TextWidth('0');
   with lvVMS.Font do
   begin
      FontName := Name;
      FontSize := Size;
      FontBold := fsBold in Style;
      FontItalic := fsBold in Style;
      FontUnderline := fsUnderline in Style;
      FontStrikeOut := fsStrikeOut in Style;
      FontColor := Color;
      FontScript := Charset;
      DefaultFontName := Name;
      DefaultFontSize := Size;
      DefaultFontBold := fsBold in Style;
      DefaultFontItalic := fsBold in Style;
      DefaultFontUnderline := fsUnderline in Style;
      DefaultFontStrikeOut := fsStrikeOut in Style;
      DefaultFontColor := Color;
      DefaultFontScript := Charset;
   end;
   CFGFoundAndLoaded := WideFileExists(CfgFile) and LoadCfg(CfgFile);
   if CFGFoundAndLoaded and (not AutomaticFont) then
      with lvVMs.Font do
      begin
         lvVMs.Items.BeginUpdate;
         Name := FontName;
         Size := FontSize;
         Style := [];
         if FontBold then
            Style := Style + [fsBold];
         if FontItalic then
            Style := Style + [fsItalic];
         if FontUnderline then
            Style := Style + [fsUnderline];
         if FontStrikeOut then
            Style := Style + [fsStrikeOut];
         Color := FontColor;
         Charset := FontScript;
         lvVMs.Items.EndUpdate;
      end;
   ChangeCompLang;
   if Application.Terminated then
   begin
      OnDestroy := nil;
      Exit;
   end;
   lvVMS.Height := ClientHeight - 2 * lvVMS.Top;
   btnStart.Top := lvVMS.Top;
   btnExit.Top := lvVMS.Top + lvVMS.Height - btnExit.Height;
   Constraints.MinHeight := 2 * lvVMs.Top + 6 * btnStart.Height + Height - ClientHeight;
   SetLength(VMentries, 0);
   if WideFileExists(VMentriesFile) then
   begin
      LoadVMEntries(VMentriesFile);
      lv := Length(VMentries);
      if lv > 0 then
      begin
         for i := 0 to lv - 1 do
         begin
            VMEntries[i].FirstDriveFound := False;
            VMEntries[i].SecondDriveFound := False;
            l := Length(vmEntries[i].FirstDriveName);
            if l <> 0 then
            begin
               H := 2166136261;
               for j := 1 to l do
                  H := (H xor Byte(vmEntries[i].FirstDriveName[j])) * 16777619;
               H := H and 255;
               SetLength(FHash[H], Length(FHash[H]) + 1);
               FHash[H][High(FHash[h])][1] := 1;
               FHash[H][High(FHash[h])][2] := i;
            end;
            if AddSecondDrive then
            begin
               l := Length(vmEntries[i].SecondDriveName);
               if l = 0 then
                  Continue;
               H := 2166136261;
               for j := 1 to l do
                  H := (H xor Byte(vmEntries[i].SecondDriveName[j])) * 16777619;
               H := H and 255;
               SetLength(FHash[H], Length(FHash[H]) + 1);
               FHash[H][High(FHash[h])][1] := 2;
               FHash[H][High(FHash[h])][2] := i;
            end;
         end;
         LastSelected := Min(LastSelected, High(VMentries));
         FindDrives;
         lvVMS.Items.BeginUpdate;
         for i := 0 to High(VMentries) do
         begin
            with lvVMS.Items.Add do
            begin
               ImageIndex := VMentries[i].Ptype;
               j := 1;
               while j < lvVms.Columns.Count do
               begin
                  case lvVms.Columns[j].Tag of
                     0:
                        begin
                           if (Length(VMentries) < 10) or (i > 10) then
                              SubItems.Add(IntToStr(i + 1))
                           else
                              SubItems.Add('0' + IntToStr(i + 1));
                        end;
                     1: SubItems.Add(VMentries[i].Name);
                     2: SubItems.Add(VMentries[i].VMName);
                     3:
                        begin
                           SubItems.Add(vmEntries[i].FirstDriveName);
                           if vmEntries[i].FirstDriveName = '' then
                              SubItemImages[3] := -1
                           else if vmEntries[i].FirstDriveFound then
                              SubItemImages[3] := 4
                           else
                              SubItemImages[3] := 5;
                        end;
                     4:
                        begin
                           SubItems.Add(vmEntries[i].SecondDriveName);
                           if vmEntries[i].SecondDriveName = '' then
                              SubItemImages[4] := -1
                           else if vmEntries[i].SecondDriveFound then
                              SubItemImages[4] := 4
                           else
                              SubItemImages[4] := 5;
                        end;
                  end;
                  Inc(j);
               end;
            end;
         end;
         lvVMS.Items.EndUpdate;
         lvVMS.ItemIndex := LastSelected;
         if LastSelected > -1 then
         begin
            lvVms.Items[LastSelected].Selected := True;
            lvVms.Items[LastSelected].Focused := True;
            lvVMs.Items[LastSelected].MakeVisible(False);
         end;
      end
      else
         LastSelected := -1;
   end
   else
      LastSelected := -1;
   ws := GetEnvVarValue('USERPROFILE');
   if ws <> '' then
   begin
      ws := ws + '\.VirtualBox\VirtualBox.xml';
      if WideFileExists(ws) then
         try
            xmlGen.LoadFromFile(ws);
         except
            xmlGen.Active := False;
         end;
      xmlGen.Tag := Integer(xmlGen.Active);
      xmlGen.Active := False;
   end;
   try
      SysMenu := GetSystemMenu(Handle, False);
      AppendMenu(SysMenu, MF_SEPARATOR, 0, '');
      AppendMenu(SysMenu, MF_STRING, WM_USER + 1, 'Designed by DavidB');
      AppendMenu(SysMenu, MF_STRING, WM_USER + 2, 'Testing and ideas: steve6375');
      AppendMenu(SysMenu, MF_SEPARATOR, 0, '');
      AppendMenu(SysMenu, MF_STRING, WM_USER + 3, 'Latest version and news');
      AppendMenu(SysMenu, MF_STRING, WM_USER + 4, 'Support forum');
   except
   end;
   VBVMWasClosed := Now - 1;
   DriveDetect := TComponentDrive.Create(frmMain);
   try
      hDll := LoadLibrary('User32.dll');
      if hDLL <> 0 then
      begin
         try
            SetLength(Buffer, 255);
            BufferLen := LoadStringW(hdll, 800, PWideChar(Buffer), Length(Buffer));
            if BufferLen <> 0 then
               OKCaption := Tnt_WideStringReplace(Copy(Buffer, 1, BufferLen), '&', '', [rfReplaceAll, rfIgnoreCase]);
         finally
            FreeLibrary(hDll);
         end;
      end;
   except
   end;
end;

procedure TfrmMain.ChangeCompLang;
var
   i, lv, abl: Integer;
   RS: TResourceStream;
   tms: TMemoryStream;

   function areDifferent(const FirstXMLnode, SecondXMLnode: IXMLNode): Boolean;
   var
      i: Integer;
   begin
      Result := False;
      try
         if FirstXMLnode.LocalName <> SecondXMLnode.LocalName then
         begin
            Result := True;
            Exit;
         end;
         if FirstXMLnode.ChildNodes.Count <> SecondXMLnode.ChildNodes.Count then
         begin
            Result := True;
            Exit;
         end;
         for i := 0 to FirstXMLnode.ChildNodes.Count - 1 do
            if areDifferent(FirstXMLnode.ChildNodes[i], SecondXMLnode.ChildNodes[i]) then
            begin
               Result := True;
               Exit;
            end;
      except
         Result := True;
      end;
   end;

begin
   if CurrLanguageFile = 'ENGLISH' then
   begin
      RS := nil;
      try
         RS := TResourceStream.Create(0, 'ENGLISH', PAnsiChar('Languages'));
         xmlLanguage.LoadFromStream(RS);
      except
      end;
      if RS <> nil then
         try
            RS.Free;
         except
         end;
      if not xmlLanguage.Active then
      begin
         if Showing then
         begin
            Update;
            msgBoxCaption := 'Error';
            PostMessage(Handle, WM_USER + 1024, 0, 0);
         end;
         MessageBox(Handle, 'Corrupt application exe file !'#13#10#13#10'The application will now be terminated...', 'Error', MB_ICONERROR or MB_OK);
         Application.Terminate;
         Exit;
      end;
   end
   else if FileExists(LngFolder + '\' + CurrLanguageFile) then
   begin
      try
         xmlLanguage.LoadFromFile(LngFolder + '\' + CurrLanguageFile);
      except
      end;
      if xmlLanguage.Active then
      begin
         RS := nil;
         try
            RS := TResourceStream.Create(0, 'ENGLISH', PAnsiChar('Languages'));
            xmlVBoxCompare.LoadFromStream(RS);
         except
         end;
         if RS <> nil then
            try
               RS.Free;
            except
            end;
         if not xmlVBoxCompare.Active then
         begin
            if Showing then
            begin
               Update;
               msgBoxCaption := 'Error';
               PostMessage(Handle, WM_USER + 1024, 0, 0);
            end;
            MessageBox(Handle, 'Corrupt application exe file !'#13#10#13#10'The application will now be terminated...', 'Error', MB_ICONERROR or MB_OK);
            Application.Terminate;
            Exit;
         end
         else if areDifferent(xmlLanguage.DocumentElement, xmlVBoxCompare.DocumentElement) then
         begin
            tms := TMemoryStream.Create;
            xmlVBoxCompare.SaveToStream(tms);
            xmlLanguage.LoadFromStream(tms);
            tms.Free;
            CurrLanguageFile := 'ENGLISH';
            if Showing then
            begin
               Update;
               msgBoxCaption := 'Warning';
               PostMessage(Handle, WM_USER + 1024, 0, 0);
            end;
            MessageBox(Handle, 'Corrupt language file !'#13#10#13#10'The default language (english) was loaded...', 'Warning', MB_ICONWARNING or MB_OK);
         end;
         xmlVBoxCompare.Active := False;
      end
      else
      begin
         RS := nil;
         try
            RS := TResourceStream.Create(0, 'ENGLISH', PAnsiChar('Languages'));
            xmlLanguage.LoadFromStream(RS);
         except
         end;
         if RS <> nil then
            try
               RS.Free;
            except
            end;
         if not xmlLanguage.Active then
         begin
            if Showing then
            begin
               Update;
               msgBoxCaption := 'Error';
               PostMessage(Handle, WM_USER + 1024, 0, 0);
            end;
            MessageBox(Handle, 'Corrupt application exe file !'#13#10#13#10'The application will now be terminated...', 'Error', MB_ICONERROR or MB_OK);
            Application.Terminate;
            Exit;
         end
         else
         begin
            CurrLanguageFile := 'ENGLISH';
            if Showing then
            begin
               Update;
               msgBoxCaption := 'Warning';
               PostMessage(Handle, WM_USER + 1024, 0, 0);
            end;
            MessageBox(Handle, 'Corrupt language file !'#13#10#13#10'The default language (english) was loaded...', 'Warning', MB_ICONWARNING or MB_OK);
         end;
      end;
   end
   else
   begin
      if FindResource(hInstance, PAnsiChar(AnsiString(CurrLanguageFile)), PAnsiChar('Languages')) <> 0 then
      begin
         RS := nil;
         try
            RS := TResourceStream.Create(0, CurrLanguageFile, PAnsiChar('Languages'));
            xmlLanguage.LoadFromStream(RS);
         except
         end;
         if RS <> nil then
            try
               RS.Free;
            except
            end;
      end;
      if not xmlLanguage.Active then
      begin
         RS := nil;
         try
            RS := TResourceStream.Create(0, 'ENGLISH', PAnsiChar('Languages'));
            xmlLanguage.LoadFromStream(RS);
         except
         end;
         if RS <> nil then
            try
               RS.Free;
            except
            end;
         if not xmlLanguage.Active then
         begin
            if Showing then
            begin
               Update;
               msgBoxCaption := 'Error';
               PostMessage(Handle, WM_USER + 1024, 0, 0);
            end;
            MessageBox(Handle, 'Corrupt application exe file !'#13#10#13#10'The application will now be terminated...', 'Error', MB_ICONERROR or MB_OK);
            Application.Terminate;
            Exit;
         end
         else
         begin
            CurrLanguageFile := 'ENGLISH';
            if Showing then
            begin
               Update;
               msgBoxCaption := 'Warning';
               PostMessage(Handle, WM_USER + 1024, 0, 0);
            end;
            MessageBox(Handle, 'Corrupt language resource !'#13#10#13#10'The default language (english) was loaded...', 'Warning', MB_ICONWARNING or MB_OK);
         end;
      end;
   end;
   idxInterface := xmlLanguage.ChildNodes.IndexOf('Interface');
   idxLanguage := xmlLanguage.ChildNodes[idxInterface].ChildNodes.IndexOf('Language');
   idxMain := xmlLanguage.ChildNodes[idxInterface].ChildNodes.IndexOf('Main');
   idxAddEdit := xmlLanguage.ChildNodes[idxInterface].ChildNodes.IndexOf('AddEdit');
   idxOptions := xmlLanguage.ChildNodes[idxInterface].ChildNodes.IndexOf('Options');
   idxMessagesType := xmlLanguage.ChildNodes[idxInterface].ChildNodes.IndexOf('MessagesType');
   idxProgress := xmlLanguage.ChildNodes[idxInterface].ChildNodes.IndexOf('Progress');
   idxInfoMess := xmlLanguage.ChildNodes[idxInterface].ChildNodes.IndexOf('InfoMess');
   lv := Min(200, Max(5, StrToIntDef(xmlLanguage.ChildNodes[idxInterface].ChildNodes[idxMain].ChildNodes.FindNode('Buttons').ChildNodes.FindNode('Size').ChildNodes.FindNode('Width').Text, btnStart.Width)));
   if lv <> btnStart.Width then
   begin
      btnStart.Width := lv;
      btnAdd.Width := lv;
      btnEdit.Width := lv;
      btnDelete.Width := lv;
      btnOptions.Width := lv;
      btnExit.Width := lv;
   end;
   lv := Min(lv, Max(0, StrToIntDef(GetLangTextDef(idxMain, ['Buttons', 'Size', 'TextMargin'], IntToStr(btnStart.Margin)), btnStart.Margin)));
   if lv <> btnStart.Margin then
   begin
      btnStart.Margin := lv;
      btnAdd.Margin := lv;
      btnEdit.Margin := lv;
      btnDelete.Margin := lv;
      btnOptions.Margin := lv;
      btnExit.Margin := lv;
   end;
   btnStart.Caption := GetLangTextDef(idxMain, ['Buttons', 'Start'], 'Start');
   btnAdd.Caption := GetLangTextDef(idxMain, ['Buttons', 'Add'], 'Add');
   btnEdit.Caption := GetLangTextDef(idxMain, ['Buttons', 'Edit'], 'Edit');
   btnDelete.Caption := GetLangTextDef(idxMain, ['Buttons', 'Delete'], 'Delete');
   btnOptions.Caption := GetLangTextDef(idxMain, ['Buttons', 'Options'], 'Options');
   btnExit.Caption := GetLangTextDef(idxMain, ['Buttons', 'Exit'], 'Exit');
   for i := 0 to lvVMs.Columns.Count - 1 do
      case lvVMs.Columns[i].Tag of
         1: lvVMs.Columns[i].Caption := GetLangTextDef(idxMain, ['List', 'Header', 'Name'], 'Name');
         2: lvVMs.Columns[i].Caption := GetLangTextDef(idxMain, ['List', 'Header', 'VMName'], 'VM name');
         3: if not AddSecondDrive then
               lvVMs.Columns[i].Caption := GetLangTextDef(idxMain, ['List', 'Header', 'Drive'], 'Drive')
            else
               lvVMs.Columns[i].Caption := GetLangTextDef(idxMain, ['List', 'Header', 'FirstDrive'], 'First drive');
         4: lvVMs.Columns[i].Caption := GetLangTextDef(idxMain, ['List', 'Header', 'SecondDrive'], 'Second drive');
      end;
   mmName.Caption := GetLangTextDef(idxMain, ['List', 'Header', 'Name'], 'Name');
   mmVMName.Caption := GetLangTextDef(idxMain, ['List', 'Header', 'VMName'], 'VM Name');
   if not AddSecondDrive then
      mmDrive.Caption := GetLangTextDef(idxMain, ['List', 'Header', 'Drive'], 'Drive')
   else
      mmDrive.Caption := GetLangTextDef(idxMain, ['List', 'Header', 'FirstDrive'], 'First drive');
   mmSecondDrive.Caption := GetLangTextDef(idxMain, ['List', 'Header', 'SecondDrive'], 'Second drive');
   mmAdd.Caption := GetLangTextDef(idxMain, ['List', 'Menu', 'Add'], 'Add');
   mmEdit.Caption := GetLangTextDef(idxMain, ['List', 'Menu', 'Edit'], 'Edit');
   mmDelete.Caption := GetLangTextDef(idxMain, ['List', 'Menu', 'Delete'], 'Delete');
   mmMoveUp.Caption := GetLangTextDef(idxMain, ['List', 'Menu', 'MoveUp'], 'Move up');
   mmMoveDown.Caption := GetLangTextDef(idxMain, ['List', 'Menu', 'MoveDown'], 'Move down');
   mmRefresh.Caption := GetLangTextDef(idxMain, ['List', 'Menu', 'Refresh'], 'Refresh');
   lvVMS.Width := Round(ClientWidth - 11 / 9 * btnStart.Width - lvVMS.Left + ClientOrigin.X - Left);
   abl := Round(ClientWidth - 10 / 9 * btnStart.Width + ClientOrigin.X - Left);
   btnStart.Left := abl;
   btnAdd.Left := abl;
   btnEdit.Left := abl;
   btnDelete.Left := abl;
   btnOptions.Left := abl;
   btnExit.Left := abl;
   if Showing then
      TntFormResize(Self);
end;

procedure TfrmMain.btnEditClick(Sender: TObject);
var
   i, j, p, l, cp, hi, n1, n2, n3, a: Integer;
   H: Cardinal;
   ws, wst, FolderName: WideString;
   strTemp: AnsiString;

begin
   if (lvVMS.Items.Count = 0) or (lvVMS.ItemIndex < 0) or (lvVMS.ItemIndex >= lvVMS.Items.Count) then
   begin
      btnEdit.Down := False;
      Exit;
   end;
   try
      try
         if frmAddEdit = nil then
            Application.CreateForm(TfrmAddEdit, frmAddEdit);
         with frmAddEdit do
         begin
            Caption := GetLangTextDef(idxAddEdit, ['Caption', 'Edit'], 'Edit');
            isEdit := True;
            with VMentries[lvVMS.ItemIndex] do
            begin
               edtName.Text := Name;
               cmbMode.ItemIndex := ModeLoadVM;
               if Ptype = 0 then
               begin
                  if sbVirtualBox.Down then
                     cmbModeChange(cmbMode)
                  else
                     sbVirtualBox.Click;
               end
               else
               begin
                  if sbQEMU.Down then
                     cmbModeChange(cmbMode)
                  else
                     sbQEMU.Click;
               end;
               edtExeParams.Text := ExeParams;

               GetNamesAndIDs;
               for i := 0 to High(VMIDs) do
                  try
                     cmbVMName.Items.Add('"' + VMIDs[i].Name + '"');
                  except
                  end;

               i := 1;
               while i < cmbVMName.Items.Count do
               begin
                  if cmbVMName.Items[i] = '"' + VMName + '"' then
                     Break;
                  Inc(i);
               end;
               if i < cmbVMName.Items.Count then
                  cmbVMName.ItemIndex := i
               else
                  cmbVMName.ItemIndex := 0;
               edtVMPath.Text := VMPath;
               Refresh;
               if FirstDriveFound then
               begin
                  SetLength(CBFirstDriveName, cmbFirstDrive.Items.Count);
                  SetLength(CBFirstDriveSize, cmbFirstDrive.Items.Count);
                  SetLength(CBFirstDriveLetters, cmbFirstDrive.Items.Count);
                  i := Length(FirstDriveName) - Pos(' ,', ReverseString(FirstDriveName));
                  CBFirstDriveName[High(CBFirstDriveName)] := Copy(FirstDriveName, 1, i - 1);
                  CBFirstDriveSize[High(CBFirstDriveSize)] := Copy(FirstDriveName, i + 2, Length(FirstDriveName) - i - 1);
                  CBFirstDriveLetters[High(CBFirstDriveLetters)] := '[ ]';
                  CBMaxLetSize := cmbFirstDrive.Canvas.TextWidth('  [ ]');
                  cmbFirstDrive.Items.Append(FirstDriveName + ',  [ ]');
                  cmbFirstDrive.ItemIndex := 1;
               end
               else
                  cmbFirstDrive.ItemIndex := 0;
               if AddSecondDrive then
               begin
                  if SecondDriveFound and (SecondDriveName <> '') then
                  begin
                     SetLength(CBSecondDriveName, cmbSecondDrive.Items.Count);
                     SetLength(CBSecondDriveSize, cmbSecondDrive.Items.Count);
                     SetLength(CBSecondDriveLetters, cmbSecondDrive.Items.Count);
                     i := Length(SecondDriveName) - Pos(' ,', ReverseString(SecondDriveName));
                     CBSecondDriveName[High(CBSecondDriveName)] := Copy(SecondDriveName, 1, i - 1);
                     CBSecondDriveSize[High(CBSecondDriveSize)] := Copy(SecondDriveName, i + 2, Length(SecondDriveName) - i - 1);
                     CBSecondDriveLetters[High(CBSecondDriveLetters)] := '[ ]';
                     CBMaxLetSize := cmbSecondDrive.Canvas.TextWidth('  [ ]');
                     cmbSecondDrive.Items.Append(SecondDriveName + ',  [ ]');
                     cmbSecondDrive.ItemIndex := 1;
                  end
                  else
                     cmbSecondDrive.ItemIndex := 0;
               end;
               cmbEnableCPUVirtualization.ItemIndex := VBCPUVirtualization;
               edtHDD.Text := InternalHDD;
               if Ptype = 1 then
                  if CDROMName <> '' then
                  begin
                     if CDROMType = 0 then
                        cmbCDROM.Items.Add(CDROMName)
                     else
                        cmbCDROM.Items.Add(WideExtractFileName(CDROMName));
                     cmbCDROM.ItemIndex := cmbCDROM.Items.Count - 1;
                  end;
               edtMemory.Text := IntToStr(Memory);
               cmbAudio.ItemIndex := Audio;
               cmbWS.ItemIndex := Run;
               cmbPriority.ItemIndex := Priority;
            end;
            Left := frmMain.Left + ((frmMain.Width - Width) div 2);
            if Left < Screen.WorkAreaLeft then
               Left := Screen.WorkAreaLeft
            else if Left + Width > Screen.WorkAreaRect.Right then
               Left := Screen.WorkAreaRect.Right - Width;

            Top := frmMain.Top + ((frmMain.Height - Height) div 2);
            if Top < Screen.WorkAreaTop then
               Top := Screen.WorkAreaTop
            else if Top + Height > Screen.WorkAreaRect.Bottom then
               Top := Screen.WorkAreaRect.Bottom - Height;
            if ShowModal = mrOK then
            begin
               with VMentries[lvVMS.ItemIndex] do
               begin
                  Name := Trim(edtName.Text);
                  Ptype := Byte(not sbVirtualBox.Down);
                  if sbVirtualBox.Down then
                  begin
                     ModeLoadVM := cmbMode.ItemIndex;
                     case ModeLoadVM of
                        0:
                           begin
                              VMName := VMIDs[cmbVMName.ItemIndex - 1].Name;
                              VMID := VMIDs[cmbVMName.ItemIndex - 1].ID;
                              FolderName := '';
                              with frmMain.xmlGen do
                              begin
                                 if Tag = 1 then
                                    try
                                       Active := True;
                                       n1 := ChildNodes.IndexOf('VirtualBox');
                                       if n1 > -1 then
                                       begin
                                          n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                          if n2 > -1 then
                                          begin
                                             n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                             if n3 > -1 then
                                             begin
                                                a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                                if a > -1 then
                                                begin
                                                   FolderName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                                                   l := Length(FolderName);
                                                   Replacebks(FolderName, l);
                                                end;
                                             end;
                                          end;
                                       end;
                                    except
                                    end;
                                 Active := False;
                              end;

                              if WideDirectoryExists(FolderName) then
                                 VMPath := FolderName + '\' + VMName + '\' + VMName + '.vbox'
                              else
                                 VMPath := '';
                           end;
                        1:
                           begin
                              VMPath := Trim(edtVMPath.Text);
                              VMName := WideChangeFileExt(WideExtractFileName(VMPath), '');
                              i := 0;
                              while i <= High(VMIDs) do
                              begin
                                 if VMIDs[i].Name = VMName then
                                    Break;
                                 Inc(i);
                              end;
                              VMID := VMIDs[i].ID;
                           end;
                        2:
                           begin
                              ws := Trim(edtExeParams.Text);
                              p := Pos('--startvm "', ws);
                              l := Length(ws);
                              if (p > 0) and ((p + 11) < l) then
                              begin
                                 cp := PosEx('"', ws, p + 11);
                                 if cp > 0 then
                                    ws := Trim(Copy(ws, p + 11, cp - p - 11))
                                 else
                                    ws := '';
                              end
                              else
                                 ws := '';
                              if WideFileExists(ws) then
                              begin
                                 wst := WideChangeFileExt(WideExtractFileName(ws), '');
                                 GetNamesAndIDs;
                                 i := 0;
                                 while i <= High(VMIDs) do
                                 begin
                                    if VMIDs[i].Name = wst then
                                       Break;
                                    Inc(i);
                                 end;
                                 if i <= High(VMIDs) then
                                 begin
                                    VMName := VMIDs[i].Name;
                                    VMID := VMIDs[i].ID;
                                    VMPath := ws;
                                 end;
                              end
                              else
                              begin
                                 wst := '';
                                 with frmMain.xmlGen do
                                 begin
                                    if Tag = 1 then
                                       try
                                          Active := True;
                                          n1 := ChildNodes.IndexOf('VirtualBox');
                                          if n1 > -1 then
                                          begin
                                             n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                             if n2 > -1 then
                                             begin
                                                n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                                if n3 > -1 then
                                                begin
                                                   a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                                   if a > -1 then
                                                   begin
                                                      wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                                                      Replacebks(wst, Length(wst));
                                                   end;
                                                end;
                                             end;
                                          end;
                                       except
                                       end;
                                    Active := False;
                                 end;

                                 if (WideExtractFileName(ws) = ws) and (WideExtractFileExt(ws) <> '') and WideFileExists(wst + '\' + WideChangeFileExt(ws, '') + '\' + ws) then
                                 begin
                                    VMPath := wst + '\' + WideChangeFileExt(ws, '') + '\' + ws;
                                    wst := WideChangeFileExt(WideExtractFileName(ws), '');
                                    GetNamesAndIDs;
                                    i := 0;
                                    while i <= High(VMIDs) do
                                    begin
                                       if VMIDs[i].Name = wst then
                                          Break;
                                       Inc(i);
                                    end;
                                    if i <= High(VMIDs) then
                                    begin
                                       VMName := VMIDs[i].Name;
                                       VMID := VMIDs[i].ID;
                                    end
                                    else
                                    begin
                                       VMName := '';
                                       VMID := '';
                                       VMPath := '';
                                    end;
                                 end
                                 else if (WideExtractFileName(ws) = ws) and (WideExtractFileExt(ws) = '') and WideFileExists(wst + '\' + ws + '\' + ws + '.vbox') then
                                 begin
                                    VMPath := wst + '\' + ws + '\' + ws + '.vbox';
                                    wst := WideChangeFileExt(WideExtractFileName(ws), '');
                                    GetNamesAndIDs;
                                    i := 0;
                                    while i <= High(VMIDs) do
                                    begin
                                       if VMIDs[i].Name = wst then
                                          Break;
                                       Inc(i);
                                    end;
                                    if i <= High(VMIDs) then
                                    begin
                                       VMName := VMIDs[i].Name;
                                       VMID := VMIDs[i].ID;
                                    end
                                    else
                                    begin
                                       VMName := '';
                                       VMPath := '';
                                       VMID := '';
                                    end;
                                 end
                                 else if isGUID(ws) then
                                 begin
                                    i := 0;
                                    while i <= High(VMIDs) do
                                    begin
                                       if VMIDs[i].ID = ws then
                                          Break;
                                       Inc(i);
                                    end;
                                    if i <= High(VMIDs) then
                                    begin
                                       VMName := VMIDs[i].Name;
                                       VMID := VMIDs[i].ID;
                                       FolderName := '';
                                       with frmMain.xmlGen do
                                       begin
                                          if Tag = 1 then
                                             try
                                                Active := True;
                                                n1 := ChildNodes.IndexOf('VirtualBox');
                                                if n1 > -1 then
                                                begin
                                                   n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                                   if n2 > -1 then
                                                   begin
                                                      n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                                      if n3 > -1 then
                                                      begin
                                                         a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                                         if a > -1 then
                                                         begin
                                                            FolderName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                                                            l := Length(FolderName);
                                                            Replacebks(FolderName, l);
                                                         end;
                                                      end;
                                                   end;
                                                end;
                                             except
                                             end;
                                          Active := False;
                                       end;

                                       if WideDirectoryExists(FolderName) then
                                          VMPath := FolderName + '\' + VMName + '\' + VMName + '.vbox'
                                       else
                                          VMPath := '';
                                    end;
                                 end;
                              end;
                           end;
                     end;
                  end
                  else
                  begin
                     ModeLoadVM := 2;
                     VMID := '';
                     VMPath := '';
                     ws := Trim(edtExeParams.Text);
                     p := Pos('-name "', ws);
                     l := Length(ws);
                     if (p > 0) and ((p + 7) < l) then
                     begin
                        cp := PosEx('"', ws, p + 7);
                        if cp > 0 then
                           ws := Trim(Copy(ws, p + 7, cp - p - 7))
                        else
                           ws := '';
                     end
                     else
                        ws := '';
                     VMName := ws;
                  end;
                  ExeParams := Trim(edtExeParams.Text);
                  strTemp := FirstDriveName;
                  if cmbFirstDrive.ItemIndex > 0 then
                  begin
                     strTemp := AnsiString(cmbFirstDrive.Text);
                     i := Pos(',  [', strTemp);
                     if i = 0 then
                        FirstDriveName := strTemp
                     else
                        FirstDriveName := Copy(strTemp, 1, i - 1);
                  end
                  else
                     FirstDriveName := '';
                  if strTemp <> FirstDriveName then
                  begin
                     l := Length(strTemp);
                     if l > 0 then
                     begin
                        H := 2166136261;
                        for i := 1 to l do
                           H := (H xor Byte(strTemp[i])) * 16777619;
                        H := H and 255;
                        j := 0;
                        hi := High(FHash[H]);
                        while j <= hi do
                        begin
                           if (FHash[H][j][1] = 1) and (FHash[H][j][2] = lvVMS.ItemIndex) then
                           begin
                              Move(FHash[H][j + 1][1], FHash[H][j][1], (hi - j) * 4);
                              SetLength(FHash[H], hi);
                              Dec(hi);
                              Continue;
                           end;
                           Inc(j);
                        end;
                     end;
                     l := Length(FirstDriveName);
                     if l > 0 then
                     begin
                        H := 2166136261;
                        for i := 1 to l do
                           H := (H xor Byte(FirstDriveName[i])) * 16777619;
                        H := H and 255;
                        SetLength(FHash[H], Length(FHash[H]) + 1);
                        FHash[H][High(FHash[H])][1] := 1;
                        FHash[H][High(FHash[H])][2] := lvVMS.ItemIndex;
                     end;
                  end;
                  FirstDriveFound := True;
                  if AddSecondDrive then
                  begin
                     strTemp := SecondDriveName;
                     if cmbSecondDrive.ItemIndex > 0 then
                     begin
                        strTemp := AnsiString(cmbSecondDrive.Text);
                        i := Pos(',  [', strTemp);
                        if i = 0 then
                           SecondDriveName := strTemp
                        else
                           SecondDriveName := Copy(strTemp, 1, i - 1);
                     end
                     else
                        SecondDriveName := '';
                     SecondDriveFound := True;
                     if strTemp <> SecondDriveName then
                     begin
                        l := Length(strTemp);
                        if l > 0 then
                        begin
                           H := 2166136261;
                           for i := 1 to l do
                              H := (H xor Byte(strTemp[i])) * 16777619;
                           H := H and 255;
                           j := 0;
                           hi := High(FHash[H]);
                           while j <= hi do
                           begin
                              if (FHash[H][j][1] = 2) and (FHash[H][j][2] = lvVMS.ItemIndex) then
                              begin
                                 Move(FHash[H][j + 1][1], FHash[H][j][1], (hi - j) * 4);
                                 SetLength(FHash[H], hi);
                                 Dec(hi);
                                 Continue;
                              end;
                              Inc(j);
                           end;
                        end;
                        l := Length(SecondDriveName);
                        if l > 0 then
                        begin
                           H := 2166136261;
                           for i := 1 to l do
                              H := (H xor Byte(SecondDriveName[i])) * 16777619;
                           H := H and 255;
                           SetLength(FHash[H], Length(FHash[H]) + 1);
                           FHash[H][High(FHash[H])][1] := 2;
                           FHash[H][High(FHash[H])][2] := lvVMS.ItemIndex;
                        end;
                     end;
                  end;
                  VBCPUVirtualization := cmbEnableCPUVirtualization.ItemIndex;
                  InternalHDD := Trim(edtHDD.Text);
                  if cmbCDROM.ItemIndex = 0 then
                  begin
                     CDROMName := '';
                     CDROMType := 0;
                  end
                  else if CDDVDType = 0 then
                  begin
                     CDROMName := Copy(cmbCDROM.Text, 1, Length(cmbCDROM.Text) - 6);
                     CDROMType := 0;
                  end
                  else
                  begin
                     CDROMName := TMyObj(cmbCDROM.Items.Objects[cmbCDROM.Items.Count - 1]).Text;
                     CDROMType := 1;
                  end;
                  Memory := Min(Max(StrToIntDef(edtMemory.Text, 512), 1), 65535);
                  Audio := cmbAudio.ItemIndex;
                  Run := cmbWS.ItemIndex;
                  Priority := cmbPriority.ItemIndex;
                  luIDS.fdCID := '';
                  luIDS.fdGUID := '';
                  luIDS.sdCID := '';
                  luIDS.sdGUID := '';
                  lvVMS.Items.BeginUpdate;
                  with lvVMS.Items[lvVMS.ItemIndex] do
                  begin
                     ImageIndex := Ptype;
                     for i := 1 to lvVMS.Columns.Count - 1 do
                        case lvVMS.Columns[i].Tag of
                           1: SubItems[i - 1] := Name;
                           2: SubItems[i - 1] := VMName;
                           3:
                              begin
                                 SubItems[i - 1] := FirstDriveName;
                                 SubItemImages[i - 1] := 4;
                              end;
                           4:
                              begin
                                 SubItems[i - 1] := SecondDriveName;
                                 if SecondDriveName <> '' then
                                    SubItemImages[i - 1] := 4
                                 else
                                    SubItemImages[i - 1] := -1;
                              end;
                        end;
                  end;
                  lvVMS.Items.EndUpdate;
                  lvVMs.Items[lvVMS.ItemIndex].MakeVisible(False);
               end;

               SaveVMentries(VMentriesFile);
            end;
         end;
      finally
         frmAddEdit.Free;
         frmAddEdit := nil;
      end;
   except
   end;
   btnEdit.Down := False;
end;

procedure TfrmMain.btnDeleteClick(Sender: TObject);
var
   i, j, li, h: Integer;
begin
   btnDelete.Down := True;
   try
      if lvVMS.Items.Count = 0 then
         Exit;
      if lvVMS.ItemIndex < 0 then
         Exit;
      if lvVMS.ItemIndex >= lvVMS.Items.Count then
         Exit;
      msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
      PostMessage(Handle, WM_USER + 1024, 0, 0);
      if MessageBoxW(Handle,
         PWideChar(GetLangTextDef(idxMain, ['Messages', 'SureDeleteEntry'], 'Are you sure you want to delete this entry...?')),
         PWideChar(msgBoxCaption), MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
      begin
         btnDelete.Down := False;
         Exit;
      end;
      li := lvVMS.ItemIndex;
      for i := 0 to 255 do
      begin
         j := 0;
         h := High(FHash[i]);
         while j <= h do
         begin
            if FHash[i][j][2] > li then
               Dec(FHash[i][j][2])
            else if FHash[i][j][2] = li then
            begin
               Move(FHash[i][j + 1][1], FHash[i][j][1], (h - j) * 4);
               SetLength(FHash[i], h);
               Dec(h);
               Continue;
            end;
            Inc(j);
         end;
      end;
      for i := li to High(VMentries) - 1 do
         VMentries[i] := VMentries[i + 1];
      SetLength(VMentries, Length(VMentries) - 1);
      lvVMS.Items.BeginUpdate;
      lvVMS.DeleteSelected;
      mmCrt.Tag := lvVms.Canvas.TextWidth(IntToStr(Length(VMentries))) + 2 * lvVms.Canvas.TextWidth('0');
      if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
      begin
         if lvVMs.Items.Count < 10 then
         begin
            if lvVMs.Items.Count = 9 then
            begin
               lvVms.Columns[1].MinWidth := 25;
               lvVms.Columns[1].MaxWidth := 25;
               lvVms.Columns[1].Width := 25;
            end;
            for i := 0 to lvVMS.Items.Count - 1 do
               lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
         end
         else
         begin
            for i := 0 to lvVMS.Items.Count - 1 do
               if i < 9 then
                  lvVMS.Items[i].SubItems[0] := '0' + IntToStr(i + 1)
               else
                  lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
         end;
      end;
      lvVMS.Items.EndUpdate;
      if lvVMS.Items.Count > 0 then
      begin
         lvVMS.ItemIndex := Min(li, lvVMS.Items.Count - 1);
         lvVMs.Items[lvVMS.ItemIndex].Selected := True;
         lvVMs.Items[lvVMS.ItemIndex].Focused := True;
         lvVMs.Items[lvVMS.ItemIndex].MakeVisible(False);
      end;
      SaveVMentries(VMentriesFile);
      SaveCfg(CfgFile);
   finally
      btnDelete.Down := False;
   end;
end;

procedure TfrmMain.MoveUp(Sender: TObject);
var
   i, j, k, stf1, stf2, sts1, sts2, fdCol, sdCol, l1, l2, hi: Integer;
   H1, H2: Cardinal;
   et: VMEntry;
   vet: TTNTListItem;
   c1, c2: WideString;
begin
   if lvVMS.Items.Count <= 1 then
      Exit;
   i := lvVMS.ItemIndex;
   if i < 1 then
      Exit;
   if i >= lvVMS.Items.Count then
      Exit;

   l1 := Length(VMentries[i - 1].FirstDriveName);
   if l1 > 0 then
   begin
      H1 := 2166136261;
      for j := 1 to l1 do
         H1 := (H1 xor Byte(VMentries[i - 1].FirstDriveName[j])) * 16777619;
      H1 := H1 and 255;
      j := 0;
      hi := High(FHash[H1]);
      while j <= hi do
      begin
         if (FHash[H1][j][1] = 1) and (FHash[H1][j][2] = (i - 1)) then
            Break;
         Inc(j);
      end;
   end
   else
   begin
      H1 := 0;
      j := -1;
   end;
   l2 := Length(VMentries[i].FirstDriveName);
   if l2 > 0 then
   begin
      H2 := 2166136261;
      for k := 1 to l2 do
         H2 := (H2 xor Byte(VMentries[i].FirstDriveName[k])) * 16777619;
      H2 := H2 and 255;
      k := 0;
      hi := High(FHash[H2]);
      while k <= hi do
      begin
         if (FHash[H2][k][1] = 1) and (FHash[H2][k][2] = i) then
            Break;
         Inc(k);
      end;
   end
   else
   begin
      H2 := 0;
      k := -1;
   end;

   if j > -1 then
   begin
      if k > -1 then
      begin
         FHash[H1][j][2] := i;
         FHash[H2][k][2] := i - 1;
      end
      else
         FHash[H1][j][2] := i;
   end
   else if k > -1 then
      FHash[H2][k][2] := i - 1;

   if AddSecondDrive then
   begin
      l1 := Length(VMentries[i - 1].SecondDriveName);
      if l1 > 0 then
      begin
         H1 := 2166136261;
         for j := 1 to l1 do
            H1 := (H1 xor Byte(VMentries[i - 1].SecondDriveName[j])) * 16777619;
         H1 := H1 and 255;
         j := 0;
         hi := High(FHash[H1]);
         while j <= hi do
         begin
            if (FHash[H1][j][1] = 2) and (FHash[H1][j][2] = (i - 1)) then
               Break;
            Inc(j);
         end;
      end
      else
      begin
         H1 := 0;
         j := -1;
      end;
      l2 := Length(VMentries[i].SecondDriveName);
      if l2 > 0 then
      begin
         H2 := 2166136261;
         for k := 1 to l2 do
            H2 := (H2 xor Byte(VMentries[i].SecondDriveName[k])) * 16777619;
         H2 := H2 and 255;
         k := 0;
         hi := High(FHash[H2]);
         while k <= hi do
         begin
            if (FHash[H2][k][1] = 2) and (FHash[H2][k][2] = i) then
               Break;
            Inc(k);
         end;
      end
      else
      begin
         H2 := 0;
         k := -1;
      end;

      if j > -1 then
      begin
         if k > -1 then
         begin
            FHash[H1][j][2] := i;
            FHash[H2][k][2] := i - 1;
         end
         else
            FHash[H1][j][2] := i;
      end
      else if k > -1 then
         FHash[H2][k][2] := i - 1;
   end;

   lvVMs.Items.BeginUpdate;

   fdCol := -1;
   sdCol := -1;
   stf1 := -1;
   stf2 := -1;
   sts1 := -1;
   sts2 := -1;

   j := 1;
   while j < lvVMs.Columns.Count do
   begin
      if lvVMs.Columns[j].Tag = 3 then
      begin
         fdCol := j;
         stf1 := lvVMs.Items[i - 1].SubItemImages[j - 1];
         sts1 := lvVMs.Items[i].SubItemImages[j - 1];
         Break;
      end;
      Inc(j);
   end;

   if AddSecondDrive then
   begin
      j := 1;
      while j < lvVMs.Columns.Count do
      begin
         if lvVMs.Columns[j].Tag = 4 then
         begin
            sdCol := j;
            stf2 := lvVMs.Items[i - 1].SubItemImages[j - 1];
            sts2 := lvVMs.Items[i].SubItemImages[j - 1];
            Break;
         end;
         Inc(j);
      end;
   end;

   if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
   begin
      c1 := lvVMS.Items[i - 1].SubItems[0];
      c2 := lvVMS.Items[i].SubItems[0];
   end;
   vet := TTNTListItem.Create(lvVMS.Items);
   vet.Assign(lvVMS.Items[i - 1]);
   lvVMS.Items[i - 1].Assign(lvVMS.Items[i]);
   lvVMS.Items[i].Assign(vet);
   vet.Free;
   if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
   begin
      lvVMS.Items[i - 1].SubItems[0] := c1;
      lvVMS.Items[i].SubItems[0] := c2;
   end;
   lvVMS.ItemIndex := i - 1;
   lvVMS.Items[i - 1].Selected := True;
   lvVMS.Items[i - 1].Focused := True;

   et := VMentries[i - 1];
   VMentries[i - 1] := VMentries[i];
   VMentries[i] := et;

   if fdCol > -1 then
   begin
      lvVMs.Items[i - 1].SubItemImages[fdCol - 1] := sts1;
      lvVMs.Items[i].SubItemImages[fdCol - 1] := stf1;
   end;

   if sdCol > -1 then
   begin
      lvVMs.Items[i - 1].SubItemImages[sdCol - 1] := sts2;
      lvVMs.Items[i].SubItemImages[sdCol - 1] := stf2;
   end;
   lvVMs.Items.EndUpdate;
   lvVMs.Repaint;
   SaveVMentries(VMentriesFile);
   SaveCfg(CfgFile);
end;

procedure TfrmMain.MoveDown(Sender: TObject);
var
   i, j, k, hi, stf1, stf2, sts1, sts2, fdCol, sdCol, l1, l2: Integer;
   H1, H2: Cardinal;
   et: VMEntry;
   vet: TTNTListItem;
   c1, c2: WideString;
begin
   if lvVMS.Items.Count < 1 then
      Exit;
   i := lvVMS.ItemIndex;
   if i < 0 then
      Exit;
   if i >= (lvVMS.Items.Count - 1) then
      Exit;

   l1 := Length(VMentries[i].FirstDriveName);
   if l1 > 0 then
   begin
      H1 := 2166136261;
      for j := 1 to l1 do
         H1 := (H1 xor Byte(VMentries[i].FirstDriveName[j])) * 16777619;
      H1 := H1 and 255;
      j := 0;
      hi := High(FHash[H1]);
      while j <= hi do
      begin
         if (FHash[H1][j][1] = 1) and (FHash[H1][j][2] = i) then
            Break;
         Inc(j);
      end;
   end
   else
   begin
      H1 := 0;
      j := -1;
   end;
   l2 := Length(VMentries[i + 1].FirstDriveName);
   if l2 > 0 then
   begin
      H2 := 2166136261;
      for k := 1 to l2 do
         H2 := (H2 xor Byte(VMentries[i + 1].FirstDriveName[k])) * 16777619;
      H2 := H2 and 255;
      k := 0;
      hi := High(FHash[H2]);
      while k <= hi do
      begin
         if (FHash[H2][k][1] = 1) and (FHash[H2][k][2] = (i + 1)) then
            Break;
         Inc(k);
      end;
   end
   else
   begin
      H2 := 0;
      k := -1;
   end;

   if j > -1 then
   begin
      if k > -1 then
      begin
         FHash[H1][j][2] := i + 1;
         FHash[H2][k][2] := i;
      end
      else
         FHash[H1][j][2] := i + 1;
   end
   else if k > -1 then
      FHash[H2][k][2] := i;

   if AddSecondDrive then
   begin
      l1 := Length(VMentries[i].SecondDriveName);
      if l1 > 0 then
      begin
         H1 := 2166136261;
         for j := 1 to l1 do
            H1 := (H1 xor Byte(VMentries[i].SecondDriveName[j])) * 16777619;
         H1 := H1 and 255;
         j := 0;
         hi := High(FHash[H1]);
         while j <= hi do
         begin
            if (FHash[H1][j][1] = 2) and (FHash[H1][j][2] = i) then
               Break;
            Inc(j);
         end;
      end
      else
      begin
         H1 := 0;
         j := -1;
      end;
      l2 := Length(VMentries[i + 1].SecondDriveName);
      if l2 > 0 then
      begin
         H2 := 2166136261;
         for k := 1 to l2 do
            H2 := (H2 xor Byte(VMentries[i + 1].SecondDriveName[k])) * 16777619;
         H2 := H2 and 255;
         k := 0;
         hi := High(FHash[H2]);
         while k <= hi do
         begin
            if (FHash[H2][k][1] = 2) and (FHash[H2][k][2] = (i + 1)) then
               Break;
            Inc(k);
         end;
      end
      else
      begin
         H2 := 0;
         k := -1;
      end;

      if j > -1 then
      begin
         if k > -1 then
         begin
            FHash[H1][j][2] := i + 1;
            FHash[H2][k][2] := i;
         end
         else
            FHash[H1][j][2] := i + 1;
      end
      else if k > -1 then
         FHash[H2][k][2] := i;
   end;

   lvVMs.Items.BeginUpdate;
   fdCol := -1;
   sdCol := -1;
   stf1 := -1;
   stf2 := -1;
   sts1 := -1;
   sts2 := -1;

   j := 1;
   while j < lvVMs.Columns.Count do
   begin
      if lvVMs.Columns[j].Tag = 3 then
      begin
         fdCol := j;
         stf1 := lvVMs.Items[i].SubItemImages[j - 1];
         sts1 := lvVMs.Items[i + 1].SubItemImages[j - 1];
         Break;
      end;
      Inc(j);
   end;

   if AddSecondDrive then
   begin
      j := 1;
      while j < lvVMs.Columns.Count do
      begin
         if lvVMs.Columns[j].Tag = 4 then
         begin
            sdCol := j;
            stf2 := lvVMs.Items[i].SubItemImages[j - 1];
            sts2 := lvVMs.Items[i + 1].SubItemImages[j - 1];
            Break;
         end;
         Inc(j);
      end;
   end;
   if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
   begin
      c1 := lvVMS.Items[i].SubItems[0];
      c2 := lvVMS.Items[i + 1].SubItems[0];
   end;
   vet := TTNTListItem.Create(lvVMS.Items);
   vet.Assign(lvVMS.Items[i + 1]);
   lvVMS.Items[i + 1].Assign(lvVMS.Items[i]);
   lvVMS.Items[i].Assign(vet);
   vet.Free;
   if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
   begin
      lvVMS.Items[i].SubItems[0] := c1;
      lvVMS.Items[i + 1].SubItems[0] := c2;
   end;
   lvVMS.ItemIndex := i + 1;
   lvVMS.Items[i + 1].Selected := True;
   lvVMS.Items[i + 1].Focused := True;

   et := VMentries[i + 1];
   VMentries[i + 1] := VMentries[i];
   VMentries[i] := et;

   if fdCol > -1 then
   begin
      lvVMs.Items[i].SubItemImages[fdCol - 1] := sts1;
      lvVMs.Items[i + 1].SubItemImages[fdCol - 1] := stf1;
   end;

   if sdCol > -1 then
   begin
      lvVMs.Items[i].SubItemImages[sdCol - 1] := sts2;
      lvVMs.Items[i + 1].SubItemImages[sdCol - 1] := stf2;
   end;
   lvVMs.Items.EndUpdate;
   lvVMs.Repaint;
   SaveVMentries(VMentriesFile);
   SaveCfg(CfgFile);
end;

procedure TfrmMain.btnStartClick(Sender: TObject);

   function areDifferent(const FirstXMLnode, SecondXMLnode: IXMLNode): Boolean;
   var
      i: Integer;
   begin
      Result := False;
      try
         if FirstXMLnode.AttributeNodes.Count <> SecondXMLnode.AttributeNodes.Count then
         begin
            Result := True;
            Exit;
         end;
         for i := 0 to FirstXMLnode.AttributeNodes.Count - 1 do
            if FirstXMLnode.AttributeNodes[i].Text <> SecondXMLnode.AttributeNodes[i].Text then
            begin
               Result := True;
               Exit;
            end;
         if FirstXMLnode.ChildNodes.Count <> SecondXMLnode.ChildNodes.Count then
         begin
            Result := True;
            Exit;
         end;
         if FirstXMLnode.ChildNodes.Count = 0 then
            Exit;
         for i := 0 to FirstXMLnode.ChildNodes.Count - 1 do
            if areDifferent(FirstXMLnode.ChildNodes[i], SecondXMLnode.ChildNodes[i]) then
            begin
               Result := True;
               Exit;
            end;
      except
      end;
   end;

const
   ReadBuffer = 2400;
   IOCTL_STORAGE_CHECK_VERIFY2 = $002D0800;
var
   zAppName, zVBM, zSVC: array[0..512] of WideChar;
   eStartupInfo, vbmStartupInfo, svcStartupInfo: TStartupInfo;
   eProcessInfo, vbmProcessInfo, svcProcessInfo: TProcessInformation;
   ExitCode: DWORD;
   i, j, k, p, cp, l, n1, n2, n3, n4, n5, a1, a2, a3, sc: Integer;
   lv: Int64;
   hVolume, hVBoxSVC, hVmdk, hVbox, hDrive: THandle;
   dwBytesReturned: DWORD;
   sdn: STORAGE_DEVICE_NUMBER;
   an, vbmPath, StartFolder, sf, wst, wp, floc, sloc, ComLine, errmsg, mPort, mDevice, mCName, sJob, svcPath, strMess: WideString;
   CDROMLetter: AnsiChar;
   PStartFolder: PWideChar;
   ErrorMode: Word;
   fu, su: ShortInt;
   AllOK, BreakCycles, isWin, isRightWin, isFUSet, isSUSet, isLastC, DoChange, useVBMU, svcAlreadyStarted: Boolean;
   vmdkids: array of array[1..2] of WideString;
   exvmdks: array of AnsiString;
   fv, sv, fuuid, suuid, sVbox, sVmdk, sOutput: AnsiString;
   ds: Int64;
   ahs: array of array[0..2] of Word;
   sr: TSearchRecW;
   tres: array[0..255] of WideChar;
   attr: Cardinal;
   tms: TMemoryStream;
   wereDismounted, js, jc, VBHardwareVirtualization, AlreadyWaitedForVBSVC: Boolean;
   ThreadID, hStderr: THandle;
   WarnAboutBoot: Byte;
   vbmComm: array of array[1..2] of WideString;
   Security: TSecurityAttributes;
   ReadPipe, WritePipe: THandle;
   Buffer: PAnsiChar;
   dwBytesRead: DWord;
   bSuccess: LongBool;

label
   sid, srchvbm, srchvm, srchvbm2, juststart, justclose;
begin
   ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
   fu := -1;
   su := -1;
   wereDismounted := False;
   js := False;
   jc := False;
   AllOK := False;
   VBHardwareVirtualization := True;
   useVBMU := False;
   AlreadyWaitedForVBSVC := False;
   svcAlreadyStarted := False;
   FindDrivesScheduled := False;
   try
      if lvVMS.Items.Count < 1 then
         Exit;
      p := lvVMS.ItemIndex;
      if p < 0 then
         Exit;
      if p >= lvVMS.Items.Count then
         Exit;

      Hide;

      if (not StartMessageShowed) and (VMentries[p].Ptype <> 1) then
      begin
         try
            if frmInfoMess = nil then
               Application.CreateForm(TfrmInfoMess, frmInfoMess);
            with frmInfoMess do
            begin
               Caption := GetLangTextDef(idxInfoMess, ['Caption'], 'Information');
               btnOK.Caption := GetLangTextDef(idxInfoMess, ['OKButton'], 'OK');
               lblMess.Caption := GetLangTextFormatDef(idxInfoMess, ['InfoStart'], [btnOK.Caption], 'It will take a few seconds to modify the VM configuration file'#13#10'and another few seconds to start it.'#13#10#13#10'So please be patient while I carry out these operations.'#13#10#13#10'Click on %s to continue...');
               cbNoConfirm.Caption := GetLangTextDef(idxInfoMess, ['DontShow'], 'Don''t show this next time');
               cbNoConfirm.Checked := True;
               ShowModal;
               StartMessageShowed := cbNoConfirm.Checked;
            end;
         except
         end;
         try
            if frmInfoMess <> nil then
            begin
               frmInfoMess.Free;
               frmInfoMess := nil;
            end;
         except
         end;
      end;

      with VMentries[p] do
      begin
         SetLength(VolumesInfo, 0);

         if Ptype <> 1 then
         begin
            vbmPath := WideExtractFilePath(ExeVBPath) + 'VBoxManage.exe';
            svcPath := WideExtractFilePath(ExeVBPath) + 'VBoxSVC.exe';

            AllOK := True;
            errmsg := GetLangTextDef(idxMain, ['Messages', 'UnknownError'], 'unknown error, please report it to the author'#13#10'with a complete description of what you''re doing.');
            case ModeLoadVM of
               2:
                  begin
                     p := Pos('--startvm "', ExeParams);
                     l := Length(ExeParams);
                     if (p > 0) and ((p + 11) < l) then
                     begin
                        cp := PosEx('"', ExeParams, p + 11);
                        if cp > 0 then
                           sf := Trim(Copy(ExeParams, p + 11, cp - p - 11))
                        else
                           sf := '';
                     end
                     else
                        sf := '';
                     VMPath := '';
                     VMID := '';
                     if sf <> '' then
                        if WideFileExists(sf) then
                           VMPath := sf
                        else
                        begin

                           with frmMain.xmlGen do
                           begin
                              if Tag = 1 then
                                 try
                                    Active := True;
                                    n1 := ChildNodes.IndexOf('VirtualBox');
                                    if n1 > -1 then
                                    begin
                                       n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                       if n2 > -1 then
                                       begin
                                          n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                          if n3 > -1 then
                                          begin
                                             a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                             if a1 > -1 then
                                             begin
                                                wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a1].Text;
                                                Replacebks(wst, Length(wst));
                                             end;
                                          end;
                                       end;
                                    end;
                                 except
                                 end;
                              Active := False;
                           end;

                           if (WideExtractFileName(sf) = sf) and (WideExtractFileExt(sf) <> '') and WideFileExists(wst + '\' + WideChangeFileExt(sf, '') + '\' + sf) then
                              VMPath := wst + '\' + WideChangeFileExt(sf, '') + '\' + sf
                           else if (WideExtractFileName(sf) = sf) and (WideExtractFileExt(sf) = '') and WideFileExists(wst + '\' + sf + '\' + sf + '.vbox') then
                              VMPath := wst + '\' + sf + '\' + sf + '.vbox'
                           else if isGUID(sf) then
                           begin
                              VMID := sf;
                              goto sid;
                           end
                           else
                              sf := '';
                        end;
                     if sf = '' then
                     begin
                        AllOK := False;
                        errmsg := GetLangTextDef(idxMain, ['Messages', 'ErrorRetrievingPathID'], 'error retrieving VM path/ID from the exe parameters,'#13#10'please fix the path/ID.');
                     end
                     else if VMPath <> '' then
                     begin
                        VMName := WideChangeFileExt(WideExtractFileName(VMPath), '');
                        with xmlGen do
                        begin
                           AllOK := False;
                           errmsg := GetLangTextDef(idxMain, ['Messages', 'ErrorRetrievingPath'], 'error retrieving VM path from Virtualbox.xml,'#13#10'please replace the file or allow reading.');
                           if Tag = 1 then
                              try
                                 Active := True;
                                 n1 := ChildNodes.IndexOf('VirtualBox');
                                 if n1 > -1 then
                                 begin
                                    n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                                    if n2 > -1 then
                                    begin
                                       n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('MachineRegistry');
                                       if n3 > -1 then
                                       begin
                                          i := 0;
                                          while i < ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count do
                                          begin
                                             try
                                                a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('src');
                                                if a1 > -1 then
                                                begin
                                                   wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[a1].Text;
                                                   l := Length(wst);
                                                   if l > 2 then
                                                   begin
                                                      if WideLowerCase(wst) = WideLowerCase(VMPath) then
                                                      begin
                                                         a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('uuid');
                                                         if a1 > -1 then
                                                         begin
                                                            wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[a1].Text;
                                                            VMID := Copy(wst, 2, Length(wst) - 2);
                                                            AllOK := True;
                                                            Break;
                                                         end;
                                                      end;
                                                   end;
                                                end;
                                             except
                                             end;
                                             Inc(i);
                                          end;
                                          if (not AllOK) and (i >= ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count) then
                                             errmsg := GetLangTextDef(idxMain, ['Messages', 'CouldNotFindVM'], 'could not find the VM in VirtualBox configuration files,'#13#10'please set a valid VM.');
                                       end;
                                    end;
                                 end;
                              except
                              end;
                           Active := False;
                        end;

                     end;
                  end;
            else
               begin

                  sid:
                  with xmlGen do
                  begin
                     AllOK := False;
                     errmsg := GetLangTextDef(idxMain, ['Messages', 'ErrorRetrievingPath'], 'error retrieving VM path from Virtualbox.xml,'#13#10'please replace the file or allow reading.');
                     if Tag = 1 then
                        try
                           Active := True;
                           n1 := ChildNodes.IndexOf('VirtualBox');
                           if n1 > -1 then
                           begin
                              n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                              if n2 > -1 then
                              begin
                                 n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('MachineRegistry');
                                 if n3 > -1 then
                                 begin
                                    i := 0;
                                    while i < ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count do
                                    begin
                                       try
                                          a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('uuid');
                                          if a1 > -1 then
                                          begin
                                             wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[a1].Text;
                                             l := Length(wst);
                                             if l > 2 then
                                             begin
                                                wst := Copy(wst, 2, l - 2);
                                                if wst = VMID then
                                                begin
                                                   a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('src');
                                                   if a1 > -1 then
                                                   begin
                                                      wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[a1].Text;
                                                      l := Length(wst);
                                                      if l >= 9 then
                                                      begin
                                                         Replacebks(wst, l);
                                                         VMPath := wst;
                                                         VMName := WideChangeFileExt(WideExtractFileName(VMPath), '');
                                                         AllOK := True;
                                                      end;
                                                      Break;
                                                   end;
                                                end;
                                             end;
                                          end;
                                       except
                                       end;
                                       Inc(i);
                                    end;
                                    if (not AllOK) and (i >= ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count) then
                                       errmsg := GetLangTextDef(idxMain, ['Messages', 'CouldNotFindVM'], 'could not find the VM in VirtualBox configuration files,'#13#10'please set a valid VM.');
                                 end;
                              end;
                           end;
                        except
                        end;
                     Active := False;
                  end;
               end;
            end;

            if UpdateVM = 0 then
            begin
               GetProcessList;
               l := Length(ProcessInfo);
               for i := 0 to l - 1 do
                  if ProcessInfo[i].WClass = 'QWidget' then
                     if IsWindowVisible(ProcessInfo[i].Handle) then
                        if not ((Pos(VMName + ' [', ProcessInfo[i].WCaption) = 1) and (Pos('] - Oracle VM VirtualBox', ProcessInfo[i].WCaption) > 1)) then
                           if GetFileNameFromHandleW(ProcessInfo[i].Handle) = 'virtualbox.exe' then
                           begin
                              useVBMU := True;
                              Break;
                           end;
            end;

            try
               GetProcessList;
               l := Length(ProcessInfo);
               if (UpdateVM = 2) or ((UpdateVM = 0) and (not useVBMU)) then
               begin
                  an := GetLangTextDef(idxMain, ['Messages', 'VBManDetected'], 'VirtualBox Manager was detected.'#13#10'It is highly recommended not to be used in the same time !'#13#10#13#10'Should I close it...? (it will take a few sec to fully close)');
                  srchvbm:
                  for i := 0 to l - 1 do
                     if ProcessInfo[i].WClass = 'QWidget' then
                        if ProcessInfo[i].WCaption = 'Oracle VM VirtualBox Manager' then
                           if GetFileNameFromHandleW(ProcessInfo[i].Handle) = 'virtualbox.exe' then
                              if IsWindowVisible(ProcessInfo[i].Handle) then
                              begin
                                 if IsIconic(ProcessInfo[i].Handle) then
                                    SendMessage(ProcessInfo[i].Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
                                 SetWindowPos(ProcessInfo[i].Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                 SetWindowPos(ProcessInfo[i].Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                 if MessageBoxW(0, PWideChar(an),
                                    PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')), MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                                    Exit
                                 else
                                 begin
                                    if IsWindowVisible(ProcessInfo[i].Handle) then
                                       SendMessage(ProcessInfo[i].Handle, WM_CLOSE, 0, 0);
                                    j := 1;
                                    while j <= 20 do
                                    begin
                                       Sleep(100);
                                       isRightWin := True;
                                       isWin := isWindow(ProcessInfo[i].Handle);
                                       if isWin then
                                       begin
                                          GetWindowTextW(ProcessInfo[i].Handle, tres, 255);
                                          if tres <> 'Oracle VM VirtualBox Manager' then
                                             isRightWin := False
                                          else
                                          begin
                                             GetClassNameW(ProcessInfo[i].Handle, tres, 255);
                                             if tres <> 'QWidget' then
                                                isRightWin := False;
                                          end;
                                       end;
                                       if (not isWin) or (not isRightWin) then
                                          Break;
                                       Inc(j);
                                    end;
                                    if j > 20 then
                                    begin
                                       if IsIconic(ProcessInfo[i].Handle) then
                                          SendMessage(ProcessInfo[i].Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
                                       SetWindowPos(ProcessInfo[i].Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                       SetWindowPos(ProcessInfo[i].Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                       if MessageBoxW(0,
                                          PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CouldNotCloseVBMan'], [OKCaption], 'Could not close VirtualBox Manager automatically !'#13#10#13#10'Please close it manually and click on %s...  (it will take a few sec to fully close)')),
                                          PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')),
                                          MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                                          Exit
                                       else
                                       begin
                                          j := 1;
                                          while j <= 20 do
                                          begin
                                             Sleep(100);
                                             isRightWin := True;
                                             isWin := isWindow(ProcessInfo[i].Handle);
                                             if isWin then
                                             begin
                                                GetWindowTextW(ProcessInfo[i].Handle, tres, 255);
                                                if tres <> 'Oracle VM VirtualBox Manager' then
                                                   isRightWin := False
                                                else
                                                begin
                                                   GetClassNameW(ProcessInfo[i].Handle, tres, 255);
                                                   if tres <> 'QWidget' then
                                                      isRightWin := False;
                                                end;
                                             end;
                                             if (not isWin) or (not isRightWin) then
                                                Break;
                                             Inc(j);
                                          end;
                                          if j > 20 then
                                          begin
                                             MessageBoxW(0,
                                                PWideChar(GetLangTextDef(idxMain, ['Messages', 'ErrorVBManNotClosed'], 'Error: VirtualBox Manager not closed !')),
                                                PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')),
                                                MB_ICONERROR or MB_OK);
                                             Exit;
                                          end;
                                       end;
                                    end;
                                 end;
                                 an := GetLangTextDef(idxMain, ['Messages', 'AnotherVBManSession'], 'Another VirtualBox Manager was detected.'#13#10'It is highly recommended not to be used in the same time !'#13#10#13#10'Should I close it...? (it will take a few sec to fully close)') + ' ';
                                 goto srchvbm;
                              end;
               end;

               an := GetLangTextDef(idxMain, ['Messages', 'VBVMDetected'], 'A VirtualBox VM was detected.'#13#10'It is highly recommended not to be used in the same time !'#13#10#13#10'Please close it and click on %s... (it will take a few sec to fully close)');
               srchvm:
               if (UpdateVM = 2) or ((UpdateVM = 0) and (not useVBMU)) then
               begin
                  for i := 0 to l - 1 do
                     if ProcessInfo[i].WClass = 'QWidget' then
                        if Pos('] - Oracle VM VirtualBox', ProcessInfo[i].WCaption) > 0 then
                           if GetFileNameFromHandleW(ProcessInfo[i].Handle) = 'virtualbox.exe' then
                              if IsWindowVisible(ProcessInfo[i].Handle) then
                              begin
                                 if IsIconic(ProcessInfo[i].Handle) then
                                    SendMessage(ProcessInfo[i].Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
                                 SetWindowPos(ProcessInfo[i].Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                 SetWindowPos(ProcessInfo[i].Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                 if MessageBoxW(0,
                                    PWideChar(WideFormat(an, [OKCaption])),
                                    PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                                    MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                                    Exit
                                 else
                                 begin
                                    j := 1;
                                    while j <= 20 do
                                    begin
                                       Sleep(100);
                                       isRightWin := True;
                                       isWin := isWindow(ProcessInfo[i].Handle);
                                       if isWin then
                                       begin
                                          GetWindowTextW(ProcessInfo[i].Handle, tres, 255);
                                          if Pos('] - Oracle VM VirtualBox', WideString(tres)) = 0 then
                                             isRightWin := False
                                          else
                                          begin
                                             GetClassNameW(ProcessInfo[i].Handle, tres, 255);
                                             if tres <> 'QWidget' then
                                                isRightWin := False;
                                          end;
                                       end;
                                       if (not isWin) or (not isRightWin) then
                                          Break;
                                       Inc(j);
                                    end;
                                    if j > 20 then
                                    begin
                                       MessageBoxW(0,
                                          PWideChar(GetLangTextDef(idxMain, ['Messages', 'ErrorVBVMNotClosed'], 'Error: VirtualBox VM not closed !')),
                                          PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')),
                                          MB_ICONERROR or MB_OK);
                                       Exit;
                                    end;
                                 end;
                                 an := GetLangTextDef(idxMain, ['Messages', 'AnotherVBVMDetected'], 'Another VirtualBox VM was detected.'#13#10'It is highly recommended not to be used in the same time !'#13#10#13#10'Please close it and click on %s... (it will take a few sec to fully close)');
                                 GetProcessList;
                                 l := Length(ProcessInfo);
                                 goto srchvm;
                              end;
               end
               else
               begin
                  for i := 0 to l - 1 do
                     if ProcessInfo[i].WClass = 'QWidget' then
                        if (Pos(VMName + ' [', ProcessInfo[i].WCaption) = 1) and (Pos('] - Oracle VM VirtualBox', ProcessInfo[i].WCaption) > 1) then
                           if GetFileNameFromHandleW(ProcessInfo[i].Handle) = 'virtualbox.exe' then
                              if IsWindowVisible(ProcessInfo[i].Handle) then
                              begin
                                 if IsIconic(ProcessInfo[i].Handle) then
                                    SendMessage(ProcessInfo[i].Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
                                 SetWindowPos(ProcessInfo[i].Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                 SetWindowPos(ProcessInfo[i].Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                 if MessageBoxW(0,
                                    PWideChar(GetLangTextDef(idxMain, ['Messages', 'ErrorVBVMAlready'], 'The VirtualBox VM is already started.'#13#10'Its configuration cannot be updated.'#13#10#13#10'Please close it and click on %s... (it will take a few sec to fully close)')),
                                    PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                                    MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                                    Exit
                                 else
                                 begin
                                    j := 1;
                                    while j <= 20 do
                                    begin
                                       Sleep(100);
                                       isRightWin := True;
                                       isWin := isWindow(ProcessInfo[i].Handle);
                                       if isWin then
                                       begin
                                          GetWindowTextW(ProcessInfo[i].Handle, tres, 255);
                                          if Pos('] - Oracle VM VirtualBox', WideString(tres)) = 0 then
                                             isRightWin := False
                                          else
                                          begin
                                             GetClassNameW(ProcessInfo[i].Handle, tres, 255);
                                             if tres <> 'QWidget' then
                                                isRightWin := False;
                                          end;
                                       end;
                                       if (not isWin) or (not isRightWin) then
                                          Break;
                                       Inc(j);
                                    end;
                                    if j > 20 then
                                    begin
                                       MessageBoxW(0,
                                          PWideChar(GetLangTextDef(idxMain, ['Messages', 'ErrorVBVMNotClosed'], 'Error: VirtualBox VM not closed !')),
                                          PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')),
                                          MB_ICONERROR or MB_OK);
                                       Exit;
                                    end
                                    else
                                       VBVMWasClosed := Now;
                                 end;
                                 GetProcessList;
                                 l := Length(ProcessInfo);
                                 goto srchvm;
                              end;
               end;
            except
            end;

            if WaitForVBSVC then
               if (UpdateVM = 2) or ((UpdateVM = 0) and (not useVBMU)) then
               begin
                  try
                     GetProCessList;
                     j := 0;
                     l := Length(ProcessInfo);
                     while j < l do
                     begin
                        if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                           if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                              if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                 Break;
                        Inc(j);
                     end;
                     if j < l then
                     begin
                        hVBoxSVC := ProcessInfo[j].Handle;
                        ShowingProgress := False;
                        try
                           if frmProgress = nil then
                              Application.CreateForm(TfrmProgress, frmProgress);
                           with frmProgress do
                           begin
                              lblMessage.Caption := GetLangTextDef(idxMain, ['Messages', 'WaitingVBSVCToClose'], 'Waiting for "VBoxSVC.exe" (a VirtualBox component) to close...');
                              btnCancel.Caption := GetLangTextDef(idxMain, ['Messages', 'CancelHide'], 'Hide');
                              pbProgress.Max := 200 + 200 * Integer(VBSVC2x);
                              Show;
                           end;
                           Application.ProcessMessages;
                           ShowingProgress := True;
                        except
                           if frmProgress.Visible then
                              frmProgress.Close;
                           frmProgress.Free;
                           frmProgress := nil;
                        end;
                        i := 1;
                        while i <= (200 + 200 * Integer(VBSVC2x)) do
                        begin
                           Sleep(35);
                           if ShowingProgress then
                           begin
                              frmProgress.pbProgress.Position := i;
                              Application.ProcessMessages;
                           end;
                           isRightWin := True;
                           isWin := IsWindow(hVBoxSVC);
                           if isWin then
                           begin
                              GetWindowTextW(hVBoxSVC, tres, 255);
                              if tres <> 'VBoxPowerNotifyClass' then
                                 isRightWin := False
                              else
                              begin
                                 GetClassNameW(hVBoxSVC, tres, 255);
                                 if tres <> 'VBoxPowerNotifyClass' then
                                    isRightWin := False;
                              end;
                           end;
                           if (not isWin) or (not isRightWin) then
                           begin
                              GetProCessList;
                              j := 0;
                              l := Length(ProcessInfo);
                              while j < l do
                              begin
                                 if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                    if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                       if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                          Break;
                                 Inc(j);
                              end;
                              if j < l then
                                 hVBoxSVC := ProcessInfo[j].Handle
                              else
                              begin
                                 Sleep(100);
                                 Break;
                              end;
                           end;
                           Inc(i);
                        end;
                        if ShowingProgress then
                           try
                              if frmProgress.Visible then
                                 frmProgress.Close;
                              frmProgress.Free;
                              frmProgress := nil;
                           except
                           end;
                        if i > (200 + 200 * Integer(VBSVC2x)) then
                        begin
                           if MessageBoxW(0,
                              PWideChar(GetLangTextDef(idxMain, ['Messages', 'OutOfTimeVBSVC'], 'Out of time waiting for "VBoxSVC.exe" (a VirtualBox component) to close...!'#13#10#13#10'Should I forcibly close it...?')),
                              PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')),
                              MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                              Exit
                           else
                           begin
                              j := 0;
                              GetProcessList;
                              l := Length(ProcessInfo);
                              while j < l do
                              begin
                                 if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                    if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                       if GetFileNameAndThreadFromHandleW(ProcessInfo[j].Handle, ThreadID) = 'vboxsvc.exe' then
                                          try
                                             TerminateProcess(OpenProcess(PROCESS_TERMINATE, BOOL(0), ThreadID), 0);
                                          except
                                          end;
                                 Inc(j);
                              end;
                              for i := 1 to 10 do
                              begin
                                 Sleep(200);
                                 j := 0;
                                 GetProcessList;
                                 l := Length(ProcessInfo);
                                 while j < l do
                                 begin
                                    if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                       if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                          if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                             Break;
                                    Inc(j);
                                 end;
                                 if j >= l then
                                    Break;
                              end;
                              if i <= 10 then
                              begin
                                 MessageBoxW(0,
                                    PWideChar(GetLangTextDef(idxMain, ['Messages', 'VBSVCStillOpened'], '"VBoxSVC.exe" is still opened !'#13#10#13#10'Exiting...')),
                                    PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')),
                                    MB_ICONERROR or MB_OK);
                                 Exit;
                              end;
                           end;
                        end;
                     end;

                  except
                  end;
               end
               else
               begin
                  GetProcessList;
                  l := Length(ProcessInfo);
                  if VBSVC2x then
                     sc := 11000 - Min(11000, Max(0, Round(86400000 * (Now - VBVMWasClosed))))
                  else
                     sc := 6000 - Min(6000, Max(0, Round(86400000 * (Now - VBVMWasClosed))));
                  for i := 0 to l - 1 do
                     if ProcessInfo[i].WClass = 'QWidget' then
                        if IsWindowVisible(ProcessInfo[i].Handle) then
                           if GetFileNameFromHandleW(ProcessInfo[i].Handle) = 'virtualbox.exe' then
                              sc := 0;
                  if sc < 1500 then
                     Sleep(sc)
                  else
                  begin
                     ShowingProgress := False;
                     ProgressCancelled := False;
                     try
                        if frmProgress = nil then
                           Application.CreateForm(TfrmProgress, frmProgress);
                        with frmProgress do
                        begin
                           lblMessage.Caption := GetLangTextDef(idxMain, ['Messages', 'WaitingPrevSession'], 'Waiting for the previous VM session to be properly closed...');
                           btnCancel.Caption := GetLangTextDef(idxMain, ['Messages', 'CancelSkip'], 'Skip this (unsafe)');
                           pbProgress.Max := 150;
                           Show;
                        end;
                        Application.ProcessMessages;
                        ShowingProgress := True;
                     except
                        try
                           if frmProgress.Visible then
                              frmProgress.Close;
                        except
                        end;
                        try
                           frmProgress.Free;
                           frmProgress := nil;
                        except
                        end;
                     end;
                     if ShowingProgress then
                     begin
                        j := 1;
                        while j <= 150 do
                        begin
                           if ShowingProgress then
                           begin
                              frmProgress.pbProgress.Position := j;
                              Application.ProcessMessages;
                              if not frmProgress.Visible then
                              begin
                                 Sleep(100);
                                 Break;
                              end;
                           end;
                           GetProcessList;
                           l := Length(ProcessInfo);
                           i := 0;
                           while i < l do
                           begin
                              if ProcessInfo[i].WClass = 'QWidget' then
                                 if IsWindowVisible(ProcessInfo[i].Handle) then
                                    if GetFileNameFromHandleW(ProcessInfo[i].Handle) = 'virtualbox.exe' then
                                       Break;
                              if ProcessInfo[i].WClass = 'VBoxPowerNotifyClass' then
                                 if ProcessInfo[i].WCaption = 'VBoxPowerNotifyClass' then
                                    if GetFileNameFromHandleW(ProcessInfo[i].Handle) = 'vboxsvc.exe' then
                                       Break;
                              Inc(i);
                           end;
                           if i >= l then
                           begin
                              Sleep(100);
                              Break;
                           end;
                           Sleep(sc div 100);
                           Inc(j);
                        end;
                        if ShowingProgress then
                           try
                              if frmProgress.Visible then
                                 frmProgress.Close;
                              frmProgress.Free;
                              frmProgress := nil;
                           except
                           end;
                     end;
                  end;
               end;

         end;

         fu := FindDriveWithVendorProductSize(FirstDriveName);
         if fu = -1 then
         begin
            if AddSecondDrive then
            begin
               if ListOnlyUSBDrives then
                  strMess := GetLangTextFormatDef(idxMain, ['Messages', 'FirstDriveWUsb'], [FirstDriveName], 'The first drive (%s) doesn''t seem to exist on this system, it isn''t accessible or is not a USB drive !'#13#10#13#10'Are you sure you want to continue...?')
               else
                  strMess := GetLangTextFormatDef(idxMain, ['Messages', 'FirstDrive'], [FirstDriveName], 'The first drive (%s) doesn''t seem to exist on this system or it isn''t accessible !'#13#10#13#10'Are you sure you want to continue...?');
            end
            else
            begin
               if ListOnlyUSBDrives then
                  strMess := GetLangTextFormatDef(idxMain, ['Messages', 'DriveWUsb'], [FirstDriveName], 'The drive (%s) doesn''t seem to exist on this system, it isn''t accessible or is not a USB drive !'#13#10#13#10'Are you sure you want to continue...?')
               else
                  strMess := GetLangTextFormatDef(idxMain, ['Messages', 'Drive'], [FirstDriveName], 'The drive (%s) doesn''t seem to exist on this system or it isn''t accessible !'#13#10#13#10'Are you sure you want to continue...?');
            end;
            if MessageBoxW(0, PWideChar(strMess),
               PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
               MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
               Exit;
         end;

         if AddSecondDrive and (SecondDriveName <> '') then
         begin
            su := FindDriveWithVendorProductSize(SecondDriveName);
            if su = -1 then
            begin
               if ListOnlyUSBDrives then
                  strMess := GetLangTextFormatDef(idxMain, ['Messages', 'SecDriveWUsb'], [SecondDriveName], 'The second drive (%s) doesn''t seem to exist on this system, it isn''t accessible or is not a USB drive !'#13#10#13#10'Are you sure you want to continue...?')
               else
                  strMess := GetLangTextFormatDef(idxMain, ['Messages', 'SecDrive'], [SecondDriveName], 'The second drive (%s) doesn''t seem to exist on this system or it isn''t accessible !'#13#10#13#10'Are you sure you want to continue...?');
               if MessageBoxW(0, PWideChar(strMess),
                  PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                  MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                  Exit;
            end;
         end
         else
            su := -1;

         for i := Byte('A') to Byte('Z') do
         begin
            try
               case GetDriveType(PAnsiChar(Char(i) + ':\')) of
                  DRIVE_REMOVABLE, DRIVE_FIXED:
                     begin
                        try
                           hVolume := CreateFile(PAnsiChar('\\.\' + Char(i) + ':'), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                        except
                           hVolume := INVALID_HANDLE_VALUE;
                        end;
                        if hVolume <> INVALID_HANDLE_VALUE then
                        begin
                           dwBytesReturned := 0;
                           try
                              if DeviceIoControl(hVolume, IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0, @sdn, sizeof(sdn), dwBytesReturned, nil) then
                                 if Integer(sdn.DeviceNumber) = fu then
                                 begin
                                    SetLength(VolumesInfo, Length(VolumesInfo) + 1);
                                    VolumesInfo[High(VolumesInfo)].Letter := Char(i);
                                    VolumesInfo[High(VolumesInfo)].DriveProp := FirstDriveName;
                                 end
                                 else if Integer(sdn.DeviceNumber) = su then
                                 begin
                                    SetLength(VolumesInfo, Length(VolumesInfo) + 1);
                                    VolumesInfo[High(VolumesInfo)].Letter := Char(i);
                                    VolumesInfo[High(VolumesInfo)].DriveProp := SecondDriveName;
                                 end;
                           except
                           end;
                           try
                              CloseHandle(hVolume);
                           except
                           end;
                        end;
                     end
               else
                  Continue;
               end;
            except
            end
         end;

         for i := 0 to High(VolumesInfo) do
         begin
            try
               VolumesInfo[i].Handle := CreateFile(PAnsiChar('\\.\' + VolumesInfo[i].Letter + ':'), GENERIC_READ or GENERIC_WRITE,
                  FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
            except
               VolumesInfo[i].Handle := INVALID_HANDLE_VALUE;
            end;
            if VolumesInfo[i].Handle = INVALID_HANDLE_VALUE then
            begin
               LastError := GetLastError;
               if MessageBoxW(0, PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CantAccessVolume'], [VolumesInfo[i].Letter, VolumesInfo[i].DriveProp, WideSysErrorMessage(LastError)], 'Unable to access volume ''%s'' on "%s" !'#13#10#13#10'System message: %s'#13#10#13#10'Are you sure you want to continue...?')),
                  PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                  MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                  Exit
               else
                  Continue;
            end;
            FlushToDisk(VolumesInfo[i].Handle);
            Sleep(FlushWaitTime);
            if LockVolumes and (not LockVolume(VolumesInfo[i])) and (not ProgressCancelled) and (MessageBoxW(0, PWideChar('Unable to lock volume ''' + VolumesInfo[i].Letter + ''' on "' + VolumesInfo[i].DriveProp + '" !'#13#10#13#10'System message: ' + WideSysErrorMessage(LastError) + #13#10#13#10'Are you sure you want to continue...?'), PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')), MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes) then
               Exit
            else if not DisMountVolume(VolumesInfo[i].Handle) then
               if MessageBoxW(0, PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'UnableDismVolume'], [VolumesInfo[i].Letter, VolumesInfo[i].DriveProp, WideSysErrorMessage(LastError)], 'Unable to dismount volume ''%s'' on "%s" !'#13#10#13#10'System message: %s'#13#10#13#10'Are you sure you want to continue...?')),
                  PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                  MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                  Exit;
         end;
         wereDismounted := True;

         if Ptype = 1 then
         begin
            StartFolder := WideExtractFilePath(ExeQPath);
            if SecondDriveName = '' then
               ComLine := '"' + ExeQPath + '" ' + ' -drive file=\\.\PhysicalDrive' + IntToStr(fu) + ',if=ide,index=0,media=disk,snapshot=off ' + ExeParams
            else
               ComLine := '"' + ExeQPath + '" ' + ' -drive file=\\.\PhysicalDrive' + IntToStr(fu) + ',if=ide,index=0,media=disk,snapshot=off' + ' -drive file=\\.\PhysicalDrive' + IntToStr(su) + ',if=ide,index=1,media=disk,snapshot=off ' + ExeParams;
            if InternalHDD <> '' then
               if WideFileExists(InternalHDD) then
               begin
                  if SecondDriveName = '' then
                     ComLine := ComLine + ' -hdb "' + InternalHDD + '"'
                  else if CDROMName = '' then
                     ComLine := ComLine + ' -hdc "' + InternalHDD + '"'
                  else
                     ComLine := ComLine + ' -hdd "' + InternalHDD + '"';
               end
               else if MessageBoxW(0, PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'UnableFindDevice'], [InternalHDD], 'Unable to find "%s" !'#13#10#13#10'Are you sure you want to continue...?')),
                  PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                  MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                  Exit;
            if CDROMName <> '' then
               if CDROMType = 0 then
               begin
                  CDROMLetter := AnsiChar(CharLower(PAnsiChar(FindCDROMLetter(CDROMName))));
                  if CDROMLetter <> '0' then
                  begin
                     try
                        hVolume := CreateFile(PAnsiChar('\\.\' + CDROMLetter + ':'), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                     except
                        hVolume := INVALID_HANDLE_VALUE;
                     end;
                     if hVolume = INVALID_HANDLE_VALUE then
                     begin
                        if MessageBoxW(0, PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CannotAccessCDROM'], [CDROMName], 'Cannot access the "%s" !'#13#10#13#10'Are you sure you want to continue...?')),
                           PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                           MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                           Exit;
                     end
                     else
                     begin
                        try
                           bSuccess := DeviceIoControl(hVolume, IOCTL_STORAGE_CHECK_VERIFY2, nil, 0, nil, 0, dwBytesRead, nil);
                        except
                           bSuccess := False;
                        end;
                        try
                           CloseHandle(hVolume);
                        except
                        end;
                        if not bSuccess then
                           if MessageBoxW(0, PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CannotAccessMedium'], [CDROMName], 'Cannot access the medium from "%s" !'#13#10#13#10'Are you sure you want to continue...?')),
                              PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                              MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                              Exit;
                     end;
                     ComLine := ComLine + ' -cdrom ' + CDROMLetter + ':';
                  end
                  else if MessageBoxW(0, PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CDROMDoesntExist'], [CDROMName], '"%s" doesn''t exist on this system, it is not mounted or it is not accessible !'#13#10#13#10'Are you sure you want to continue...?')),
                     PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                     MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                     Exit;
               end
               else if WideFileExists(CDROMName) then
                  ComLine := ComLine + ' -cdrom "' + CDROMName + '"'
               else if MessageBoxW(0, PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'UnableFindDevice'], [CDROMName], 'Unable to find "%s" !'#13#10#13#10'Are you sure you want to continue...?')),
                  PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                  MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                  Exit;
            ComLine := ComLine + ' -m ' + IntToStr(Memory);
            case Audio of
               1: ComLine := ComLine + ' -soundhw sb16';
               2: ComLine := ComLine + ' -soundhw pcspk';
               3: ComLine := ComLine + ' -soundhw hda';
               4: ComLine := ComLine + ' -soundhw gus';
               5: ComLine := ComLine + ' -soundhw es1370';
               6: ComLine := ComLine + ' -soundhw cs4231a';
               7: ComLine := ComLine + ' -soundhw adlib';
               8: ComLine := ComLine + ' -soundhw ac97';
            end;
         end
         else
         begin
            StartFolder := WideExtractFilePath(ExeVBPath);
            if (fu >= 0) or (su >= 0) then
            begin
               if AllOK then
               begin
                  errmsg := GetLangTextDef(idxMain, ['Messages', 'UnknownError'], 'unknown error, please report it to the author'#13#10'with a complete description of what you''re doing.');
                  try
                     xmlVBox.LoadFromFile(VMPath);
                  except
                     on E: Exception do
                     begin
                        AllOK := False;
                        errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'PleaseAllowAccess'], [VMPath, E.Message], 'error accessing "%s",'#13#10'please allow access.'#13#10'System message: %s');
                        xmlVBox.Active := False;
                     end;
                  end;
                  xmlVBox.Tag := Integer(xmlVBox.Active);

                  if xmlVBox.Active then
                  begin
                     tms := TMemoryStream.Create;
                     try
                        xmlVBox.SaveToStream(tms);
                        xmlVboxCompare.LoadFromStream(tms);
                     except
                     end;
                     xmlVBoxCompare.Tag := Integer(xmlVBoxCompare.Active);
                     tms.Free;

                     SetLength(vmdkids, 0);
                     SetLength(exvmdks, 0);

                     WarnAboutBoot := 1;

                     with xmlVBox do
                     begin
                        if Tag = 1 then
                           try
                              n1 := ChildNodes.IndexOf('VirtualBox');
                              if n1 = -1 then
                              begin
                                 errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'SectionNotFound'], ['VirtualBox'], '"%s" section not found in the vbox file !'#13#10#13#10'It seems Oracle changed the file format or you have a corrupted file.');
                                 Abort;
                              end
                              else
                              begin
                                 n2 := ChildNodes[n1].ChildNodes.IndexOf('Machine');
                                 if n2 = -1 then
                                 begin
                                    errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'SectionNotFound'], ['Machine'], '"%s" section not found in the vbox file !'#13#10#13#10'It seems Oracle changed the file format or you have a corrupted file.');
                                    Abort;
                                 end
                                 else
                                 begin
                                    a1 := ChildNodes[n1].ChildNodes[n2].AttributeNodes.IndexOf('stateFile');
                                    if a1 > -1 then
                                    begin
                                       MessageBoxW(0,
                                          PWideChar(GetLangTextDef(idxMain, ['Messages', 'SavedStateOpen'], 'It appears this VM is in a saved state so it will not be modified, only started...'#13#10#13#10'Just so you know, it is not a good idea to save the state of a VM with a real drive,'#13#10'because it will increase the risk of corrupting the data from that drive...')),
                                          PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                                          MB_OK or MB_ICONWARNING);
                                       js := True;
                                       Abort;
                                    end;
                                    n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('MediaRegistry');
                                    if n3 = -1 then
                                    begin
                                       errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'SectionNotFound'], ['MediaRegistry'], '"%s" section not found in the vbox file !'#13#10#13#10'It seems Oracle changed the file format or you have a corrupted file.');
                                       Abort;
                                    end
                                    else
                                    begin
                                       n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.IndexOf('HardDisks');
                                       if n4 > -1 then
                                       begin
                                          for i := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.Count - 1 downto 0 do
                                          begin
                                             a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes.IndexOf('format');
                                             if a1 = -1 then
                                                Continue;
                                             if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a1].Text = 'VMDK' then
                                             begin
                                                a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes.IndexOf('location');
                                                if a2 > -1 then
                                                begin
                                                   wp := WideLowerCase(ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a2].Text);
                                                   l := Length(wp);
                                                   if l <> 17 then
                                                      Continue;
                                                   if Pos('vmubdrive', wp) <> 1 then
                                                      Continue;
                                                   if StrToIntDef('$' + Copy(wp, 10, 3), -1) = -1 then
                                                      Continue;
                                                   if Pos('.vmdk', wp) <> 13 then
                                                      Continue;
                                                   a3 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes.IndexOf('uuid');
                                                   if a3 > -1 then
                                                   begin
                                                      if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].ChildNodes.Count > 0 then
                                                      begin
                                                         errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'DividedSnapshots'],
                                                            [ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a2].Text, ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].ChildNodes.Count], 'the content of "%s" is divided into %d snapshot(s).'#13#10'It is not a good idea using snapshots with real drives. But if you really want to at least do this:' +
                                                            #13#10'If you created a snapshot or linked clone this VM you should of manually detached any'#13#10'VMUBDrive***.vmdk drive from the storage controller(s) before the snapshoting/cloning operation.');
                                                         Abort;
                                                      end;
                                                      wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a3].Text;
                                                      wst := Copy(wst, 2, Length(wst) - 2);
                                                      SetLength(vmdkids, Length(vmdkids) + 1);
                                                      vmdkids[High(vmdkids)][1] := wst;
                                                      ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.Delete(i);
                                                      SetLength(vbmComm, Length(vbmComm) + 1);
                                                      vbmComm[High(vbmComm)][1] := 'closemedium disk ' + wst;
                                                      vbmComm[High(vbmComm)][2] := GetLangTextDef(idxMain, ['Messages', 'RemoveDriveOp'], 'removing the drive');
                                                   end;
                                                end;
                                             end;
                                          end;
                                          for i := 0 to ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.Count - 1 do
                                          begin
                                             a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes.IndexOf('uuid');
                                             if a1 > -1 then
                                             begin
                                                wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a1].Text;
                                                SetLength(exvmdks, Length(exvmdks) + 1);
                                                exvmdks[High(exvmdks)] := Copy(wst, 2, Length(wst) - 2);
                                             end;
                                          end;
                                       end;
                                    end;
                                    if Length(vmdkids) > 0 then
                                    begin
                                       n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('StorageControllers');
                                       if n3 > -1 then
                                          for i := 0 to ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count - 1 do
                                             for j := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes.Count - 1 downto 0 do
                                             begin
                                                a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('name');
                                                if a1 > -1 then
                                                   mCName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[a1].Text
                                                else
                                                   mCName := 'IDE';
                                                a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].AttributeNodes.IndexOf('port');
                                                if a2 > -1 then
                                                   mPort := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].AttributeNodes[a2].Text
                                                else
                                                   mPort := '0';
                                                a3 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].AttributeNodes.IndexOf('device');
                                                if a3 > -1 then
                                                   mDevice := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].AttributeNodes[a3].Text
                                                else
                                                   mDevice := '0';
                                                n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].ChildNodes.IndexOf('Image');
                                                if n4 > -1 then
                                                begin
                                                   a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].ChildNodes[n4].AttributeNodes.IndexOf('uuid');
                                                   if a1 > -1 then
                                                   begin
                                                      wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].ChildNodes[n4].AttributeNodes[a1].Text;
                                                      wst := Copy(wst, 2, Length(wst) - 2);
                                                      k := 0;
                                                      while k < Length(vmdkids) do
                                                      begin
                                                         if vmdkids[k][1] = wst then
                                                         begin
                                                            WarnAboutBoot := 0;
                                                            ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes.Delete(j);
                                                            SetLength(vbmComm, Length(vbmComm) + 1);
                                                            for p := High(vbmComm) downto 1 do
                                                               vbmComm[p] := vbmComm[p - 1];

                                                            if (a1 > -1) and (a2 > -1) and (a3 > -1) then
                                                            begin
                                                               vbmComm[0][1] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                                  ' --port ' + mPort + ' --device ' + mDevice + ' --medium none';
                                                               vbmComm[0][2] := GetLangTextDef(idxMain, ['Messages', 'DetachDriveOp'], 'detaching the drive');
                                                            end;
                                                            Break;
                                                         end;
                                                         Inc(k);
                                                      end;
                                                   end;
                                                end;
                                             end;

                                    end;
                                    if ShowVBCPUVirtualizationOption and (VBCPUVirtualization <> 0) then
                                    begin
                                       n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('Hardware');
                                       if n3 > -1 then
                                       begin
                                          VBHardwareVirtualization := False;
                                          n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.IndexOf('CPU');
                                          if n4 > -1 then
                                          begin
                                             n5 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.IndexOf('HardwareVirtEx');
                                             if n5 > -1 then
                                             begin
                                                a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[n5].AttributeNodes.IndexOf('enabled');
                                                VBHardwareVirtualization := (a1 > -1) and (ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[n5].AttributeNodes[a1].Text = 'true');
                                             end;
                                          end;
                                       end;
                                    end;
                                 end;
                              end;
                              AllOK := True;
                           except
                              if errmsg = GetLangTextDef(idxMain, ['Messages', 'UnknownError'], 'unknown error, please report it to the author'#13#10'with a complete description of what you''re doing.') then
                                 errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'BrokenXML'], [VMPath], 'error accessing xml structure from "%s",'#13#10'please repair the file or replace it with a backup copy.');
                              AllOK := False;
                           end;

                        if not AllOK then
                           Active := False;
                        if js then
                           goto juststart;
                     end;

                  end;

                  if AllOK then
                  begin

                     if fu >= 0 then
                     begin
                        if luIDS.fdCID = '' then
                           luIDS.fdCID := GenID;
                        fv := defvmdk[1] + luIDS.fdCID + defvmdk[2];
                        try
                           hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(fu)), GENERIC_READ,
                              FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                        except
                           hDrive := INVALID_HANDLE_VALUE;
                        end;
                        ds := GetDriveSize(hDrive);
                        try
                           CloseHandle(hDrive);
                        except
                        end;
                        if ds = -1 then
                           ds := 4294967296
                        else
                           ds := ds div 512;
                        fuuid := '';
                        if luIDS.fdGUID <> '' then
                           fuuid := luIDS.fdGUID
                        else
                           fuuid := GenGuid;
                        while True do
                        begin
                           i := 0;
                           while i < Length(exvmdks) do
                           begin
                              if exvmdks[i] = fuuid then
                                 Break;
                              Inc(i);
                           end;
                           if i >= Length(exvmdks) then
                              Break;
                           fuuid := GenGuid;
                        end;
                        luIDS.fdGUID := fuuid;
                        SetLength(exvmdks, Length(exvmdks) + 1);
                        exvmdks[High(exvmdks)] := fuuid;
                        fv := fv + IntToStr(ds) + defvmdk[3] + IntToStr(fu) + defvmdk[4] +
                           IntToStr(Min(16383, ds div 1008)) + defvmdk[5] + fuuid + defvmdk[6];
                     end
                     else
                        fv := '';

                     if su >= 0 then
                     begin
                        if luIDS.sdCID = '' then
                           while True do
                           begin
                              luIDS.sdCID := GenID;
                              if luIDS.sdCID <> luIDS.fdCID then
                                 Break;
                           end;
                        sv := defvmdk[1] + luIDS.sdCID + defvmdk[2];
                        try
                           hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(su)), GENERIC_READ,
                              FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                        except
                           hDrive := INVALID_HANDLE_VALUE;
                        end;
                        ds := GetDriveSize(hDrive);
                        try
                           CloseHandle(hDrive);
                        except
                        end;
                        if ds = -1 then
                           ds := 4294967296
                        else
                           ds := ds div 512;
                        suuid := '';
                        if luIDS.sdGUID <> '' then
                           suuid := luIDS.sdGUID
                        else
                           suuid := GenGuid;
                        while True do
                        begin
                           i := 0;
                           while i < Length(exvmdks) do
                           begin
                              if exvmdks[i] = suuid then
                                 Break;
                              Inc(i);
                           end;
                           if i >= Length(exvmdks) then
                              Break;
                           suuid := GenGuid;
                        end;
                        luIDS.sdGUID := suuid;
                        sv := sv + IntToStr(ds) + defvmdk[3] + IntToStr(su) + defvmdk[4] +
                           IntToStr(Min(16383, ds div 1008)) + defvmdk[5] + suuid + defvmdk[6];
                     end
                     else
                        sv := '';

                     isFUSet := fu < 0;
                     isSUSet := su < 0;

                     sf := WideExtractFilePath(VMPath);
                     try
                        if WideFindFirst(sf + 'VMUBDrive???.vmdk', faAnyFile, sr) = 0 then
                        begin
                           repeat
                              try
                                 if StrToIntDef('$' + Copy(sr.Name, 9, 3), -1) <> -1 then
                                 begin
                                    if not isFUSet then
                                    begin
                                       floc := sf + sr.Name;
                                       sVmdk := '';
                                       try
                                          hVmdk := CreateFileW(PWideChar(floc), GENERIC_READ, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                                       except
                                          hVmdk := INVALID_HANDLE_VALUE;
                                       end;
                                       if hVmdk <> INVALID_HANDLE_VALUE then
                                       begin
                                          try
                                             lv := GetFileSize(hVmdk, nil);
                                          except
                                             lv := $FFFFFFFF;
                                          end;
                                          if lv <> $FFFFFFFF then
                                          begin
                                             SetLength(sVmdk, lv);
                                             try
                                                ReadFile(hVmdk, Pointer(sVmdk)^, lv, dwBytesReturned, nil);
                                             except
                                                dwBytesReturned := 0;
                                             end;
                                             if lv = dwBytesReturned then
                                                if Pos(fv, sVmdk) = 1 then
                                                   isFUSet := True;
                                          end;
                                          try
                                             CloseHandle(hVmdk);
                                          except
                                          end;
                                          if not isFUSet then
                                             WideDeleteFile(sf + sr.Name);
                                       end;
                                    end
                                    else if not isSUSet then
                                    begin
                                       sloc := sf + sr.Name;
                                       sVmdk := '';
                                       try
                                          hVmdk := CreateFileW(PWideChar(sloc), GENERIC_READ, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                                       except
                                          hVmdk := INVALID_HANDLE_VALUE;
                                       end;
                                       if hVmdk <> INVALID_HANDLE_VALUE then
                                       begin
                                          try
                                             lv := GetFileSize(hVmdk, nil);
                                          except
                                             lv := $FFFFFFFF;
                                          end;
                                          if lv <> $FFFFFFFF then
                                          begin
                                             SetLength(sVmdk, lv);
                                             try
                                                ReadFile(hVmdk, Pointer(sVmdk)^, lv, dwBytesReturned, nil);
                                             except
                                                dwBytesReturned := 0;
                                             end;
                                             if lv = dwBytesReturned then
                                                if Pos(sv, sVmdk) = 1 then
                                                   isSUSet := True;
                                          end;
                                          try
                                             CloseHandle(hVmdk);
                                          except
                                          end;
                                          if not isSUSet then
                                             WideDeleteFile(sf + sr.Name);
                                       end;
                                    end
                                    else
                                       WideDeleteFile(sf + sr.Name);

                                 end;
                              except
                              end;
                           until WideFindNext(sr) <> 0;
                           WideFindClose(sr);
                        end;
                     except
                     end;

                     if not isFUSet then
                     begin
                        i := 0;
                        while i < 4096 do
                        begin
                           floc := sf + 'VMUBDrive' + IntToHex(i, 3) + '.vmdk';
                           if not WideFileExists(floc) then
                              Break;
                           Inc(i);
                        end;
                        if i < 4096 then
                        begin
                           hVmdk := INVALID_HANDLE_VALUE;
                           try
                              hVmdk := CreateFileW(PWideChar(floc), GENERIC_WRITE, 0, nil, CREATE_ALWAYS, FILE_FLAG_WRITE_THROUGH, 0);
                              if hVmdk <> INVALID_HANDLE_VALUE then
                              begin
                                 lv := Length(fv);
                                 if not WriteFile(hVmdk, Pointer(fv)^, lv, dwBytesReturned, nil) then
                                 begin
                                    LastError := GetLastError;
                                    errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorWriteProtection'], [floc, WideSysErrorMessage(LastError)], 'error writing in "%s",'#13#10'please remove the write protection.'#13#10#13#10'System message: %s');
                                 end
                                 else
                                 begin
                                    try
                                       FlushFileBuffers(hVmdk);
                                    except
                                    end;
                                    if Cardinal(lv) <> dwBytesReturned then
                                    begin
                                       LastError := GetLastError;
                                       errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorSpaceVolume'], [floc, WideExtractFileDrive(floc), WideSysErrorMessage(LastError)], 'error writing in "%s",'#13#10'please free some space or check the volume ''%s'' for errors.'#13#10#13#10'System message: %s');
                                    end
                                    else
                                       isFUSet := True;
                                 end;
                              end
                              else
                              begin
                                 LastError := GetLastError;
                                 errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorWriteProtection'], [floc, WideSysErrorMessage(LastError)], 'error writing in "%s",'#13#10'please remove the write protection.'#13#10#13#10'System message: %s');
                              end;
                           except
                              on E: Exception do
                                 errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorWriteVolume'], [floc, WideExtractFileDrive(floc), E.Message], 'error writing in "%s",'#13#10'please remove the write protection or check the volume ''%s'' for errors.'#13#10'System message: %s');
                           end;
                           try
                              if hVmdk <> INVALID_HANDLE_VALUE then
                                 CloseHandle(hVmdk);
                           except
                           end;
                           Sleep(200);
                        end
                        else
                           errmsg := GetLangTextDef(idxMain, ['Messages', 'UnableFreeInfo'], 'unable to find an unused vmdk file name in'#13#10'"VMUBDrive000..VMUBDriveFFF" range. Please detach and delete the unused ones.'#13#10'You can do that by starting the VirtualBox Manager, then the VirtualBox Media Manager'#13#10#13#10'and deleting one or more VMUBDrive***.vmdk.');
                     end;

                     if not isSUSet then
                     begin
                        i := 0;
                        while i < 4096 do
                        begin
                           sloc := sf + 'VMUBDrive' + IntToHex(i, 3) + '.vmdk';
                           if not WideFileExists(sloc) then
                              Break;
                           Inc(i);
                        end;
                        if i < 4096 then
                        begin
                           hVmdk := INVALID_HANDLE_VALUE;
                           try
                              hVmdk := CreateFileW(PWideChar(sloc), GENERIC_WRITE, 0, nil, CREATE_ALWAYS, FILE_FLAG_WRITE_THROUGH, 0);
                              if hVmdk <> INVALID_HANDLE_VALUE then
                              begin
                                 lv := Length(sv);
                                 if not WriteFile(hVmdk, Pointer(sv)^, lv, dwBytesReturned, nil) then
                                 begin
                                    LastError := GetLastError;
                                    errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorWriteProtection'], [sloc, WideSysErrorMessage(LastError)], 'error writing in "%s",'#13#10'please remove the write protection.'#13#10#13#10'System message: %s');
                                 end
                                 else
                                 begin
                                    try
                                       FlushFileBuffers(hVmdk);
                                    except
                                    end;
                                    if Cardinal(lv) <> dwBytesReturned then
                                    begin
                                       LastError := GetLastError;
                                       errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorSpaceVolume'], [sloc, WideExtractFileDrive(sloc), WideSysErrorMessage(LastError)], 'error writing in "%s",'#13#10'please free some space or check the volume ''%s'' for errors.'#13#10#13#10'System message: %s');
                                    end
                                    else
                                       isSUSet := True;
                                 end;
                              end
                              else
                              begin
                                 LastError := GetLastError;
                                 errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorWriteProtection'], [sloc, WideSysErrorMessage(LastError)], 'error writing in "%s",'#13#10'please remove the write protection.'#13#10#13#10'System message: %s');
                              end;
                           except
                              on E: Exception do
                                 errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorWriteVolume'], [sloc, WideExtractFileDrive(sloc), E.Message], 'error writing in "%s",'#13#10'please remove the write protection or check the volume ''%s'' for errors.'#13#10'System message: %s');
                           end;
                           try
                              if hVmdk <> INVALID_HANDLE_VALUE then
                                 CloseHandle(hVmdk);
                           except
                           end;
                           Sleep(200);
                        end
                        else
                           errmsg := GetLangTextDef(idxMain, ['Messages', 'UnableFreeInfo'], 'unable to find an unused vmdk file name in'#13#10'"VMUBDrive000..VMUBDriveFFF" range. Please detach and delete the unused ones.'#13#10'You can do that by starting the VirtualBox Manager, then the VirtualBox Media Manager'#13#10#13#10'and deleting one or more VMUBDrive***.vmdk.');
                     end;

                     AllOK := isFUSet and isSUSet;

                     if AllOK then
                     begin
                        errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'BrokenXML'], [VMPath], 'error accessing xml structure from "%s",'#13#10'please repair the file or replace it with a backup copy.');
                        with xmlVBox do
                        begin
                           if Tag = 1 then
                              try
                                 n1 := ChildNodes.IndexOf('VirtualBox');
                                 if n1 = -1 then
                                 begin
                                    errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'SectionNotFound'], ['VirtualBox'], '"%s" section not found in the vbox file !'#13#10#13#10'It seems Oracle changed the file format or you have a corrupted file.');
                                    Abort;
                                 end
                                 else
                                 begin
                                    n2 := ChildNodes[n1].ChildNodes.IndexOf('Machine');
                                    if n2 = -1 then
                                    begin
                                       errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'SectionNotFound'], ['Machine'], '"%s" section not found in the vbox file !'#13#10#13#10'It seems Oracle changed the file format or you have a corrupted file.');
                                       Abort;
                                    end
                                    else
                                    begin
                                       n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('MediaRegistry');
                                       if n3 = -1 then
                                       begin
                                          errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'SectionNotFound'], ['MediaRegistry'], '"%s" section not found in the vbox file !'#13#10#13#10'It seems Oracle changed the file format or you have a corrupted file.');
                                          Abort;
                                       end
                                       else
                                       begin
                                          n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.IndexOf('HardDisks');
                                          if n4 > -1 then
                                          begin
                                             if fu >= 0 then
                                                with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].AddChild('HardDisk') do
                                                begin
                                                   SetAttribute('uuid', '{' + fuuid + '}');
                                                   SetAttribute('location', WideExtractFileName(floc));
                                                   SetAttribute('format', 'VMDK');
                                                   SetAttribute('type', 'Normal');
                                                end;
                                             if su >= 0 then
                                                with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].AddChild('HardDisk') do
                                                begin
                                                   SetAttribute('uuid', '{' + suuid + '}');
                                                   SetAttribute('location', WideExtractFileName(sloc));
                                                   SetAttribute('format', 'VMDK');
                                                   SetAttribute('type', 'Normal');
                                                end;
                                          end;
                                       end;
                                       n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('StorageControllers');
                                       isFUSet := fu < 0;
                                       isSUSet := su < 0;
                                       if n3 > -1 then
                                          if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count > 0 then
                                          begin
                                             for sc := 0 to ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count - 1 do
                                             begin
                                                if isFUSet and isSUSet then
                                                   Break;
                                                a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes.IndexOf('name');
                                                if a2 > -1 then
                                                   mCName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes[a2].Text
                                                else
                                                   mCName := 'IDE';
                                                isLastC := sc = (ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count - 1);
                                                if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes.Count = 0 then
                                                begin
                                                   a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes.IndexOf('PortCount');
                                                   p := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes[a1].NodeValue;
                                                   if (fu >= 0) and (not isFUSet) then
                                                      if (ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes.Count + 1) > p then
                                                      begin
                                                         if isLastC then
                                                         begin
                                                            if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count = 1 then
                                                               errmsg := GetLangTextDef(idxMain, ['Messages', 'FreePortAdvice'], 'unable to find a free port in the storage controller in the VirtualBox VM,'#13#10'please free one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and increasing the Port Count of the storage controller.')
                                                            else
                                                               errmsg := GetLangTextDef(idxMain, ['Messages', 'FreePort'], 'unable to find a free port in the storage controllers in the VirtualBox VM,'#13#10'please free one and try again.');
                                                            Abort;
                                                         end
                                                         else
                                                            Continue;
                                                      end
                                                      else
                                                      begin
                                                         a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes.Count;
                                                         with xmlVBox.ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AddChild('AttachedDevice') do
                                                         begin
                                                            SetAttribute('type', 'HardDisk');
                                                            SetAttribute('port', IntToStr(a2));
                                                            SetAttribute('device', '0');
                                                            with AddChild('Image') do
                                                               SetAttribute('uuid', '{' + fuuid + '}');
                                                         end;
                                                         SetLength(vbmComm, Length(vbmComm) + 1);
                                                         vbmComm[High(vbmComm)][1] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                            ' --port ' + IntToStr(a2) + ' --device 0 --type hdd --medium "' + floc + '"';
                                                         vbmComm[High(vbmComm)][2] := GetLangTextDef(idxMain, ['Messages', 'AttachDriveOp'], 'attaching the drive');
                                                      end;
                                                   if (su >= 0) and (not isSUSet) then
                                                      if (ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes.Count + 1) > p then
                                                      begin
                                                         if isLastC then
                                                         begin
                                                            if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count = 1 then
                                                               errmsg := GetLangTextDef(idxMain, ['Messages', 'FreePortAdvice'], 'unable to find a free port in the storage controller in the VirtualBox VM,'#13#10'please free one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and increasing the Port Count of the storage controller.')
                                                            else
                                                               errmsg := GetLangTextDef(idxMain, ['Messages', 'FreePort'], 'unable to find a free port in the storage controllers in the VirtualBox VM,'#13#10'please free one and try again.');
                                                            Abort;
                                                         end
                                                         else
                                                            Continue;
                                                      end
                                                      else
                                                      begin
                                                         a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes.Count;
                                                         with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AddChild('AttachedDevice') do
                                                         begin
                                                            SetAttribute('type', 'HardDisk');
                                                            SetAttribute('port', IntToStr(a2));
                                                            SetAttribute('device', '0');
                                                            with AddChild('Image') do
                                                               SetAttribute('uuid', '{' + suuid + '}');
                                                         end;
                                                         SetLength(vbmComm, Length(vbmComm) + 1);
                                                         vbmComm[High(vbmComm)][1] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                            ' --port ' + IntToStr(a2) + ' --device 0 --type hdd --medium "' + sloc + '"';
                                                         vbmComm[High(vbmComm)][2] := GetLangTextDef(idxMain, ['Messages', 'AttachDriveOp'], 'attaching the drive');
                                                      end;
                                                   Break;
                                                end
                                                else
                                                begin
                                                   SetLength(ahs, 0);
                                                   for i := 0 to ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes.Count - 1 do
                                                   begin
                                                      a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes[i].AttributeNodes.IndexOf('port');
                                                      a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes[i].AttributeNodes.IndexOf('device');
                                                      a3 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes[i].AttributeNodes.IndexOf('type');
                                                      if (a1 > -1) and (a2 > -1) and (a3 > -1) then
                                                      begin
                                                         SetLength(ahs, Length(ahs) + 1);
                                                         ahs[High(ahs)][0] := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes[i].AttributeNodes[a1].NodeValue;
                                                         ahs[High(ahs)][1] := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes[i].AttributeNodes[a2].NodeValue;
                                                         ahs[High(ahs)][2] := Integer(ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].ChildNodes[i].AttributeNodes[a3].Text = 'HardDisk');
                                                      end;
                                                   end;
                                                   a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes.IndexOf('type');
                                                   if a1 > -1 then
                                                   begin
                                                      wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes[a1].Text;
                                                      if (wst = 'PIIX3') or (wst = 'PIIX4') or (wst = 'ICH6') then
                                                      begin
                                                         a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes.IndexOf('PortCount');
                                                         p := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes[a1].NodeValue;
                                                         if (fu >= 0) and (not isFUSet) then
                                                         begin
                                                            if Length(ahs) < (2 * p) then
                                                            begin
                                                               i := 0;
                                                               j := 0;
                                                               BreakCycles := False;
                                                               while i < p do
                                                               begin
                                                                  j := 0;
                                                                  while j < p do
                                                                  begin
                                                                     k := 0;
                                                                     while k < Length(ahs) do
                                                                     begin
                                                                        if (ahs[k][0] = i) and (ahs[k][1] = j) then
                                                                           Break;
                                                                        Inc(k);
                                                                     end;
                                                                     if k >= Length(ahs) then
                                                                     begin
                                                                        BreakCycles := True;
                                                                        Break;
                                                                     end
                                                                     else if WarnAboutBoot = 1 then
                                                                        if ahs[k][2] = 1 then
                                                                           WarnAboutBoot := 2;
                                                                     Inc(j);
                                                                  end;
                                                                  if BreakCycles then
                                                                     Break;
                                                                  Inc(i);
                                                               end;

                                                               with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AddChild('AttachedDevice') do
                                                               begin
                                                                  SetAttribute('type', 'HardDisk');
                                                                  SetAttribute('port', IntToStr(i));
                                                                  SetAttribute('device', IntToStr(j));
                                                                  with AddChild('Image') do
                                                                     SetAttribute('uuid', '{' + fuuid + '}');
                                                                  SetLength(ahs, Length(ahs) + 1);
                                                                  ahs[High(ahs)][0] := i;
                                                                  ahs[High(ahs)][1] := j;
                                                                  isFUSet := True;
                                                               end;
                                                               SetLength(vbmComm, Length(vbmComm) + 1);
                                                               vbmComm[High(vbmComm)][1] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                                  ' --port ' + IntToStr(i) + ' --device ' + IntToStr(j) + ' --type hdd --medium "' + floc + '"';
                                                               vbmComm[High(vbmComm)][2] := GetLangTextDef(idxMain, ['Messages', 'AttachDriveOp'], 'attaching the drive');
                                                            end
                                                            else
                                                            begin
                                                               if isLastC then
                                                               begin
                                                                  if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count = 1 then
                                                                     errmsg := GetLangTextDef(idxMain, ['Messages', 'FreePortAdviceIde'], 'unable to find a free port in the storage controller in the VirtualBox VM,'#13#10'please free one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and deleting one or more drives from the IDE controller.')
                                                                  else
                                                                     errmsg := GetLangTextDef(idxMain, ['Messages', 'FreePort'], 'unable to find a free port in the storage controllers in the VirtualBox VM,'#13#10'please free one and try again.');
                                                                  Abort;
                                                               end
                                                               else
                                                                  Continue;
                                                            end;
                                                         end;
                                                         if (su >= 0) and (not isSUSet) then
                                                         begin
                                                            if Length(ahs) < (2 * p) then
                                                            begin
                                                               i := 0;
                                                               j := 0;
                                                               BreakCycles := False;
                                                               while i < p do
                                                               begin
                                                                  j := 0;
                                                                  while j < p do
                                                                  begin
                                                                     k := 0;
                                                                     while k < Length(ahs) do
                                                                     begin
                                                                        if (ahs[k][0] = i) and (ahs[k][1] = j) then
                                                                           Break;
                                                                        Inc(k);
                                                                     end;
                                                                     if k >= Length(ahs) then
                                                                     begin
                                                                        BreakCycles := True;
                                                                        Break;
                                                                     end;
                                                                     Inc(j);
                                                                  end;
                                                                  if BreakCycles then
                                                                     Break;
                                                                  Inc(i);
                                                               end;
                                                               with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AddChild('AttachedDevice') do
                                                               begin
                                                                  SetAttribute('type', 'HardDisk');
                                                                  SetAttribute('port', IntToStr(i));
                                                                  SetAttribute('device', IntToStr(j));
                                                                  with AddChild('Image') do
                                                                     SetAttribute('uuid', '{' + suuid + '}');
                                                                  isSUSet := True;
                                                               end;
                                                               SetLength(vbmComm, Length(vbmComm) + 1);
                                                               vbmComm[High(vbmComm)][1] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                                  ' --port ' + IntToStr(i) + ' --device ' + IntToStr(j) + ' --type hdd --medium "' + sloc + '"';
                                                               vbmComm[High(vbmComm)][2] := GetLangTextDef(idxMain, ['Messages', 'AttachDriveOp'], 'attaching the drive');
                                                            end
                                                            else
                                                            begin
                                                               if isLastC then
                                                               begin
                                                                  if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count = 1 then
                                                                     errmsg := GetLangTextDef(idxMain, ['Messages', 'FreePortAdviceIde'], 'unable to find a free port in the storage controller in the VirtualBox VM,'#13#10'please free one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and deleting one or more drives from the IDE controller.')
                                                                  else
                                                                     errmsg := GetLangTextDef(idxMain, ['Messages', 'FreePort'], 'unable to find a free port in the storage controllers in the VirtualBox VM,'#13#10'please free one and try again.');
                                                                  Abort;
                                                               end
                                                               else
                                                                  Continue;
                                                            end;
                                                         end;
                                                      end
                                                      else
                                                      begin
                                                         a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes.IndexOf('PortCount');
                                                         p := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AttributeNodes[a1].NodeValue;

                                                         if (fu >= 0) and (not isFUSet) then
                                                         begin
                                                            i := 0;
                                                            BreakCycles := False;
                                                            while i < p do
                                                            begin
                                                               j := 0;
                                                               while j < Length(ahs) do
                                                               begin
                                                                  if ahs[j][0] = i then
                                                                     Break;
                                                                  Inc(j);
                                                               end;
                                                               if j >= Length(ahs) then
                                                               begin
                                                                  BreakCycles := True;
                                                                  Break;
                                                               end
                                                               else if WarnAboutBoot = 1 then
                                                                  if ahs[j][2] = 1 then
                                                                     WarnAboutBoot := 2;
                                                               Inc(i);
                                                            end;
                                                            if not BreakCycles then
                                                            begin
                                                               if isLastC then
                                                               begin
                                                                  if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count = 1 then
                                                                     errmsg := GetLangTextDef(idxMain, ['Messages', 'FreePortAdvice'], 'unable to find a free port in the storage controller in the VirtualBox VM,'#13#10'please free one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and increasing the Port Count of the storage controller.')
                                                                  else
                                                                     errmsg := GetLangTextDef(idxMain, ['Messages', 'FreePort'], 'unable to find a free port in the storage controllers in the VirtualBox VM,'#13#10'please free one and try again.');
                                                                  Abort;
                                                               end
                                                               else
                                                                  Continue;
                                                            end
                                                            else
                                                            begin
                                                               with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AddChild('AttachedDevice') do
                                                               begin
                                                                  SetAttribute('type', 'HardDisk');
                                                                  SetAttribute('port', IntToStr(i));
                                                                  SetAttribute('device', '0');
                                                                  with AddChild('Image') do
                                                                     SetAttribute('uuid', '{' + fuuid + '}');
                                                                  SetLength(ahs, Length(ahs) + 1);
                                                                  ahs[High(ahs)][0] := i;
                                                                  ahs[High(ahs)][1] := 0;
                                                                  isFUSet := True;
                                                               end;
                                                               SetLength(vbmComm, Length(vbmComm) + 1);
                                                               vbmComm[High(vbmComm)][1] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                                  ' --port ' + IntToStr(i) + ' --device 0 --type hdd --medium "' + floc + '"';
                                                               vbmComm[High(vbmComm)][2] := GetLangTextDef(idxMain, ['Messages', 'AttachDriveOp'], 'attaching the drive');
                                                            end;
                                                         end;

                                                         if (su >= 0) and (not isSUSet) then
                                                         begin
                                                            i := 0;
                                                            BreakCycles := False;
                                                            while i < p do
                                                            begin
                                                               j := 0;
                                                               while j < Length(ahs) do
                                                               begin
                                                                  if ahs[j][0] = i then
                                                                     Break;
                                                                  Inc(j);
                                                               end;
                                                               if j >= Length(ahs) then
                                                               begin
                                                                  BreakCycles := True;
                                                                  Break;
                                                               end;
                                                               Inc(i);
                                                            end;
                                                            if not BreakCycles then
                                                            begin
                                                               if isLastC then
                                                               begin
                                                                  if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count = 1 then
                                                                     errmsg := GetLangTextDef(idxMain, ['Messages', 'FreePortAdvice'], 'unable to find a free port in the storage controller in the VirtualBox VM,'#13#10'please free one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and increasing the Port Count of the storage controller.')
                                                                  else
                                                                     errmsg := GetLangTextDef(idxMain, ['Messages', 'FreePort'], 'unable to find a free port in the storage controllers in the VirtualBox VM,'#13#10'please free one and try again.');
                                                                  Abort;
                                                               end
                                                               else
                                                                  Continue;
                                                            end
                                                            else
                                                            begin
                                                               with ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[sc].AddChild('AttachedDevice') do
                                                               begin
                                                                  SetAttribute('type', 'HardDisk');
                                                                  SetAttribute('port', IntToStr(i));
                                                                  SetAttribute('device', '0');
                                                                  with AddChild('Image') do
                                                                     SetAttribute('uuid', '{' + suuid + '}');
                                                                  isSUSet := True;
                                                               end;
                                                               SetLength(vbmComm, Length(vbmComm) + 1);
                                                               vbmComm[High(vbmComm)][1] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                                  ' --port ' + IntToStr(i) + ' --device 0 --type hdd --medium "' + sloc + '"';
                                                               vbmComm[High(vbmComm)][2] := GetLangTextDef(idxMain, ['Messages', 'AttachDriveOp'], 'attaching the drive');
                                                            end;
                                                         end;
                                                      end;
                                                   end;
                                                end;

                                             end;
                                          end
                                          else
                                          begin
                                             errmsg := GetLangTextDef(idxMain, ['Messages', 'NoStorageAdvice'], 'unable to find a storage controller in the VirtualBox VM,'#13#10'please add one and try again.'#13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and adding a storage controller.');
                                             Abort;
                                          end;
                                       if ShowVBCPUVirtualizationOption and (VBCPUVirtualization <> 0) and ((UpdateVM = 2) or ((UpdateVM = 0) and (not useVBMU))) then
                                       begin
                                          n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('Hardware');
                                          if n3 > -1 then
                                          begin
                                             n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.IndexOf('CPU');
                                             if n4 = -1 then
                                             begin
                                                ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AddChild('CPU');
                                                n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count - 1;
                                             end;
                                             n5 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.IndexOf('HardwareVirtEx');
                                             if n5 = -1 then
                                             begin
                                                ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].AddChild('HardwareVirtEx');
                                                n5 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.Count - 1;
                                             end;
                                             if ((VBCPUVirtualization = 1) and (not VBHardwareVirtualization)) or ((VBCPUVirtualization = 3) and (not VBHardwareVirtualization)) then
                                                ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[n5].SetAttribute('enabled', 'true')
                                             else if ((VBCPUVirtualization = 2) and VBHardwareVirtualization) or ((VBCPUVirtualization = 3) and VBHardwareVirtualization) then
                                                ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[n5].SetAttribute('enabled', 'false');
                                          end;
                                       end;
                                    end;
                                 end;

                                 AllOK := True;
                              except
                                 AllOK := False;
                              end;

                           if AllOK then
                              if WarnAboutBoot = 2 then
                                 if AddSecondDrive then
                                 begin
                                    if MessageBoxW(0, PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'WarnBootFirstDrive'], [FirstDriveName], 'It seems this VM won''t be able to boot from the first drive (%s)'#13#10'because other drive(s) is/are attached to the storage controller in prior position(s).'#13#10#13#10'My advice is to free a port in the storage controller before the other drive(s).' +
                                       #13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and moving the other drive(s) into subsequent port(s) in the storage controller.'#13#10#13#10'Are you sure you want to continue...?')),
                                       PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                                       MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYES then
                                       Exit;
                                 end
                                 else if MessageBoxW(0, PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'WarnBootDrive'], [FirstDriveName], 'It seems this VM won''t be able to boot from the drive (%s)'#13#10'because other drive(s) is/are attached to the storage controller in prior position(s).'#13#10#13#10'My advice is to free a port in the storage controller before the other drive(s).' +
                                    #13#10'You can do that by starting the VirtualBox Manager, editing the VM''s storage options'#13#10'and moving the other drive(s) into subsequent port(s) in the storage controller.'#13#10#13#10'Are you sure you want to continue...?')),
                                    PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                                    MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYES then
                                    Exit;

                           if not AllOK then
                              Active := False
                           else
                           begin
                              if ShowVBCPUVirtualizationOption and (VBCPUVirtualization <> 0) and (UpdateVM = 1) or ((UpdateVM = 0) and useVBMU) then
                              begin
                                 DoChange := False;
                                 if ((VBCPUVirtualization = 1) and (not VBHardwareVirtualization)) or ((VBCPUVirtualization = 3) and (not VBHardwareVirtualization)) then
                                 begin
                                    DoChange := True;
                                    VBHardwareVirtualization := True;
                                 end
                                 else if ((VBCPUVirtualization = 2) and VBHardwareVirtualization) or ((VBCPUVirtualization = 3) and VBHardwareVirtualization) then
                                 begin
                                    DoChange := True;
                                    VBHardwareVirtualization := False;
                                 end;
                                 if DoChange then
                                 begin
                                    if WaitForVBSVC then
                                    begin
                                       try
                                          GetProCessList;
                                          j := 0;
                                          l := Length(ProcessInfo);
                                          while j < l do
                                          begin
                                             if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                                if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                                   if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                                      Break;
                                             Inc(j);
                                          end;
                                          if j < l then
                                          begin
                                             j := 0;
                                             while j < l do
                                             begin
                                                if ProcessInfo[j].WClass = 'QWidget' then
                                                   if IsWindowVisible(ProcessInfo[j].Handle) then
                                                      if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'virtualbox.exe' then
                                                         Break;
                                                Inc(j);
                                             end;
                                             if j >= l then
                                             begin
                                                hVBoxSVC := ProcessInfo[j].Handle;
                                                ShowingProgress := False;
                                                try
                                                   if frmProgress = nil then
                                                      Application.CreateForm(TfrmProgress, frmProgress);
                                                   with frmProgress do
                                                   begin
                                                      lblMessage.Caption := GetLangTextDef(idxMain, ['Messages', 'WaitingVBSVCToClose'], 'Waiting for "VBoxSVC.exe" (a VirtualBox component) to close...');
                                                      btnCancel.Caption := GetLangTextDef(idxMain, ['Messages', 'CancelHide'], 'Hide');
                                                      pbProgress.Max := 200 + 200 * Integer(VBSVC2x);
                                                      Show;
                                                   end;
                                                   Application.ProcessMessages;
                                                   ShowingProgress := True;
                                                except
                                                   if frmProgress.Visible then
                                                      frmProgress.Close;
                                                   frmProgress.Free;
                                                   frmProgress := nil;
                                                end;
                                                i := 1;
                                                while i <= (200 + 200 * Integer(VBSVC2x)) do
                                                begin
                                                   Sleep(35);
                                                   if ShowingProgress then
                                                   begin
                                                      frmProgress.pbProgress.Position := i;
                                                      Application.ProcessMessages;
                                                   end;
                                                   isRightWin := True;
                                                   isWin := IsWindow(hVBoxSVC);
                                                   if isWin then
                                                   begin
                                                      GetWindowTextW(hVBoxSVC, tres, 255);
                                                      if tres <> 'VBoxPowerNotifyClass' then
                                                         isRightWin := False
                                                      else
                                                      begin
                                                         GetClassNameW(hVBoxSVC, tres, 255);
                                                         if tres <> 'VBoxPowerNotifyClass' then
                                                            isRightWin := False;
                                                      end;
                                                   end;
                                                   if (not isWin) or (not isRightWin) then
                                                   begin
                                                      GetProCessList;
                                                      j := 0;
                                                      l := Length(ProcessInfo);
                                                      while j < l do
                                                      begin
                                                         if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                                            if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                                               if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                                                  Break;
                                                         Inc(j);
                                                      end;
                                                      if j < l then
                                                         hVBoxSVC := ProcessInfo[j].Handle
                                                      else
                                                      begin
                                                         Sleep(100);
                                                         Break;
                                                      end;
                                                   end;
                                                   Inc(i);
                                                end;
                                                if ShowingProgress then
                                                   try
                                                      if frmProgress.Visible then
                                                         frmProgress.Close;
                                                      frmProgress.Free;
                                                      frmProgress := nil;
                                                   except
                                                   end;
                                             end;
                                          end;
                                       except
                                       end;
                                       AlreadyWaitedForVBSVC := True;
                                       if WideFileExists(svcPath) then
                                          try
                                             GetProCessList;
                                             j := 0;
                                             l := Length(ProcessInfo);
                                             while j < l do
                                             begin
                                                if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                                   if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                                      if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                                         Break;
                                                if ProcessInfo[j].WClass = 'QWidget' then
                                                   if IsWindowVisible(ProcessInfo[j].Handle) then
                                                      if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'virtualbox.exe' then
                                                         Break;
                                                Inc(j);
                                             end;
                                             if j >= l then
                                             begin
                                                l := Min(Length(svcPath), 512);
                                                for j := 1 to l do
                                                   zSVC[j - 1] := svcPath[j];
                                                for j := l + 1 to SizeOf(zSVC) do
                                                   zSVC[j - 1] := #0;
                                                FillChar(svcStartupInfo, SizeOf(svcStartupInfo), #0);
                                                svcStartupInfo.cb := SizeOf(svcStartupInfo);
                                                svcStartupInfo.dwFlags := STARTF_USESHOWWINDOW;
                                                svcStartupInfo.wShowWindow := SW_HIDE;
                                                StartFolder := WideExtractFilePath(ExeVBPath);
                                                if StartFolder <> '' then
                                                   PStartFolder := PWideChar(StartFolder)
                                                else
                                                   PStartFolder := nil;
                                                if CreateProcessW(nil,
                                                   zSVC,
                                                   nil,
                                                   nil,
                                                   False,
                                                   DETACHED_PROCESS or
                                                   NORMAL_PRIORITY_CLASS,
                                                   nil,
                                                   PStartFolder,
                                                   svcStartupInfo,
                                                   svcProcessInfo) then
                                                   svcAlreadyStarted := True;
                                             end;
                                          except
                                          end;
                                    end;
                                    if VBHardwareVirtualization then
                                       sJob := 'modifyvm ' + VMID + ' --hwvirtex on'
                                    else
                                       sJob := 'modifyvm ' + VMID + ' --hwvirtex off';
                                    ComLine := vbmPath + ' ' + sJob;
                                    l := Min(Length(ComLine), 512);
                                    for j := 1 to l do
                                       zVBM[j - 1] := ComLine[j];
                                    for j := l + 1 to SizeOf(zVBM) do
                                       zVBM[j - 1] := #0;
                                    FillChar(vbmStartupInfo, Sizeof(vbmStartupInfo), #0);
                                    vbmStartupInfo.cb := Sizeof(vbmStartupInfo);
                                    vbmStartupInfo.dwFlags := STARTF_USESHOWWINDOW;
                                    vbmStartupInfo.wShowWindow := SW_HIDE;
                                    StartFolder := WideExtractFilePath(ExeVBPath);
                                    if StartFolder <> '' then
                                       PStartFolder := PWideChar(StartFolder)
                                    else
                                       PStartFolder := nil;
                                    if CreateProcessW(nil,
                                       zVBM,
                                       nil,
                                       nil,
                                       False,
                                       DETACHED_PROCESS or
                                       HIGH_PRIORITY_CLASS,
                                       nil,
                                       PStartFolder,
                                       vbmStartupInfo,
                                       vbmProcessInfo) then
                                    begin
                                       if WaitForSingleObject(vbmProcessInfo.hProcess, 3000) = WAIT_TIMEOUT then
                                       begin
                                          errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorVBMan'], [GetLangTextDef(idxMain, ['Messages', 'HardwareVirtOp'], 'changing hardware virtualization'), sJob], 'Out of time waiting for VBoxManage.exe to finish the current job (%s) !'#13#10#13#10'Job = %s'#13#10#13#10'This is a VirtualBox bug. My advice is to wait 20..30 seconds and try again...');
                                          AllOK := False;
                                       end;
                                       if AllOK then
                                       begin
                                          ExitCode := 9999;
                                          try
                                             GetExitCodeProcess(vbmProcessInfo.hProcess, ExitCode);
                                          except
                                          end;
                                          if ExitCode > 0 then
                                          begin
                                             AllOK := False;
                                             if ExitCode <> 9999 then
                                                errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'VBManErrorCode'], [ExitCode, GetLangTextDef(idxMain, ['Messages', 'HardwareVirtOp'], 'changing hardware virtualization'), sJob], 'VBoxManage.exe returned error code %d for the current job (%s) !'#13#10#13#10'Job = %s')
                                             else
                                                errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'VBManExitError'], [GetLangTextDef(idxMain, ['Messages', 'HardwareVirtOp'], 'changing hardware virtualization'), sJob], 'Error getting the exit code for the current VBoxManage job (%s) !'#13#10#13#10'Job = %s');
                                          end;
                                       end;
                                       try
                                          CloseHandle(vbmProcessInfo.hProcess);
                                          CloseHandle(vbmProcessInfo.hThread);
                                       except
                                       end;
                                    end
                                    else
                                    begin
                                       LastError := GetLastError;
                                       errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'VBManUnableLaunch'], [WideSysErrorMessage(LastError)], 'Unable to launch VBoxManage.exe !'#13#10#13#10'System message: %s');
                                       AllOK := False;
                                    end;
                                 end;
                              end;

                              if AllOK and ((xmlVBoxCompare.Tag = 0) or areDifferent(xmlVBox.DocumentElement, xmlVBoxCompare.DocumentElement)) then
                              begin
                                 if (UpdateVM = 2) or ((UpdateVM = 0) and (not useVBMU)) then
                                 begin
                                    try
                                       if WideFileExists(VMPath + '-prev') then
                                       begin
                                          attr := GetFileAttributesW(PWideChar(VMPath + '-prev'));
                                          if attr <> $FFFFFFFF then
                                          begin
                                             if SetFileAttributesW(PWideChar(VMPath + '-prev'), attr - FILE_ATTRIBUTE_READONLY) then
                                                if WideDeleteFile(VMPath + '-prev') then
                                                   if WideRenameFile(VMPath, VMPath + '-prev') then
                                                      SetFileAttributesW(PWideChar(VMPath + '-prev'), attr);
                                          end;
                                       end
                                       else
                                       begin
                                          if WideRenameFile(VMPath, VMPath + '-prev') then
                                             SetFileAttributesW(PWideChar(VMPath + '-prev'), FILE_ATTRIBUTE_READONLY);
                                       end;
                                    except
                                    end;
                                    try
                                       sVbox := XML.Text;
                                       hVbox := CreateFileW(PWideChar(FileName), GENERIC_WRITE, 0, nil, CREATE_ALWAYS, FILE_FLAG_WRITE_THROUGH, 0);
                                       if hVbox <> INVALID_HANDLE_VALUE then
                                       begin
                                          if not WriteFile(hVbox, Pointer(sVbox)^, Length(sVbox), dwBytesReturned, nil) then
                                          begin
                                             LastError := GetLastError;
                                             errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorWriteProtection'], [FileName, WideSysErrorMessage(LastError)], 'error writing in "%s",'#13#10'please remove the write protection.'#13#10#13#10'System message: %s');
                                             AllOK := False;
                                          end
                                          else
                                          begin
                                             try
                                                FlushFileBuffers(hVbox);
                                             except
                                             end;
                                             if Cardinal(Length(sVbox)) <> dwBytesReturned then
                                             begin
                                                LastError := GetLastError;
                                                errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorSpaceVolume'], [FileName, WideSysErrorMessage(LastError)], 'error writing in "%s",'#13#10'please free some space or check the volume ''%s'' for errors.'#13#10#13#10'System message: %s');
                                                AllOK := False;
                                             end
                                             else
                                                AllOK := True;
                                          end;
                                       end
                                       else
                                       begin
                                          LastError := GetLastError;
                                          GetLangTextFormatDef(idxMain, ['Messages', 'ErrorWriteProtection'], [FileName, WideSysErrorMessage(LastError)], 'error writing in "%s",'#13#10'please remove the write protection.'#13#10#13#10'System message: %s');
                                          AllOK := False;
                                       end;
                                    except
                                       on E: Exception do
                                       begin
                                          AllOK := False;
                                          errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorWriteVolume'], [FileName, E.Message], 'error writing in "%s",'#13#10'please remove the write protection or check the volume ''%s'' for errors.'#13#10'System message: %s');
                                       end;
                                    end;
                                    try
                                       if hVbox <> INVALID_HANDLE_VALUE then
                                          CloseHandle(hVbox);
                                    except
                                    end;
                                    Sleep(200);
                                    Active := False;
                                 end
                                 else
                                 begin
                                    if Active then
                                       Active := False;
                                    if WaitForVBSVC then
                                    begin
                                       if not AlreadyWaitedForVBSVC then
                                       begin
                                          try
                                             GetProCessList;
                                             j := 0;
                                             l := Length(ProcessInfo);
                                             while j < l do
                                             begin
                                                if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                                   if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                                      if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                                         Break;
                                                Inc(j);
                                             end;
                                             if j < l then
                                             begin
                                                j := 0;
                                                while j < l do
                                                begin
                                                   if ProcessInfo[j].WClass = 'QWidget' then
                                                      if IsWindowVisible(ProcessInfo[j].Handle) then
                                                         if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'virtualbox.exe' then
                                                            Break;
                                                   Inc(j);
                                                end;
                                                if j >= l then
                                                begin
                                                   hVBoxSVC := ProcessInfo[j].Handle;
                                                   ShowingProgress := False;
                                                   try
                                                      if frmProgress = nil then
                                                         Application.CreateForm(TfrmProgress, frmProgress);
                                                      with frmProgress do
                                                      begin
                                                         lblMessage.Caption := GetLangTextDef(idxMain, ['Messages', 'WaitingVBSVCToClose'], 'Waiting for "VBoxSVC.exe" (a VirtualBox component) to close...');
                                                         btnCancel.Caption := GetLangTextDef(idxMain, ['Messages', 'CancelHide'], 'Hide');
                                                         pbProgress.Max := 200 + 200 * Integer(VBSVC2x);
                                                         Show;
                                                      end;
                                                      Application.ProcessMessages;
                                                      ShowingProgress := True;
                                                   except
                                                      if frmProgress.Visible then
                                                         frmProgress.Close;
                                                      frmProgress.Free;
                                                      frmProgress := nil;
                                                   end;
                                                   i := 1;
                                                   while i <= (200 + 200 * Integer(VBSVC2x)) do
                                                   begin
                                                      Sleep(35);
                                                      if ShowingProgress and frmProgress.Visible then
                                                      begin
                                                         frmProgress.pbProgress.Position := i;
                                                         Application.ProcessMessages;
                                                      end;
                                                      isRightWin := True;
                                                      isWin := IsWindow(hVBoxSVC);
                                                      if isWin then
                                                      begin
                                                         GetWindowTextW(hVBoxSVC, tres, 255);
                                                         if tres <> 'VBoxPowerNotifyClass' then
                                                            isRightWin := False
                                                         else
                                                         begin
                                                            GetClassNameW(hVBoxSVC, tres, 255);
                                                            if tres <> 'VBoxPowerNotifyClass' then
                                                               isRightWin := False;
                                                         end;
                                                      end;
                                                      if (not isWin) or (not isRightWin) then
                                                      begin
                                                         GetProCessList;
                                                         j := 0;
                                                         l := Length(ProcessInfo);
                                                         while j < l do
                                                         begin
                                                            if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                                               if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                                                  if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                                                     Break;
                                                            Inc(j);
                                                         end;
                                                         if j < l then
                                                            hVBoxSVC := ProcessInfo[j].Handle
                                                         else
                                                         begin
                                                            Sleep(100);
                                                            Break;
                                                         end;
                                                      end;
                                                      Inc(i);
                                                   end;
                                                   if ShowingProgress then
                                                      try
                                                         if frmProgress.Visible then
                                                            frmProgress.Close;
                                                         frmProgress.Free;
                                                         frmProgress := nil;
                                                      except
                                                      end;
                                                end;
                                             end;
                                          except
                                          end;
                                       end;
                                       if (Length(vbmComm) > 0) and WideFileExists(svcPath) and (not svcAlreadyStarted) then
                                          try
                                             GetProCessList;
                                             j := 0;
                                             l := Length(ProcessInfo);
                                             while j < l do
                                             begin
                                                if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                                   if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                                      if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                                         Break;
                                                if ProcessInfo[j].WClass = 'QWidget' then
                                                   if IsWindowVisible(ProcessInfo[j].Handle) then
                                                      if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'virtualbox.exe' then
                                                         Break;
                                                Inc(j);
                                             end;
                                             if j >= l then
                                             begin
                                                l := Min(Length(svcPath), 512);
                                                for j := 1 to l do
                                                   zSVC[j - 1] := svcPath[j];
                                                for j := l + 1 to SizeOf(zSVC) do
                                                   zSVC[j - 1] := #0;
                                                FillChar(svcStartupInfo, SizeOf(svcStartupInfo), #0);
                                                svcStartupInfo.cb := SizeOf(svcStartupInfo);
                                                svcStartupInfo.dwFlags := STARTF_USESHOWWINDOW;
                                                svcStartupInfo.wShowWindow := SW_HIDE;
                                                StartFolder := WideExtractFilePath(ExeVBPath);
                                                if StartFolder <> '' then
                                                   PStartFolder := PWideChar(StartFolder)
                                                else
                                                   PStartFolder := nil;
                                                CreateProcessW(nil,
                                                   zSVC,
                                                   nil,
                                                   nil,
                                                   False,
                                                   DETACHED_PROCESS or
                                                   NORMAL_PRIORITY_CLASS,
                                                   nil,
                                                   PStartFolder,
                                                   svcStartupInfo,
                                                   svcProcessInfo);
                                             end;
                                          except
                                          end;
                                    end;
                                    i := 0;
                                    while i <= High(vbmComm) do
                                    begin
                                       ComLine := vbmPath + ' ' + vbmComm[i][1];
                                       l := Min(Length(ComLine), 512);
                                       for j := 1 to l do
                                          zVBM[j - 1] := ComLine[j];
                                       for j := l + 1 to SizeOf(zVBM) do
                                          zVBM[j - 1] := #0;
                                       FillChar(vbmStartupInfo, Sizeof(vbmStartupInfo), #0);
                                       vbmStartupInfo.cb := Sizeof(vbmStartupInfo);
                                       vbmStartupInfo.dwFlags := STARTF_USESHOWWINDOW;
                                       vbmStartupInfo.wShowWindow := SW_HIDE;
                                       StartFolder := WideExtractFilePath(ExeVBPath);
                                       if StartFolder <> '' then
                                          PStartFolder := PWideChar(StartFolder)
                                       else
                                          PStartFolder := nil;
                                       if CreateProcessW(nil,
                                          zVBM,
                                          nil,
                                          nil,
                                          False,
                                          DETACHED_PROCESS or
                                          HIGH_PRIORITY_CLASS,
                                          nil,
                                          PStartFolder,
                                          vbmStartupInfo,
                                          vbmProcessInfo) then
                                       begin
                                          if WaitForSingleObject(vbmProcessInfo.hProcess, 3000) = WAIT_TIMEOUT then
                                          begin
                                             errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorVBMan'], [vbmComm[i][2], vbmComm[i][1]], 'Out of time waiting for VBoxManage.exe to finish the current job (%s) !'#13#10#13#10'Job = %s'#13#10#13#10'This is a VirtualBox bug. My advice is to wait 20..30 seconds and try again...');
                                             try
                                                CloseHandle(vbmProcessInfo.hProcess);
                                                CloseHandle(vbmProcessInfo.hThread);
                                             except
                                             end;
                                             AllOK := False;
                                             Break;
                                          end;
                                          ExitCode := 9999;
                                          try
                                             GetExitCodeProcess(vbmProcessInfo.hProcess, ExitCode);
                                          except
                                          end;
                                          try
                                             CloseHandle(vbmProcessInfo.hProcess);
                                             CloseHandle(vbmProcessInfo.hThread);
                                          except
                                          end;
                                          if ExitCode > 0 then
                                          begin
                                             AllOK := False;
                                             if ExitCode <> 9999 then
                                                errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'VBManErrorCode'], [ExitCode, vbmComm[i][2], vbmComm[i][1]], 'VBoxManage.exe returned error code %d for the current job (%s) !'#13#10#13#10'Job = %s')
                                             else
                                                errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'VBManExitError'], [vbmComm[i][2], vbmComm[i][1]], 'Error getting the exit code for the current VBoxManage job (%s) !'#13#10#13#10'Job = %s');
                                             Break;
                                          end;
                                       end
                                       else
                                       begin
                                          LastError := GetLastError;
                                          errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'VBManUnableLaunch'], [WideSysErrorMessage(LastError)], 'Unable to launch VBoxManage.exe !'#13#10#13#10'System message: %s');
                                          AllOK := False;
                                          Break;
                                       end;
                                       Inc(i);
                                    end;

                                 end;
                              end;
                           end;
                        end;
                     end;
                     if xmlVBoxCompare.Tag = 1 then
                        xmlVBoxCompare.Active := False;
                  end;
               end;
               if not AllOK then
               begin
                  l := Length(errmsg);
                  i := l;
                  while i > 0 do
                  begin
                     if (errmsg[i] <> #13) and (errmsg[i] <> #10) then
                        Break;
                     Dec(i);
                  end;
                  Delete(errmsg, i + 1, l - i);
                  if MessageBoxW(0, PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CantAddDrives'], [errmsg], 'Could not automatically add the drive(s) to the VirtualBox VM.'#13#10#13#10'Possible reason: %s'#13#10#13#10'Are you sure you want to continue (not recommended)...?')),
                     PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')), MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
                     Exit;
               end;
            end;

            juststart:

            if Run = 3 then
               sf := ' --fullscreen'
            else
               sf := '';
            case ModeLoadVM of
               1: ComLine := ExeVBPath + ' --startvm "' + VMPath + '"' + sf;
               2: ComLine := ExeVBPath + ' ' + ExeParams + sf;
            else
               ComLine := ExeVBPath + ' --startvm "' + VMID + '"' + sf;
            end;
         end;
         FillChar(eStartupInfo, Sizeof(eStartupInfo), #0);
         eStartupInfo.dwFlags := STARTF_USESHOWWINDOW;
         eStartupInfo.cb := Sizeof(eStartupInfo);
         case Run of
            1: eStartupInfo.wShowWindow := SW_MINIMIZE;
            2: eStartupInfo.wShowWindow := SW_MAXIMIZE;
            3: if Ptype = 0 then
                  eStartupInfo.wShowWindow := SW_SHOWNORMAL
               else
                  eStartupInfo.wShowWindow := SW_HIDE;
         else
            eStartupInfo.wShowWindow := SW_SHOWNORMAL;
         end;
         case Priority of
            0: cp := $000004000;
            2: cp := $000008000;
            3: cp := $000000080;
         else
            cp := $000000020;
         end;
         if StartFolder <> '' then
            PStartFolder := PWideChar(StartFolder)
         else
            PStartFolder := nil;
         if Ptype <> 1 then
         begin
            l := Min(Length(ComLine), 512);
            for i := 1 to l do
               zAppName[i - 1] := ComLine[i];
            if CreateProcessW(nil,
               zAppName,
               nil,
               nil,
               False,
               CREATE_NEW_CONSOLE or
               cp,
               nil,
               PStartFolder,
               eStartupInfo,
               eProcessInfo) then
            begin
               WaitforSingleObject(eProcessInfo.hProcess, INFINITE);
               VBVMWasClosed := Now;
               try
                  if not GetExitCodeProcess(eProcessInfo.hProcess, ExitCode) then
                     ExitCode := 1;
               except
                  ExitCode := 1;
               end;
               try
                  CloseHandle(eProcessInfo.hProcess);
                  CloseHandle(eProcessInfo.hThread);
               except
               end;
               Sleep(200);
            end
            else
            begin
               LastError := GetLastError;
               MessageBoxW(0, PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'VBUnableLaunch'], [WideSysErrorMessage(LastError)], 'Unable to launch VirtualBox.exe !'#13#10#13#10'System message: %s')),
                  PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')), MB_ICONERROR or MB_OK);
            end;

            //removes the drive
            if RemoveDrive then
            begin
               useVBMU := False;
               if UpdateVM = 0 then
                  if not WaitForVBSVC then
                     useVBMU := True
                  else
                  begin
                     GetProcessList;
                     l := Length(ProcessInfo);
                     i := 0;
                     while i < l do
                     begin
                        if ProcessInfo[i].WClass = 'QWidget' then
                           if IsWindowVisible(ProcessInfo[i].Handle) then
                              if GetFileNameFromHandleW(ProcessInfo[i].Handle) = 'virtualbox.exe' then
                              begin
                                 useVBMU := True;
                                 Break;
                              end;
                        Inc(i);
                     end;
                     if (not useVBMU) and ((Now - VBVMWasClosed) < (5 / 86400)) then
                     begin
                        i := 0;
                        while i < l do
                        begin
                           if ProcessInfo[i].WClass = 'VBoxPowerNotifyClass' then
                              if ProcessInfo[i].WCaption = 'VBoxPowerNotifyClass' then
                                 if GetFileNameFromHandleW(ProcessInfo[i].Handle) = 'vboxsvc.exe' then
                                 begin
                                    useVBMU := True;
                                    Break;
                                 end;
                           Inc(i);
                        end;
                     end;
                  end;
               AllOK := True;
               if (UpdateVM = 2) or ((UpdateVM = 0) and (not useVBMU)) then
               begin
                  an := GetLangTextDef(idxMain, ['Messages', 'VBManDetected'], 'VirtualBox Manager was detected.'#13#10'It is highly recommended not to be used in the same time !'#13#10#13#10'Should I close it...? (it will take a few sec to fully close)');
                  srchvbm2:
                  for i := 0 to l - 1 do
                     if ProcessInfo[i].WClass = 'QWidget' then
                        if ProcessInfo[i].WCaption = 'Oracle VM VirtualBox Manager' then
                           if GetFileNameFromHandleW(ProcessInfo[i].Handle) = 'virtualbox.exe' then
                              if IsWindowVisible(ProcessInfo[i].Handle) then
                              begin
                                 if IsIconic(ProcessInfo[i].Handle) then
                                    SendMessage(ProcessInfo[i].Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
                                 SetWindowPos(ProcessInfo[i].Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                 SetWindowPos(ProcessInfo[i].Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                 if MessageBoxW(0, PWideChar(an),
                                    PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')), MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                                    Exit
                                 else
                                 begin
                                    if IsWindowVisible(ProcessInfo[i].Handle) then
                                       SendMessage(ProcessInfo[i].Handle, WM_CLOSE, 0, 0);
                                    j := 1;
                                    while j <= 20 do
                                    begin
                                       Sleep(100);
                                       isRightWin := True;
                                       isWin := isWindow(ProcessInfo[i].Handle);
                                       if isWin then
                                       begin
                                          GetWindowTextW(ProcessInfo[i].Handle, tres, 255);
                                          if tres <> 'Oracle VM VirtualBox Manager' then
                                             isRightWin := False
                                          else
                                          begin
                                             GetClassNameW(ProcessInfo[i].Handle, tres, 255);
                                             if tres <> 'QWidget' then
                                                isRightWin := False;
                                          end;
                                       end;
                                       if (not isWin) or (not isRightWin) then
                                          Break;
                                       Inc(j);
                                    end;
                                    if j > 20 then
                                    begin
                                       if IsIconic(ProcessInfo[i].Handle) then
                                          SendMessage(ProcessInfo[i].Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
                                       SetWindowPos(ProcessInfo[i].Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                       SetWindowPos(ProcessInfo[i].Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW);
                                       if MessageBoxW(0,
                                          PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'CouldNotCloseVBMan'], [OKCaption], 'Could not close VirtualBox Manager automatically !'#13#10#13#10'Please close it manually and click on %s...  (it will take a few sec to fully close)')),
                                          PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')),
                                          MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                                          Exit
                                       else
                                       begin
                                          j := 1;
                                          while j <= 20 do
                                          begin
                                             Sleep(100);
                                             isRightWin := True;
                                             isWin := isWindow(ProcessInfo[i].Handle);
                                             if isWin then
                                             begin
                                                GetWindowTextW(ProcessInfo[i].Handle, tres, 255);
                                                if tres <> 'Oracle VM VirtualBox Manager' then
                                                   isRightWin := False
                                                else
                                                begin
                                                   GetClassNameW(ProcessInfo[i].Handle, tres, 255);
                                                   if tres <> 'QWidget' then
                                                      isRightWin := False;
                                                end;
                                             end;
                                             if (not isWin) or (not isRightWin) then
                                                Break;
                                             Inc(j);
                                          end;
                                          if j > 20 then
                                          begin
                                             MessageBoxW(0,
                                                PWideChar(GetLangTextDef(idxMain, ['Messages', 'ErrorVBManNotClosed'], 'Error: VirtualBox Manager not closed !')),
                                                PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')),
                                                MB_ICONERROR or MB_OK);
                                             Exit;
                                          end;
                                       end;
                                    end;
                                 end;
                                 an := GetLangTextDef(idxMain, ['Messages', 'AnotherVBManSession'], 'Another VirtualBox Manager was detected.'#13#10'It is highly recommended not to be used in the same time !'#13#10#13#10'Should I close it...? (it will take a few sec to fully close)') + ' ';
                                 goto srchvbm2;
                              end;
                  if WaitForVBSVC then
                     try
                        GetProCessList;
                        j := 0;
                        l := Length(ProcessInfo);
                        while j < l do
                        begin
                           if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                              if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                 if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                    Break;
                           Inc(j);
                        end;
                        if j < l then
                        begin
                           hVBoxSVC := ProcessInfo[j].Handle;
                           ShowingProgress := False;
                           try
                              if frmProgress = nil then
                                 Application.CreateForm(TfrmProgress, frmProgress);
                              with frmProgress do
                              begin
                                 lblMessage.Caption := GetLangTextDef(idxMain, ['Messages', 'WaitingVBSVCToClose'], 'Waiting for "VBoxSVC.exe" (a VirtualBox component) to close...');
                                 btnCancel.Caption := GetLangTextDef(idxMain, ['Messages', 'CancelHide'], 'Hide');
                                 pbProgress.Max := 200 + 200 * Integer(VBSVC2x);
                                 Show;
                              end;
                              Application.ProcessMessages;
                              ShowingProgress := True;
                           except
                              if frmProgress.Visible then
                                 frmProgress.Close;
                              frmProgress.Free;
                              frmProgress := nil;
                           end;
                           i := 1;
                           while i <= (200 + 200 * Integer(VBSVC2x)) do
                           begin
                              Sleep(35);
                              if ShowingProgress and frmProgress.Visible then
                              begin
                                 frmProgress.pbProgress.Position := i;
                                 Application.ProcessMessages;
                              end;
                              isRightWin := True;
                              isWin := IsWindow(hVBoxSVC);
                              if isWin then
                              begin
                                 GetWindowTextW(hVBoxSVC, tres, 255);
                                 if tres <> 'VBoxPowerNotifyClass' then
                                    isRightWin := False
                                 else
                                 begin
                                    GetClassNameW(hVBoxSVC, tres, 255);
                                    if tres <> 'VBoxPowerNotifyClass' then
                                       isRightWin := False;
                                 end;
                              end;
                              if (not isWin) or (not isRightWin) then
                              begin
                                 GetProCessList;
                                 j := 0;
                                 l := Length(ProcessInfo);
                                 while j < l do
                                 begin
                                    if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                       if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                          if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                             Break;
                                    Inc(j);
                                 end;
                                 if j < l then
                                    hVBoxSVC := ProcessInfo[j].Handle
                                 else
                                 begin
                                    Sleep(100);
                                    Break;
                                 end;
                              end;
                              Inc(i);
                           end;
                           if ShowingProgress then
                              try
                                 if frmProgress.Visible then
                                    frmProgress.Close;
                                 frmProgress.Free;
                                 frmProgress := nil;
                              except
                              end;
                           if i > (200 + 200 * Integer(VBSVC2x)) then
                           begin
                              if MessageBoxW(0,
                                 PWideChar(GetLangTextDef(idxMain, ['Messages', 'OutOfTimeVBSVC'], 'Out of time waiting for "VBoxSVC.exe" (a VirtualBox component) to close...!'#13#10#13#10'Should I forcibly close it...?')),
                                 PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')),
                                 MB_ICONWARNING or MB_OKCANCEL or MB_DEFBUTTON1) <> mrOK then
                                 Exit
                              else
                              begin
                                 j := 0;
                                 GetProcessList;
                                 l := Length(ProcessInfo);
                                 while j < l do
                                 begin
                                    if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                       if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                          if GetFileNameAndThreadFromHandleW(ProcessInfo[j].Handle, ThreadID) = 'vboxsvc.exe' then
                                             try
                                                TerminateProcess(OpenProcess(PROCESS_TERMINATE, BOOL(0), ThreadID), 0);
                                             except
                                             end;
                                    Inc(j);
                                 end;
                                 for i := 1 to 10 do
                                 begin
                                    Sleep(200);
                                    j := 0;
                                    GetProcessList;
                                    l := Length(ProcessInfo);
                                    while j < l do
                                    begin
                                       if ProcessInfo[j].WClass = 'VBoxPowerNotifyClass' then
                                          if ProcessInfo[j].WCaption = 'VBoxPowerNotifyClass' then
                                             if GetFileNameFromHandleW(ProcessInfo[j].Handle) = 'vboxsvc.exe' then
                                                Break;
                                       Inc(j);
                                    end;
                                    if j >= l then
                                       Break;
                                 end;
                                 if i <= 10 then
                                 begin
                                    MessageBoxW(0,
                                       PWideChar(GetLangTextDef(idxMain, ['Messages', 'VBSVCStillOpened'], '"VBoxSVC.exe" is still opened !'#13#10#13#10'Exiting...')),
                                       PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')),
                                       MB_ICONERROR or MB_OK);
                                    Exit;
                                 end;
                              end;
                           end;
                        end;

                     except
                     end;
               end;

               try
                  xmlVBox.Active := True;
               except
                  on E: Exception do
                  begin
                     AllOK := False;
                     errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'PleaseAllowAccess'], [VMPath, E.Message], 'error accessing "%s",'#13#10'please allow access.'#13#10'System message: %s');
                     xmlVBox.Active := False;
                  end;
               end;
               if xmlVBox.Active then
               begin
                  SetLength(vmdkids, 0);
                  SetLength(exvmdks, 0);
                  SetLength(vbmComm, 0);

                  with xmlVBox do
                  begin
                     if Tag = 1 then
                        try
                           n1 := ChildNodes.IndexOf('VirtualBox');
                           if n1 = -1 then
                           begin
                              errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'SectionNotFound'], ['VirtualBox'], '"%s" section not found in the vbox file !'#13#10#13#10'It seems Oracle changed the file format or you have a corrupted file.');
                              Abort;
                           end
                           else
                           begin
                              n2 := ChildNodes[n1].ChildNodes.IndexOf('Machine');
                              if n2 = -1 then
                              begin
                                 errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'SectionNotFound'], ['Machine'], '"%s" section not found in the vbox file !'#13#10#13#10'It seems Oracle changed the file format or you have a corrupted file.');
                                 Abort;
                              end
                              else
                              begin
                                 a1 := ChildNodes[n1].ChildNodes[n2].AttributeNodes.IndexOf('stateFile');
                                 if a1 > -1 then
                                 begin
                                    MessageBoxW(0,
                                       PWideChar(GetLangTextDef(idxMain, ['Messages', 'SavedStateClose'], 'It appears this VM is in a saved state so it will not be modified, only closed...'#13#10#13#10'Just so you know, it is not a good idea to save the state of a VM with a real drive,'#13#10'because it will increase the risk of corrupting the data from that drive...')),
                                       PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                                       MB_OK or MB_ICONWARNING);
                                    jc := True;
                                    Abort;
                                 end;
                                 n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('MediaRegistry');
                                 if n3 = -1 then
                                 begin
                                    errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'SectionNotFound'], ['MediaRegistry'], '"%s" section not found in the vbox file !'#13#10#13#10'It seems Oracle changed the file format or you have a corrupted file.');
                                    Abort;
                                 end
                                 else
                                 begin
                                    n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.IndexOf('HardDisks');
                                    if n4 > -1 then
                                    begin
                                       for i := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.Count - 1 downto 0 do
                                       begin
                                          a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes.IndexOf('format');
                                          if a1 = -1 then
                                             Continue;
                                          if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a1].Text = 'VMDK' then
                                          begin
                                             a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes.IndexOf('location');
                                             if a2 > -1 then
                                             begin
                                                wp := WideLowerCase(ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a2].Text);
                                                l := Length(wp);
                                                if l <> 17 then
                                                   Continue;
                                                if Pos('vmubdrive', wp) <> 1 then
                                                   Continue;
                                                if StrToIntDef('$' + Copy(wp, 10, 3), -1) = -1 then
                                                   Continue;
                                                if Pos('.vmdk', wp) <> 13 then
                                                   Continue;
                                                a3 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes.IndexOf('uuid');
                                                if a3 > -1 then
                                                begin
                                                   if ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].ChildNodes.Count > 0 then
                                                   begin
                                                      errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'DividedSnapshots'],
                                                         [ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a2].Text, ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].ChildNodes.Count], 'the content of "%s" is divided into %d snapshot(s).'#13#10'It is not a good idea using snapshots with real drives. But if you really want to at least do this:' +
                                                         #13#10'If you created a snapshot or linked clone this VM you should of manually detached any'#13#10'VMUBDrive***.vmdk drive from the storage controller(s) before the snapshoting/cloning operation.');
                                                      Abort;
                                                   end;
                                                   wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a3].Text;
                                                   SetLength(vmdkids, Length(vmdkids) + 1);
                                                   vmdkids[High(vmdkids)][1] := Copy(wst, 2, Length(wst) - 2);
                                                   vmdkids[High(vmdkids)][2] := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a2].Text;
                                                   ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.Delete(i);
                                                   SetLength(vbmComm, Length(vbmComm) + 1);
                                                   vbmComm[High(vbmComm)][1] := 'closemedium disk ' + Copy(wst, 2, Length(wst) - 2);
                                                   vbmComm[High(vbmComm)][2] := GetLangTextDef(idxMain, ['Messages', 'RemoveDriveOp'], 'removing the drive');
                                                end;
                                             end;
                                          end;
                                       end;
                                       for i := 0 to ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes.Count - 1 do
                                       begin
                                          a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes.IndexOf('uuid');
                                          if a1 > -1 then
                                          begin
                                             wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[n4].ChildNodes[i].AttributeNodes[a1].Text;
                                             SetLength(exvmdks, Length(exvmdks) + 1);
                                             exvmdks[High(exvmdks)] := Copy(wst, 2, Length(wst) - 2);
                                          end;
                                       end;
                                    end;
                                 end;
                                 if Length(vmdkids) > 0 then
                                 begin
                                    n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('StorageControllers');
                                    if n3 > -1 then
                                       for i := 0 to ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count - 1 do
                                          for j := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes.Count - 1 downto 0 do
                                          begin
                                             a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('name');
                                             if a1 > -1 then
                                                mCName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[a1].Text
                                             else
                                                mCName := 'IDE';
                                             a2 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].AttributeNodes.IndexOf('port');
                                             if a2 > -1 then
                                                mPort := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].AttributeNodes[a2].Text
                                             else
                                                mPort := '0';
                                             a3 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].AttributeNodes.IndexOf('device');
                                             if a3 > -1 then
                                                mDevice := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].AttributeNodes[a3].Text
                                             else
                                                mDevice := '0';
                                             n4 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].ChildNodes.IndexOf('Image');
                                             if n4 > -1 then
                                             begin
                                                a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].ChildNodes[n4].AttributeNodes.IndexOf('uuid');
                                                if a1 > -1 then
                                                begin
                                                   wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes[j].ChildNodes[n4].AttributeNodes[a1].Text;
                                                   wst := Copy(wst, 2, Length(wst) - 2);
                                                   k := 0;
                                                   while k < Length(vmdkids) do
                                                   begin
                                                      if vmdkids[k][1] = wst then
                                                      begin
                                                         ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].ChildNodes.Delete(j);
                                                         SetLength(vbmComm, Length(vbmComm) + 1);
                                                         for p := High(vbmComm) downto 1 do
                                                            vbmComm[p] := vbmComm[p - 1];

                                                         if (a1 > -1) and (a2 > -1) and (a3 > -1) then
                                                         begin
                                                            vbmComm[0][1] := 'storageattach ' + VMID + ' --storagectl ' + mCName +
                                                               ' --port ' + mPort + ' --device ' + mDevice + ' --medium none';
                                                            vbmComm[0][2] := GetLangTextDef(idxMain, ['Messages', 'DetachDriveOp'], 'detaching the drive');
                                                         end;
                                                         Break;
                                                      end;
                                                      Inc(k);
                                                   end;
                                                end;
                                             end;
                                          end;

                                 end;
                              end;
                           end;
                           AllOK := True;
                        except
                           if errmsg = GetLangTextDef(idxMain, ['Messages', 'UnknownError'], 'unknown error, please report it to the author'#13#10'with a complete description of what you''re doing.') then
                              errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'BrokenXML'], [VMPath], 'error accessing xml structure from "%s",'#13#10'please repair the file or replace it with a backup copy.');
                           AllOK := False;
                        end;

                     if jc then
                        goto justclose;

                     if (UpdateVM = 2) or ((UpdateVM = 0) and (not useVBMU)) then
                     begin
                        if AllOK then
                           try
                              sVbox := XML.Text;
                              hVbox := CreateFileW(PWideChar(FileName), GENERIC_WRITE, 0, nil, CREATE_ALWAYS, FILE_FLAG_WRITE_THROUGH, 0);
                              if hVbox <> INVALID_HANDLE_VALUE then
                              begin
                                 if not WriteFile(hVbox, Pointer(sVbox)^, Length(sVbox), dwBytesReturned, nil) then
                                 begin
                                    LastError := GetLastError;
                                    errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorWriteProtection'], [FileName, WideSysErrorMessage(LastError)], 'error writing in "%s",'#13#10'please remove the write protection.'#13#10#13#10'System message: %s');
                                    AllOK := False;
                                 end
                                 else
                                 begin
                                    try
                                       FlushFileBuffers(hVbox);
                                    except
                                    end;
                                    if Cardinal(Length(sVbox)) <> dwBytesReturned then
                                    begin
                                       LastError := GetLastError;
                                       errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorSpaceVolume'], [FileName, WideSysErrorMessage(LastError)], 'error writing in "%s",'#13#10'please free some space or check the volume ''%s'' for errors.'#13#10#13#10'System message: %s');
                                       AllOK := False;
                                    end
                                    else
                                       AllOK := True;
                                 end;
                              end
                              else
                              begin
                                 LastError := GetLastError;
                                 errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorWriteProtection'], [FileName, WideSysErrorMessage(LastError)], 'error writing in "%s",'#13#10'please remove the write protection.'#13#10#13#10'System message: %s');
                                 AllOK := False;
                              end;
                           except
                              on E: Exception do
                              begin
                                 AllOK := False;
                                 errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorWriteVolume'], [FileName, E.Message], 'error writing in "%s",'#13#10'please remove the write protection or check the volume ''%s'' for errors.'#13#10'System message: %s');
                              end;
                           end;
                        try
                           if hVbox <> INVALID_HANDLE_VALUE then
                              CloseHandle(hVbox);
                        except
                        end;
                        Active := False;
                     end
                     else
                     begin
                        Active := False;
                        i := 0;
                        while i <= High(vbmComm) do
                        begin
                           ComLine := vbmPath + ' ' + vbmComm[i][1];
                           l := Min(Length(ComLine), 512);
                           for j := 1 to l do
                              zVBM[j - 1] := ComLine[j];
                           for j := l + 1 to SizeOf(zVBM) do
                              zVBM[j - 1] := #0;
                           FillChar(vbmStartupInfo, Sizeof(vbmStartupInfo), #0);
                           vbmStartupInfo.cb := Sizeof(vbmStartupInfo);
                           vbmStartupInfo.dwFlags := STARTF_USESHOWWINDOW;
                           vbmStartupInfo.wShowWindow := SW_HIDE;
                           StartFolder := WideExtractFilePath(ExeVBPath);
                           if StartFolder <> '' then
                              PStartFolder := PWideChar(StartFolder)
                           else
                              PStartFolder := nil;
                           if CreateProcessW(nil,
                              zVBM,
                              nil,
                              nil,
                              False,
                              DETACHED_PROCESS or
                              HIGH_PRIORITY_CLASS,
                              nil,
                              PStartFolder,
                              vbmStartupInfo,
                              vbmProcessInfo) then
                           begin
                              if WaitForSingleObject(vbmProcessInfo.hProcess, 3000) = WAIT_TIMEOUT then
                              begin
                                 errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'ErrorVBMan'], [vbmComm[i][2], vbmComm[i][1]], 'Out of time waiting for VBoxManage.exe to finish the current job (%s) !'#13#10#13#10'Job = %s'#13#10#13#10'This is a VirtualBox bug. My advice is to wait 20..30 seconds and try again...');
                                 try
                                    CloseHandle(vbmProcessInfo.hProcess);
                                    CloseHandle(vbmProcessInfo.hThread);
                                 except
                                 end;
                                 AllOK := False;
                                 Break;
                              end;
                              ExitCode := 9999;
                              try
                                 GetExitCodeProcess(vbmProcessInfo.hProcess, ExitCode);
                              except
                              end;
                              try
                                 CloseHandle(vbmProcessInfo.hProcess);
                                 CloseHandle(vbmProcessInfo.hThread);
                              except
                              end;
                              if ExitCode > 0 then
                              begin
                                 AllOK := False;
                                 if ExitCode <> 9999 then
                                    errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'VBManErrorCode'], [ExitCode, vbmComm[i][2], vbmComm[i][1]], 'VBoxManage.exe returned error code %d for the current job (%s) !'#13#10#13#10'Job = %s')
                                 else
                                    errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'VBManExitError'], [vbmComm[i][2], vbmComm[i][1]], 'Error getting the exit code for the current VBoxManage job (%s) !'#13#10#13#10'Job = %s');
                                 Break;
                              end;
                           end
                           else
                           begin
                              LastError := GetLastError;
                              errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'VBManUnableLaunch'], [WideSysErrorMessage(LastError)], 'Unable to launch VBoxManage.exe !'#13#10#13#10'System message: %s');
                              AllOK := False;
                              Break;
                           end;
                           Inc(i);
                        end;
                     end;

                     if AllOK then
                        for i := 0 to High(vmdkids) do
                        begin
                           if (Pos('/', vmdkids[i][2]) = 0) and (Pos('\', vmdkids[i][2]) = 0) then
                              vmdkids[i][2] := WideExtractFilePath(VMPath) + vmdkids[i][2];
                           if not DeleteFileW(PWideChar(vmdkids[i][2])) then
                           begin
                              errmsg := GetLangTextFormatDef(idxMain, ['Messages', 'CantDeleteFile'], [WideExtractFilePath(vmdkids[i][2]), WideSysErrorMessage(LastError)], 'Could not delete the file "%s" !'#13#10'System message: %s');
                              AllOK := False;
                           end;
                        end;
                  end;

               end;
               if not AllOK then
               begin
                  l := Length(errmsg);
                  i := l;
                  while i > 0 do
                  begin
                     if (errmsg[i] <> #13) and (errmsg[i] <> #10) then
                        Break;
                     Dec(i);
                  end;
                  Delete(errmsg, i + 1, l - i);
                  MessageBoxW(0, PWideChar(GetLangTextDef(idxMain, ['Messages', 'CantRemoveDrives'], 'Could not automatically remove the drive(s) from the VirtualBox VM.'#13#10#13#10'Possible reason: ') + errmsg),
                     PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')), MB_OK or MB_ICONWARNING or MB_DEFBUTTON2);
               end;
            end;
         end
         else
         begin
            l := Min(Length(ComLine), 512);
            for i := 1 to l do
               zAppName[i - 1] := ComLine[i];
            if CreateProcessW(nil,
               zAppName,
               nil,
               nil,
               True,
               CREATE_NEW_CONSOLE or cp,
               nil,
               PStartFolder,
               eStartupInfo,
               eProcessInfo) then
            begin
               WaitforSingleObject(eProcessInfo.hProcess, INFINITE);
               try
                  if not GetExitCodeProcess(eProcessInfo.hProcess, ExitCode) then
                     ExitCode := 1;
               except
                  ExitCode := 1;
               end;
               try
                  CloseHandle(eProcessInfo.hProcess);
                  CloseHandle(eProcessInfo.hThread);
               except
               end;
               if ExitCode >= 1 then
               begin
                  TntClipboard.AsWideText := ComLine + #13#10'pause';
                  MessageBoxW(0,
                     PWideChar(GetLangTextDef(idxMain, ['Messages', 'QEMUError'], 'QEMU returned error !'#13#10#13#10'Tip: you should check the command line parameters'#13#10'to see if any are missing or spelled wrong.' +
                     #13#10'If you are using the default parameters'#13#10'you should adapt them to your QEMU version.'#13#10#13#10'To get more informations the command line was copied into clipboard.' +
                     #13#10'Create a new bat/cmd file, paste from clipboard and start it (as an administrator).'#13#10#13#10'On QEMU newer versions you could check the content of the stderr.txt file from'#13#10'the QEMU folder (where the QEMU exe file resides).')),
                     PWideChar(GetLangTextDef(idxMessagesType, ['Warning'], 'Warning')),
                     MB_OK or MB_ICONWARNING);
               end
               else
                  Sleep(200);
            end
            else
            begin
               LastError := GetLastError;
               MessageBoxW(0, PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'QEMUStartError'], [WideSysErrorMessage(LastError)], 'Unable to launch QEMU !'#13#10#13#10'System message: %s')),
                  PWideChar(GetLangTextDef(idxMessagesType, ['Error'], 'Error')), MB_ICONERROR or MB_OK);
            end;
         end;
      end;
      justclose:
   finally
      for i := 0 to High(VolumesInfo) do
         try
            if VolumesInfo[i].Handle <> INVALID_HANDLE_VALUE then
               CloseHandle(VolumesInfo[i].Handle);
         except
         end;

      if wereDismounted then
      begin
         if fu > 0 then
            UpdateDrive(fu);
         if su > 0 then
            UpdateDrive(su);
      end;
      SetErrorMode(ErrorMode);
      btnStart.Down := False;
      if FindDrivesScheduled then
      begin
         FindDrivesScheduled := False;
         FindDrives;
      end;
      Show;
   end;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
   SaveVMentries(VMentriesFile);
   SaveCFG(CfgFile);
end;

procedure TfrmMain.lvVMsDragDrop(Sender, Source: TObject; X, Y: Integer);
var
   dropItem: TListItem;
   Rect: TRect;
   i, j, cp, dp, sfc, sfi, ssc, ssi, lv, l: Integer;
   H: Cardinal;
   currentItem: TTntListItem;
   et: VMEntry;
begin
   try
      if Sender = Source then
      begin
         with TTNTListView(Sender) do
         begin
            dropItem := GetItemAt(X, Y);
            if Selected <> nil then
            begin
               dp := 0;
               try
                  currentItem := Items.Add;
                  currentItem.Assign(Selected);
                  sfc := -1;
                  sfi := -1;
                  ssc := -1;
                  ssi := -1;
                  j := 1;
                  while j < Columns.Count do
                  begin
                     if Columns[j].Tag = 3 then
                     begin
                        sfc := j - 1;
                        sfi := Selected.SubItemImages[j - 1];
                        Break;
                     end;
                     Inc(j);
                  end;
                  if AddSecondDrive then
                  begin
                     j := 1;
                     while j < Columns.Count do
                     begin
                        if Columns[j].Tag = 4 then
                        begin
                           ssc := -1;
                           ssi := Selected.SubItemImages[j - 1];
                           Break;
                        end;
                        Inc(j);
                     end;
                  end;
                  if not Assigned(dropItem) then
                  begin
                     if Y < Items[0].DisplayRect(drBounds).Top then
                        dp := 0
                     else if Y > Items[Items.Count - 1 - SelCount].DisplayRect(drBounds).Bottom then
                        dp := Items.Count - 2;
                  end;
                  Items.BeginUpdate;
                  cp := ItemIndex;
                  et := VMEntries[cp];
                  DeleteSelected;
                  if Assigned(dropItem) then
                  begin
                     Rect := dropItem.DisplayRect(drBounds);
                     if Y < (Rect.Top + (Rect.Bottom - Rect.Top) div 2) then
                        dp := dropItem.Index
                     else
                        dp := dropItem.Index + 1;
                  end;
                  Items.Insert(dp).Assign(currentItem);
                  currentItem.Free;
                  if dp < cp then
                  begin
                     for i := cp - 1 downto dp do
                        VMEntries[i + 1] := VMEntries[i];
                  end
                  else
                     for i := cp + 1 to dp do
                        VMEntries[i - 1] := VMEntries[i];
                  VMEntries[dp] := et;
                  if sfc > -1 then
                     Items[dp].SubItemImages[sfc] := sfi;
                  if ssc > -1 then
                     Items[dp].SubItemImages[ssc] := ssi;
               finally
                  if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
                     if lvVMS.Items.Count < 10 then
                     begin
                        for i := 0 to lvVMS.Items.Count - 1 do
                           lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
                     end
                     else
                        for i := 0 to lvVMS.Items.Count - 1 do
                           if i < 9 then
                              lvVMS.Items[i].SubItems[0] := '0' + IntToStr(i + 1)
                           else
                              lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
                  Items.EndUpdate;
                  Items[dp].Focused := True;
                  ItemIndex := dp;
                  Items[dp].Selected := True;
                  Repaint;
                  lv := Length(VMentries);
                  for i := 255 downto 0 do
                     SetLength(FHash[i], 0);
                  for i := 0 to lv - 1 do
                  begin
                     l := Length(vmEntries[i].FirstDriveName);
                     if l <> 0 then
                     begin
                        H := 2166136261;
                        for j := 1 to l do
                           H := (H xor Byte(vmEntries[i].FirstDriveName[j])) * 16777619;
                        H := H and 255;
                        SetLength(FHash[H], Length(FHash[H]) + 1);
                        FHash[H][High(FHash[h])][1] := 1;
                        FHash[H][High(FHash[h])][2] := i;
                     end;
                     if AddSecondDrive then
                     begin
                        l := Length(vmEntries[i].SecondDriveName);
                        if l = 0 then
                           Continue;
                        H := 2166136261;
                        for j := 1 to l do
                           H := (H xor Byte(vmEntries[i].SecondDriveName[j])) * 16777619;
                        H := H and 255;
                        SetLength(FHash[H], Length(FHash[H]) + 1);
                        FHash[H][High(FHash[h])][1] := 2;
                        FHash[H][High(FHash[h])][2] := i;
                     end;
                  end;
                  SaveVMentries(VMentriesFile);
                  SaveCfg(CfgFile);
               end;
            end;
         end;
      end;
   except
   end;
end;

procedure TfrmMain.lvVMsDragOver(Sender, Source: TObject; X, Y: Integer;
   State: TDragState; var Accept: Boolean);
var
   dropItem: TListItem;
begin
   try
      Accept := False;
      if Sender <> Source then
         Exit;
      if (Sender as TTntListView).SelCount = (Sender as TTntListView).Items.Count then
         Exit;
      dropItem := (Sender as TTntListView).GetItemAt(X, Y);
      if (dropItem <> nil) and dropItem.Selected then
         Exit;
      Accept := True;
   except
   end;
end;

procedure TfrmMain.TntFormMouseDown(Sender: TObject; Button: TMouseButton;
   Shift: TShiftState; X, Y: Integer);
begin
   ReleaseCapture;
   SendMessage(Handle, WM_SYSCOMMAND, 61458, 0);
end;

procedure TfrmMain.WindProc(var Message: TMessage);
begin
   try
      if Message.Msg = WM_SYSCOMMAND then
         case Message.wParam of
            SC_MINIMIZE:
               if WindowState = wsNormal then
               begin
                  IntLeft := Left;
                  IntTop := Top;
                  IntWidth := Width;
                  IntHeight := Height;
               end;
            SC_MAXIMIZE:
               begin
                  if WindowState = wsNormal then
                  begin
                     IntLeft := Left;
                     IntTop := Top;
                     IntWidth := Width;
                     IntHeight := Height;
                  end;
                  SaveMaximized := True;
               end;
            WM_USER + 1: OpenInternetHelp(Self.Handle, ['http://reboot.pro/user/61891-davidb/', 'http://reboot.pro/index.php?showuser=61891']);
            WM_USER + 2: OpenInternetHelp(Self.Handle, ['http://reboot.pro/user/17818-steve6375/', 'http://reboot.pro/index.php?showuser=17818']);
            WM_USER + 3: OpenInternetHelp(Self.Handle, ['http://reboot.pro/files/file/339-virtual-machine-usb-boot/', 'http://reboot.pro/index.php?s=e6a62f6faf7bc2a4ed6d16b703166a34&app=downloads&showfile=339']);
            WM_USER + 4: OpenInternetHelp(Self.Handle, DefSiteHelp);
         end;
   except
   end;
   fOldTwndMethod(Message);
end;

procedure TfrmMain.TntFormResize(Sender: TObject);
var
   i, l, pl, iname, ivmname, ifirst, isec, nres: Integer;
   diff, t: Double;
begin
   try
      i := 0;
      l := 0;
      iname := -1;
      ivmname := -1;
      ifirst := -1;
      isec := -1;
      nres := 0;
      while i < lvVMS.Columns.Count do
      begin
         case lvVMS.Columns[i].Tag of
            1:
               begin
                  iname := i;
                  Inc(nres);
               end;
            2:
               begin
                  ivmname := i;
                  Inc(nres);
               end;
            3:
               begin
                  ifirst := i;
                  Inc(nres);
               end;
            4:
               begin
                  isec := i;
                  Inc(nres);
               end;
         else
            Inc(l, lvVMS.Columns[i].Width);
         end;
         Inc(i);
      end;
      lvVMs.Columns.BeginUpdate;
      if nres > 0 then
      begin
         l := lvVMS.ClientWidth - l - 1;
         pl := 0;
         if iname > -1 then
            Inc(pl, lvVMS.Columns[iname].Width);
         if ivmname > -1 then
            Inc(pl, lvVMS.Columns[ivmname].Width);
         if ifirst > -1 then
            Inc(pl, lvVMS.Columns[ifirst].Width);
         if isec > -1 then
            Inc(pl, lvVMS.Columns[isec].Width);
         diff := 1.0 * (l - pl) / nres;
         if iname > -1 then
            lvVMS.Columns[iname].Width := Round(diff + lvVMS.Columns[iname].Width);
         if ivmname > -1 then
            lvVMS.Columns[ivmname].Width := Round(diff + lvVMS.Columns[ivmname].Width);
         if ifirst > -1 then
            lvVMS.Columns[ifirst].Width := Round(diff + lvVMS.Columns[ifirst].Width);
         if isec > -1 then
            lvVMS.Columns[isec].Width := Round(diff + lvVMS.Columns[isec].Width);
      end;
      lvVMs.Columns.EndUpdate;
   except
   end;
   t := 0.2 * (btnExit.Top - btnStart.Top);
   btnAdd.Top := Round(t + btnStart.Top);
   btnEdit.Top := Round(2.0 * t + btnStart.Top);
   btnDelete.Top := Round(3.0 * t + btnStart.Top);
   btnOptions.Top := Round(4.0 * t + btnStart.Top);
end;

procedure TfrmMain.pmHeadersPopup(Sender: TObject);
var
   i: Integer;
begin
   for i := 0 to pmHeaders.Items.Count - 1 do
      if pmHeaders.Items[i].Visible then
         try
            pmHeaders.Items[i].Checked := False;
         except
         end;
   for i := 1 to lvVMS.Columns.Count - 1 do
      try
         if pmHeaders.Items[lvVMS.Columns[i].Tag].Visible then
            pmHeaders.Items[lvVMS.Columns[i].Tag].Checked := True;
      except
      end;
end;

procedure TfrmMain.mmHeadersClick(Sender: TObject);
var
   i, j: Integer;
begin
   (Sender as TMenuItem).Checked := not (Sender as TMenuItem).Checked;
   lvVMs.Items.BeginUpdate;
   lvVMs.Columns.BeginUpdate;
   try
      if (Sender as TMenuItem).Checked then
      begin
         for i := lvVMs.Columns.Count - 1 downto 1 do
            lvVMs.Columns[i].Free;
         for i := 0 to lvVMS.Items.Count - 1 do
            lvVMS.Items[i].SubItems.Clear;
         for i := 0 to pmHeaders.Items.Count - 1 do
            if pmHeaders.Items[i].Checked and pmHeaders.Items[i].Visible then
               with lvVMS.Columns.Add do
               begin
                  Caption := pmHeaders.Items[i].Caption;
                  MinWidth := 50;
                  Tag := i;
                  case Tag of
                     0:
                        begin
                           Alignment := taCenter;
                           pmHeaders.Items[i].Tag := lvVms.Canvas.TextWidth(IntToStr(Length(VMentries)) + '00');
                           MinWidth := pmHeaders.Items[i].Tag;
                           MaxWidth := pmHeaders.Items[i].Tag;
                           if lvVMs.Items.Count < 10 then
                           begin
                              for j := 0 to lvVMS.Items.Count - 1 do
                                 lvVMS.Items[j].SubItems.Add(IntToStr(j + 1));
                           end
                           else
                              for j := 0 to lvVMS.Items.Count - 1 do
                                 if j < 9 then
                                    lvVMS.Items[j].SubItems.Add('0' + IntToStr(j + 1))
                                 else
                                    lvVMS.Items[j].SubItems.Add(IntToStr(j + 1));
                        end;
                     1:
                        begin
                           for j := 0 to High(VMEntries) do
                              lvVMs.Items[j].SubItems.Add(VMEntries[j].Name);
                        end;
                     2:
                        begin
                           ImageIndex := 3;
                           for j := 0 to High(VMEntries) do
                              lvVMs.Items[j].SubItems.Add(VMEntries[j].VMName);
                        end;
                     3:
                        begin
                           ImageIndex := 2;
                           for j := 0 to High(VMEntries) do
                           begin
                              lvVMs.Items[j].SubItems.Add(VMEntries[j].FirstDriveName);
                              if vmEntries[j].FirstDriveName = '' then
                                 lvVMs.Items[j].SubItemImages[lvVms.Items[j].SubItems.Count - 1] := -1
                              else if VMentries[j].FirstDriveFound then
                                 lvVMs.Items[j].SubItemImages[lvVms.Items[j].SubItems.Count - 1] := 4
                              else
                                 lvVMs.Items[j].SubItemImages[lvVms.Items[j].SubItems.Count - 1] := 5;
                           end;
                        end;
                     4:
                        begin
                           ImageIndex := 2;
                           for j := 0 to High(VMEntries) do
                           begin
                              lvVMs.Items[j].SubItems.Add(VMEntries[j].SecondDriveName);
                              if vmEntries[j].SecondDriveName = '' then
                                 lvVMs.Items[j].SubItemImages[lvVms.Items[j].SubItems.Count - 1] := -1
                              else if VMentries[j].SecondDriveFound then
                                 lvVMs.Items[j].SubItemImages[lvVms.Items[j].SubItems.Count - 1] := 4
                              else
                                 lvVMs.Items[j].SubItemImages[lvVms.Items[j].SubItems.Count - 1] := 5;
                           end;
                        end;
                  end;
                  Width := pmHeaders.Items[i].Tag;
               end;
      end
      else
      begin
         i := 1;
         while i < lvVMS.Columns.Count do
         begin
            if lvVMS.Columns[i].Tag = pmHeaders.Items.IndexOf(Sender as TMenuItem) then
            begin
               (Sender as TMenuItem).Tag := lvVMS.Columns[i].Width;
               lvVMS.Columns[i].Free;
               for j := 0 to lvVMS.Items.Count - 1 do
                  lvVMS.Items[j].SubItems.Delete(i - 1);
               Break;
            end;
            Inc(i);
         end;
      end;
   except
   end;
   lvVMS.Items.EndUpdate;
   lvVMs.Columns.EndUpdate;
   TntFormResize(Self);
   SaveCfg(CfgFile);
end;

procedure TFrmMain.Sort(const ColumnIndex: Integer);
var
   i, j, p, lv, l: Integer;
   H: Cardinal;
   Changed, WasSorted: Boolean;
   et: VMEntry;
   li: TTNTListItem;
begin
   WasSorted := False;
   lvVms.Items.BeginUpdate;
   p := lvVMS.ItemIndex;
   lv := Length(VMentries);
   try
      li := TTNTListItem.Create(lvVMS.Items);
      WasSorted := False;
      repeat
         Changed := False;
         for i := 0 to lv - 2 do
         begin
            case CompareStringW((LOCALE_USER_DEFAULT or (SUBLANG_DEFAULT shl 10)) or (SORT_DEFAULT shl 16), NORM_IGNORECASE, PWideChar(lvVMS.Items[i].SubItems[ColumnIndex - 1]), Length(lvVMS.Items[i].SubItems[ColumnIndex - 1]),
               PWideChar(lvVMS.Items[i + 1].SubItems[ColumnIndex - 1]), Length(lvVMS.Items[i + 1].SubItems[ColumnIndex - 1])) - 2 of
               1:
                  begin
                     if p = i then
                        p := i + 1
                     else if p = (i + 1) then
                        p := i;
                     li.Assign(lvVMs.Items[i + 1]);
                     lvVMs.Items[i + 1].Assign(lvVMs.Items[i]);
                     lvVMs.Items[i].Assign(li);
                     et := VMentries[i + 1];
                     VMentries[i + 1] := VMentries[i];
                     VMentries[i] := et;
                     Changed := True;
                     WasSorted := True;
                  end;
               0, -1:
            else
               Abort;
            end;
         end;
      until not Changed;
      li.Free;
      if WasSorted then
      begin
         if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
         begin
            if lvVMs.Items.Count < 10 then
            begin
               for i := 0 to lvVMS.Items.Count - 1 do
                  lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
            end
            else
               for i := 0 to lvVMS.Items.Count - 1 do
                  if i < 9 then
                     lvVMS.Items[i].SubItems[0] := '0' + IntToStr(i + 1)
                  else
                     lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
         end;
         j := 1;
         while j < lvVMs.Columns.Count do
         begin
            if lvVMs.Columns[j].Tag = 3 then
               Break;
            Inc(j);
         end;
         if j < lvVMs.Columns.Count then
            for i := 0 to High(VMEntries) do
               if VMentries[i].FirstDriveName = '' then
                  lvVMs.Items[i].SubItemImages[j - 1] := -1
               else if VMentries[i].FirstDriveFound then
                  lvVMs.Items[i].SubItemImages[j - 1] := 4
               else
                  lvVMs.Items[i].SubItemImages[j - 1] := 5;
         if AddSecondDrive then
         begin
            j := 1;
            while j < lvVMs.Columns.Count do
            begin
               if lvVMs.Columns[j].Tag = 4 then
                  Break;
               Inc(j);
            end;
            if j < lvVMs.Columns.Count then
               for i := 0 to High(VMEntries) do
                  if VMentries[i].SecondDriveName = '' then
                     lvVMs.Items[i].SubItemImages[j - 1] := -1
                  else if VMentries[i].SecondDriveFound then
                     lvVMs.Items[i].SubItemImages[j - 1] := 4
                  else
                     lvVMs.Items[i].SubItemImages[j - 1] := 5;
         end;
      end;
   except
   end;
   lvVms.Items.EndUpdate;
   if p > -1 then
   begin
      lvVMS.ItemIndex := p;
      lvVMS.Items[p].Selected := True;
      lvVMS.Items[p].Focused := True;
      lvVMs.Items[lvVMS.ItemIndex].MakeVisible(False);
   end;
   lvVMs.Repaint;
   if WasSorted then
   begin
      for i := 255 downto 0 do
         SetLength(FHash[i], 0);
      for i := 0 to lv - 1 do
      begin
         l := Length(vmEntries[i].FirstDriveName);
         if l <> 0 then
         begin
            H := 2166136261;
            for j := 1 to l do
               H := (H xor Byte(vmEntries[i].FirstDriveName[j])) * 16777619;
            H := H and 255;
            SetLength(FHash[H], Length(FHash[H]) + 1);
            FHash[H][High(FHash[h])][1] := 1;
            FHash[H][High(FHash[h])][2] := i;
         end;
         if AddSecondDrive then
         begin
            l := Length(vmEntries[i].SecondDriveName);
            if l = 0 then
               Continue;
            H := 2166136261;
            for j := 1 to l do
               H := (H xor Byte(vmEntries[i].SecondDriveName[j])) * 16777619;
            H := H and 255;
            SetLength(FHash[H], Length(FHash[H]) + 1);
            FHash[H][High(FHash[h])][1] := 2;
            FHash[H][High(FHash[h])][2] := i;
         end;
      end;
      SaveVMentries(VMentriesFile);
   end;
end;

procedure TFrmMain.SortAfterType;
var
   i, j, p, lv, l: Integer;
   H: Cardinal;
   Changed, WasSorted, HasSubItems: Boolean;
   et: VMEntry;
   li: TTNTListItem;
begin
   WasSorted := False;
   HasSubItems := lvVMS.Columns.Count > 1;
   lvVms.Items.BeginUpdate;
   p := lvVMS.ItemIndex;
   lv := Length(VMentries);
   try
      li := TTNTListItem.Create(lvVMS.Items);
      WasSorted := False;
      repeat
         Changed := False;
         for i := 0 to lv - 2 do
            if (VMEntries[i].Ptype = 0) and (VMEntries[i + 1].Ptype = 1) then
            begin
               if p = i then
                  p := i + 1
               else if p = (i + 1) then
                  p := i;
               li.Assign(lvVMs.Items[i + 1]);
               lvVMs.Items[i + 1].Assign(lvVMs.Items[i]);
               lvVMs.Items[i].Assign(li);
               et := VMentries[i + 1];
               VMentries[i + 1] := VMentries[i];
               VMentries[i] := et;
               Changed := True;
               WasSorted := True;
            end
            else if HasSubItems and (VMEntries[i].Ptype = VMEntries[i + 1].Ptype) then
               case CompareStringW((LOCALE_USER_DEFAULT or (SUBLANG_DEFAULT shl 10)) or (SORT_DEFAULT shl 16), NORM_IGNORECASE, PWideChar(lvVMS.Items[i].SubItems[0]), Length(lvVMS.Items[i].SubItems[0]),
                  PWideChar(lvVMS.Items[i + 1].SubItems[0]), Length(lvVMS.Items[i + 1].SubItems[0])) - 2 of
                  1:
                     begin
                        if p = i then
                           p := i + 1
                        else if p = (i + 1) then
                           p := i;
                        li.Assign(lvVMs.Items[i + 1]);
                        lvVMs.Items[i + 1].Assign(lvVMs.Items[i]);
                        lvVMs.Items[i].Assign(li);
                        et := VMentries[i + 1];
                        VMentries[i + 1] := VMentries[i];
                        VMentries[i] := et;
                        Changed := True;
                        WasSorted := True;
                     end;
                  0, -1:
               end;
      until not Changed;
      li.Free;
      if WasSorted then
      begin
         if (lvVMs.Columns.Count > 1) and (lvVMs.Columns[1].Tag = 0) then
         begin
            if lvVMs.Items.Count < 10 then
            begin
               for i := 0 to lvVMS.Items.Count - 1 do
                  lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
            end
            else
               for i := 0 to lvVMS.Items.Count - 1 do
                  if i < 9 then
                     lvVMS.Items[i].SubItems[0] := '0' + IntToStr(i + 1)
                  else
                     lvVMS.Items[i].SubItems[0] := IntToStr(i + 1);
         end;
         j := 1;
         while j < lvVMs.Columns.Count do
         begin
            if lvVMs.Columns[j].Tag = 3 then
               Break;
            Inc(j);
         end;
         if j < lvVMs.Columns.Count then
            for i := 0 to High(VMEntries) do
               if VMentries[i].FirstDriveName = '' then
                  lvVMs.Items[i].SubItemImages[j - 1] := -1
               else if VMentries[i].FirstDriveFound then
                  lvVMs.Items[i].SubItemImages[j - 1] := 4
               else
                  lvVMs.Items[i].SubItemImages[j - 1] := 5;
         if AddSecondDrive then
         begin
            j := 1;
            while j < lvVMs.Columns.Count do
            begin
               if lvVMs.Columns[j].Tag = 4 then
                  Break;
               Inc(j);
            end;
            if j < lvVMs.Columns.Count then
               for i := 0 to High(VMEntries) do
                  if VMentries[i].SecondDriveName = '' then
                     lvVMs.Items[i].SubItemImages[j - 1] := -1
                  else if VMentries[i].SecondDriveFound then
                     lvVMs.Items[i].SubItemImages[j - 1] := 4
                  else
                     lvVMs.Items[i].SubItemImages[j - 1] := 5;
         end;
      end;
   except
   end;
   lvVms.Items.EndUpdate;
   lvVMs.Repaint;
   if p > -1 then
   begin
      lvVMS.ItemIndex := p;
      lvVMS.Items[p].Selected := True;
      lvVMS.Items[p].Focused := True;
      lvVMs.Items[lvVMS.ItemIndex].MakeVisible(False);
   end;
   if WasSorted then
   begin
      for i := 255 downto 0 do
         SetLength(FHash[i], 0);
      for i := 0 to lv - 1 do
      begin
         l := Length(vmEntries[i].FirstDriveName);
         if l <> 0 then
         begin
            H := 2166136261;
            for j := 1 to l do
               H := (H xor Byte(vmEntries[i].FirstDriveName[j])) * 16777619;
            H := H and 255;
            SetLength(FHash[H], Length(FHash[H]) + 1);
            FHash[H][High(FHash[h])][1] := 1;
            FHash[H][High(FHash[h])][2] := i;
         end;
         if AddSecondDrive then
         begin
            l := Length(vmEntries[i].SecondDriveName);
            if l = 0 then
               Continue;
            H := 2166136261;
            for j := 1 to l do
               H := (H xor Byte(vmEntries[i].SecondDriveName[j])) * 16777619;
            H := H and 255;
            SetLength(FHash[H], Length(FHash[H]) + 1);
            FHash[H][High(FHash[h])][1] := 2;
            FHash[H][High(FHash[h])][2] := i;
         end;
      end;
      SaveVMentries(VMentriesFile);
   end;
end;

procedure TfrmMain.lvVMsColumnClick(Sender: TObject; Column: TListColumn);
begin
   if lvVMs.Items.Count > 1 then
      if Column.Tag > 0 then
         Sort(Column.Index)
      else if Column.Tag < 0 then
         SortAfterType;
end;

procedure TfrmMain.lvVMsContextPopup(Sender: TObject; MousePos: TPoint;
   var Handled: Boolean);
var
   iuc: TListItem;
   HeaderRect: TRect;
   Pos: TPoint;
begin
   Handled := True;
   GetWindowRect(ListView_GetHeader(lvVMs.Handle), HeaderRect);
   Pos := lvVMs.ClientToScreen(MousePos);
   if PtInRect(HeaderRect, Pos) then
      pmHeaders.Popup(Pos.X, Pos.Y)
   else
   begin
      if PtInRect(lvVMs.ClientRect, MousePos) then
      begin
         try
            iuc := lvVMs.GetItemAt(MousePos.X, MousePos.Y);
            if iuc <> nil then
            begin
               if not iuc.Selected then
                  iuc.Selected := True;
               if not iuc.Focused then
                  iuc.Focused := True;
               if lvVMs.ItemIndex <> iuc.Index then
                  lvVMs.ItemIndex := iuc.Index;
               if mmEditH.Enabled then
               begin
                  mmEditH.Enabled := False;
                  mmEdit.ShortCut := mmEditH.ShortCut;
                  mmEditH.ShortCut := 0;
                  mmEdit.Enabled := True;
               end;
               if mmDeleteH.Enabled then
               begin
                  mmDelete.ShortCut := mmDeleteH.ShortCut;
                  mmDeleteH.Enabled := False;
                  mmDeleteH.ShortCut := 0;
                  mmDelete.Enabled := True;
               end;
               if mmMoveUpH.Enabled then
               begin
                  mmMoveUpH.Enabled := False;
                  mmMoveUp.ShortCut := mmMoveUpH.ShortCut;
                  mmMoveUpH.ShortCut := 0;
                  mmMoveUp.Enabled := True;
               end;
               if mmMoveDownH.Enabled then
               begin
                  mmMoveDown.ShortCut := mmMoveDownH.ShortCut;
                  mmMoveDownH.Enabled := False;
                  mmMoveDownH.ShortCut := 0;
                  mmMoveDown.Enabled := True;
               end;
            end
            else
            begin
               if mmEdit.Enabled then
               begin
                  mmEdit.Enabled := False;
                  mmEditH.ShortCut := mmEdit.ShortCut;
                  mmEdit.ShortCut := 0;
                  mmEditH.Enabled := True;
               end;
               if mmDelete.Enabled then
               begin
                  mmDeleteH.ShortCut := mmDelete.ShortCut;
                  mmDelete.Enabled := False;
                  mmDelete.ShortCut := 0;
                  mmDeleteH.Enabled := True;
               end;
               if mmMoveUp.Enabled then
               begin
                  mmMoveUp.Enabled := False;
                  mmMoveUpH.ShortCut := mmMoveUp.ShortCut;
                  mmMoveUp.ShortCut := 0;
                  mmMoveUpH.Enabled := True;
               end;
               if mmMoveDown.Enabled then
               begin
                  mmMoveDownH.ShortCut := mmMoveDown.ShortCut;
                  mmMoveDown.Enabled := False;
                  mmMoveDown.ShortCut := 0;
                  mmMoveDownH.Enabled := True;
               end;
            end;
         except
            if mmEdit.Enabled then
            begin
               mmEdit.Enabled := False;
               mmEditH.ShortCut := mmEdit.ShortCut;
               mmEdit.ShortCut := 0;
               mmEditH.Enabled := True;
            end;
            if mmDelete.Enabled then
            begin
               mmDeleteH.ShortCut := mmDelete.ShortCut;
               mmDelete.Enabled := False;
               mmDelete.ShortCut := 0;
               mmDeleteH.Enabled := True;
            end;
            if mmMoveUp.Enabled then
            begin
               mmMoveUp.Enabled := False;
               mmMoveUpH.ShortCut := mmMoveUp.ShortCut;
               mmMoveUp.ShortCut := 0;
               mmMoveUpH.Enabled := True;
            end;
            if mmMoveDown.Enabled then
            begin
               mmMoveDownH.ShortCut := mmMoveDown.ShortCut;
               mmMoveDown.Enabled := False;
               mmMoveDown.ShortCut := 0;
               mmMoveDownH.Enabled := True;
            end;
         end;
         pmVMs.Popup(Pos.X, Pos.Y);
      end
      else if (MousePos.X = -1) and (MousePos.Y = -1) then
      begin
         if mmEdit.Enabled then
         begin
            mmEdit.Enabled := False;
            mmEditH.ShortCut := mmEdit.ShortCut;
            mmEdit.ShortCut := 0;
            mmEditH.Enabled := True;
         end;
         if mmDelete.Enabled then
         begin
            mmDeleteH.ShortCut := mmDelete.ShortCut;
            mmDelete.Enabled := False;
            mmDelete.ShortCut := 0;
            mmDeleteH.Enabled := True;
         end;
         if mmMoveUp.Enabled then
         begin
            mmMoveUp.Enabled := False;
            mmMoveUpH.ShortCut := mmMoveUp.ShortCut;
            mmMoveUp.ShortCut := 0;
            mmMoveUpH.Enabled := True;
         end;
         if mmMoveDown.Enabled then
         begin
            mmMoveDownH.ShortCut := mmMoveDown.ShortCut;
            mmMoveDown.Enabled := False;
            mmMoveDown.ShortCut := 0;
            mmMoveDownH.Enabled := True;
         end;
         Pos := Point(lvVMs.ClientOrigin.X + lvVMs.ClientWidth div 2, lvVMs.ClientOrigin.Y + lvVMs.ClientHeight div 2);
         pmVMs.Popup(Pos.X, Pos.Y);
      end;
   end;
end;

procedure GetColors(const BaseColor: TColor; const Range: Byte; var c1, c2: TColor);

   procedure MinMax3(const i, j, k: Integer; var min, max: Integer);
   begin
      if i > j then
      begin
         if i > k then
            max := i
         else
            max := k;

         if j < k then
            min := j
         else
            min := k
      end
      else
      begin
         if j > k then
            max := j
         else
            max := k;

         if i < k then
            min := i
         else
            min := k
      end
   end;

const
   divisor: Integer = 255 * 60;
var
   Delta: Integer;
   MinValue: Integer;
   r, g, b, c, h, s, v, v1, v2, f, hTemp, p, q, t: Integer;
begin
   c := ColorToRGB(BaseColor);
   r := GetRValue(c);
   g := GetGValue(c);
   b := GetBValue(c);
   MinMax3(R, G, B, MinValue, v);
   Delta := v - MinValue;
   h := 0;
   if v = 0 then
      s := 0
   else
      s := (255 * Delta) div v;
   if s = 0 then
      h := 0
   else
   begin
      if r = v then
         h := (60 * (g - b)) div Delta
      else if g = v then
         h := 120 + (60 * (b - r)) div Delta
      else if b = v then
         h := 240 + (60 * (r - g)) div Delta;

      if h < 0 then
         h := h + 360;
   end;

   if v <= 127 then
   begin
      if (v >= Range) and (v <= (255 - Range)) then
      begin
         v1 := v - Range;
         v2 := v + Range;
      end
      else if v > 245 then
      begin
         v1 := 255 - 2 * Range;
         v2 := 255;
      end
      else
      begin
         v1 := 0;
         v2 := 2 * Range;
      end;
   end
   else
   begin
      if (v >= Range) and (v <= (255 - Range)) then
      begin
         v1 := v + Range;
         v2 := v - Range;
      end
      else if v > (255 - Range) then
      begin
         v1 := 255;
         v2 := 255 - 2 * Range;
      end
      else
      begin
         v1 := 2 * Range;
         v2 := 0;
      end;
   end;

   if s = 0 then
   begin
      r := v1;
      g := v1;
      b := v1;
   end
   else
   begin
      if h = 360 then
         hTemp := 0
      else
         hTemp := h;

      f := hTemp mod 60;
      hTemp := hTemp div 60;

      p := v1 - v1 * s div 255;
      q := v1 - (v1 * s * f) div divisor;
      t := v1 - (v1 * s * (60 - f)) div divisor;

      case hTemp of
         0:
            begin
               r := v1;
               g := t;
               b := p;
            end;
         1:
            begin
               r := q;
               g := v1;
               b := p;
            end;
         2:
            begin
               r := p;
               g := v1;
               b := t;
            end;
         3:
            begin
               r := p;
               g := q;
               b := v1;
            end;
         4:
            begin
               r := t;
               g := p;
               b := v1;
            end;
         5:
            begin
               r := v1;
               g := p;
               b := q;
            end;
      else
         begin
            r := v1;
            g := v1;
            b := v1;
         end
      end
   end;
   c1 := RGB(r, g, b);

   if s = 0 then
   begin
      r := v2;
      g := v2;
      b := v2;
   end
   else
   begin
      if h = 360 then
         hTemp := 0
      else
         hTemp := h;

      f := hTemp mod 60;
      hTemp := hTemp div 60;

      p := v2 - v2 * s div 255;
      q := v2 - (v2 * s * f) div divisor;
      t := v2 - (v2 * s * (60 - f)) div divisor;

      case hTemp of
         0:
            begin
               r := v2;
               g := t;
               b := p;
            end;
         1:
            begin
               r := q;
               g := v2;
               b := p;
            end;
         2:
            begin
               r := p;
               g := v2;
               b := t;
            end;
         3:
            begin
               r := p;
               g := q;
               b := v2;
            end;
         4:
            begin
               r := t;
               g := p;
               b := v2;
            end;
         5:
            begin
               r := v2;
               g := p;
               b := q;
            end;
      else
         begin
            r := v2;
            g := v2;
            b := v2;
         end
      end
   end;
   c2 := RGB(r, g, b);
end;

procedure TfrmMain.lvVMsCustomDrawSubItem(Sender: TCustomListView;
   Item: TListItem; SubItem: Integer; State: TCustomDrawState;
   var DefaultDraw: Boolean);
var
   c1, c2: TColor;
begin
   try
      GetColors((Sender as TTNTListView).Canvas.Font.Color, 40, c1, c2);
      if SubItem <= Ceil(0.5 * Item.SubItems.Count) then
         (Sender as TTNTListView).Canvas.Font.Color := c1
      else
         (Sender as TTNTListView).Canvas.Font.Color := c2;
   except
      (Sender as TTNTListView).Canvas.Font.Color := (Sender as TTntListView).Font.Color;
   end;
   if (Sender as TTntListView).Items.Count < 5 then
      Exit;
   try
      if lvVMs.Focused then
      begin
         GetColors((Sender as TTNTListView).Canvas.Brush.Color, 8, c1, c2);
         if (Item.Index mod 2) = 0 then
            (Sender as TTNTListView).Canvas.Brush.Color := c1
         else
            (Sender as TTNTListView).Canvas.Brush.Color := c2;
      end;
   except
      (Sender as TTNTListView).Canvas.Brush.Color := (Sender as TTntListView).Color;
   end;
end;

procedure TfrmMain.AppActDeactModBegModEnd(Sender: TObject);
begin
   if Showing then
      lvVMs.Invalidate;
end;

procedure TfrmMain.mmDownClick(Sender: TObject);
begin
   if lvVMs.Items.Count < 1 then
      Exit;
   if lvVMs.ItemIndex < (lvVMs.Items.Count - 1) then
      lvVMs.ItemIndex := lvVMs.ItemIndex + 1
   else
      lvVMs.ItemIndex := 0;
   lvVMs.Items[lvVMs.ItemIndex].Selected := True;
   lvVMs.Items[lvVMs.ItemIndex].Focused := True;
end;

procedure TfrmMain.mmUpClick(Sender: TObject);
begin
   if lvVMs.Items.Count < 1 then
      Exit;
   if lvVMs.ItemIndex > 0 then
      lvVMs.ItemIndex := lvVMs.ItemIndex - 1
   else
      lvVMs.ItemIndex := lvVMs.Items.Count - 1;
   lvVMs.Items[lvVMs.ItemIndex].Selected := True;
   lvVMs.Items[lvVMs.ItemIndex].Focused := True;
end;

procedure TfrmMain.mmEnterClick(Sender: TObject);
begin
   btnStart.Click;
end;

procedure TfrmMain.mmEscClick(Sender: TObject);
begin
   btnExit.Click;
end;

procedure TfrmMain.mmNumPlusClick(Sender: TObject);
begin
   btnAdd.Click;
end;

function enumResNamesProc(module: HMODULE; restype, resname: PAnsiChar): Integer; stdcall;
var
   RS: TResourceStream;
   ws: WideString;
   Obj: TMyObj;
begin
   RS := nil;
   try
      RS := TResourceStream.Create(0, resname, PAnsiChar('Languages'));
      frmOptions.xmlTemp.LoadFromStream(RS);
   except
   end;
   if RS <> nil then
      try
         RS.Free;
      except
      end;
   if frmOptions.xmlTemp.Active then
   begin
      try
         ws := frmOptions.xmlTemp.ChildNodes[idxInterface].ChildNodes.FindNode('Language').ChildNodes.FindNode('Name').Text +
            ', translated by ' + frmOptions.xmlTemp.ChildNodes[idxInterface].ChildNodes.FindNode('Language').ChildNodes.FindNode('Author').Text;
         if frmOptions.cmbLanguage.Items.IndexOf(ws) = -1 then
         begin
            Obj := TMyObj.Create();
            Obj.Text := resname;
            frmOptions.cmbLanguage.Items.AddObject(ws, Obj);
         end;
      finally
         frmOptions.xmlTemp.Active := False;
      end;
   end;
   Result := 1;
end;

function enumResTypesProc: Integer; stdcall;
begin
   EnumResourceNames(0, PAnsiChar('Languages'), @enumResNamesProc, 0);
   Result := 1;
end;

procedure TfrmMain.btnOptionsClick(Sender: TObject);
var
   i, j: Integer;
   ws: WideString;
   sr: TSearchRecW;
   Obj: TMyObj;
begin
   btnOptions.Down := True;
   try
      try
         if frmOptions = nil then
            Application.CreateForm(TfrmOptions, frmOptions);
         with frmOptions do
         begin
            cbLock.Checked := LockVolumes;
            cbSecondDrive.Checked := AddSecondDrive;
            edtWaitTime.Text := IntToStr(FlushWaitTime);
            cbBackup.Checked := BackupOldEntries;
            cbDontWarn.Checked := DontWarn;
            if DefaultVMType = 1 then
               sbQEMU.Click;
            cbListOnlyUSBDrives.Checked := ListOnlyUSBDrives;
            cbAutomaticFont.Checked := AutomaticFont;
            btnChooseFont.Enabled := not AutomaticFont;
            with fdListViewFont.Font do
            begin
               Name := FontName;
               Size := FontSize;
               Style := [];
               if FontBold then
                  Style := Style + [fsBold];
               if FontItalic then
                  Style := Style + [fsItalic];
               if FontUnderline then
                  Style := Style + [fsUnderline];
               if FontStrikeOut then
                  Style := Style + [fsStrikeOut];
               Color := FontColor;
               Charset := FontScript;
            end;
            cbEscapeKeyClosesMain.Checked := EscapeKeyClosesMain;
            if WideFindFirst(LngFolder + '\*.lng', faAnyFile - faDirectory, sr) = 0 then
            begin
               repeat
                  try
                     frmOptions.xmlTemp.LoadFromFile(LngFolder + '\' + sr.Name);
                     if frmOptions.xmlTemp.Active then
                     begin
                        try
                           ws := frmOptions.xmlTemp.ChildNodes[idxInterface].ChildNodes.FindNode('Language').ChildNodes.FindNode('Name').Text +
                              ', translated by ' + frmOptions.xmlTemp.ChildNodes[idxInterface].ChildNodes.FindNode('Language').ChildNodes.FindNode('Author').Text;
                           if frmOptions.cmbLanguage.Items.IndexOf(ws) = -1 then
                           begin
                              Obj := TMyObj.Create();
                              Obj.Text := sr.Name;
                              frmOptions.cmbLanguage.Items.AddObject(ws, Obj);
                           end;
                        except
                        end;
                        frmOptions.xmlTemp.Active := False;
                     end;
                  except
                  end;
               until WideFindNext(sr) <> 0;
               WideFindClose(sr);
            end;
            enumResTypesProc;
            frmOptions.cmbLanguage.ItemIndex := frmOptions.cmbLanguage.Items.IndexOf(xmlLanguage.ChildNodes[idxInterface].ChildNodes.FindNode('Language').ChildNodes.FindNode('Name').Text +
               ', translated by ' + xmlLanguage.ChildNodes[idxInterface].ChildNodes.FindNode('Language').ChildNodes.FindNode('Author').Text);
            edtVBExePath.Text := ExeVBPath;
            case UpdateVM of
               1:
                  begin
                     cbUseVboxmanage.Checked := True;
                     cbAutoDetect.Checked := False;
                  end;
               2:
                  begin
                     cbDirectly.Checked := True;
                     cbAutoDetect.Checked := False;
                  end;
            end;
            cbCPUVirtualizationOption.Checked := ShowVBCPUVirtualizationOption;
            cbRemoveDrive.Checked := RemoveDrive;
            edtQExePath.Text := ExeQPath;
            edtDefaultParameters.Text := QEMUDefaultParameters;
            if ShowModal = mrOK then
            begin
               LockVolumes := cbLock.Checked;
               if AddSecondDrive <> cbSecondDrive.Checked then
                  if cbSecondDrive.Checked then
                  begin
                     lvVMs.Items.BeginUpdate;
                     lvVMs.Columns.BeginUpdate;
                     pmHeaders.Items[4].Visible := True;
                     pmHeaders.Items[3].Caption := GetLangTextDef(idxMain, ['List', 'Header', 'FirstDrive'], 'First drive');
                     for i := 1 to lvVms.Columns.Count - 1 do
                        if lvVms.Columns[i].Tag = 3 then
                        begin
                           lvVms.Columns[i].Caption := GetLangTextDef(idxMain, ['List', 'Header', 'FirstDrive'], 'First drive');
                           Break;
                        end;
                     pmHeadersPopup(pmHeaders);
                     pmHeaders.Items[4].Click;
                     j := 1;
                     while j < lvVMs.Columns.Count do
                     begin
                        if lvVMs.Columns[j].Tag = 4 then
                           Break;
                        Inc(j);
                     end;
                     if j < lvVMs.Columns.Count then
                        for i := 0 to High(VMEntries) do
                           lvVMs.Items[i].SubItemImages[j - 1] := -1;
                     lvVMS.Items.EndUpdate;
                     lvVMs.Columns.EndUpdate;
                  end
                  else
                  begin
                     for i := 0 to lvVms.Items.Count - 1 do
                        VMEntries[i].SecondDriveName := '';
                     SaveVMentries(VMentriesFile);
                     for i := 255 downto 0 do
                     begin
                        j := High(FHash[i]);
                        while j >= 0 do
                        begin
                           if FHash[i][j][1] = 2 then
                           begin
                              Move(FHash[i][j + 1][1], FHash[i][j][1], (High(FHash[i]) - j) * 4);
                              SetLength(FHash[i], High(FHash[i]));
                           end;
                           Dec(j);
                        end;
                     end;
                     lvVMs.Items.BeginUpdate;
                     lvVMs.Columns.BeginUpdate;
                     pmHeaders.Items[3].Caption := GetLangTextDef(idxMain, ['List', 'Header', 'Drive'], 'Drive');
                     for i := 1 to lvVms.Columns.Count - 1 do
                        if lvVms.Columns[i].Tag = 3 then
                        begin
                           lvVms.Columns[i].Caption := GetLangTextDef(idxMain, ['List', 'Header', 'Drive'], 'Drive');
                           Break;
                        end;
                     i := 1;
                     while i < lvVms.Columns.Count do
                     begin
                        if lvVms.Columns[i].Tag = 4 then
                           Break;
                        Inc(i);
                     end;
                     if i < lvVms.Columns.Count then
                        try
                           i := 1;
                           while i < lvVMS.Columns.Count do
                           begin
                              if lvVMS.Columns[i].Tag = 4 then
                              begin
                                 pmHeaders.Items[4].Tag := lvVMS.Columns[i].Width;
                                 lvVMS.Columns[i].Free;
                                 for j := 0 to lvVMS.Items.Count - 1 do
                                    lvVMS.Items[j].SubItems.Delete(i - 1);
                                 Break;
                              end;
                              Inc(i);
                           end;
                        except
                        end;
                     pmHeaders.Items[4].Visible := False;
                     lvVMS.Items.EndUpdate;
                     lvVMs.Columns.EndUpdate;
                     TntFormResize(Self);
                  end;
               AddSecondDrive := cbSecondDrive.Checked;
               FlushWaitTime := Min(Max(StrToIntDef(Trim(edtWaitTime.Text), 500), 0), 20000);
               BackupOldEntries := cbBackup.Checked;
               DontWarn := cbDontWarn.Checked;
               DefaultVMType := Integer(sbQEMU.Down);
               if cbListOnlyUSBDrives.Checked <> ListOnlyUSBDrives then
               begin
                  ListOnlyUSBDrives := cbListOnlyUSBDrives.Checked;
                  mmRefreshClick(Self);
               end;
               AutomaticFont := cbAutomaticFont.Checked;
               with fdListViewFont.Font do
               begin
                  FontName := Name;
                  FontSize := Size;
                  FontBold := fsBold in Style;
                  FontItalic := fsItalic in Style;
                  FontUnderline := fsUnderline in Style;
                  FontStrikeOut := fsStrikeOut in Style;
                  FontColor := Color;
                  FontScript := Charset;
               end;
               lvVMs.Items.BeginUpdate;
               with lvVMs.Font do
               begin
                  if not AutomaticFont then
                  begin
                     Name := FontName;
                     Size := FontSize;
                     Style := [];
                     if FontBold then
                        Style := Style + [fsBold];
                     if FontItalic then
                        Style := Style + [fsItalic];
                     if FontUnderline then
                        Style := Style + [fsUnderline];
                     if FontStrikeOut then
                        Style := Style + [fsStrikeOut];
                     Color := FontColor;
                     Charset := FontScript;
                  end
                  else
                  begin
                     Name := DefaultFontName;
                     Size := DefaultFontSize;
                     Style := [];
                     if DefaultFontBold then
                        Style := Style + [fsBold];
                     if DefaultFontItalic then
                        Style := Style + [fsItalic];
                     if DefaultFontUnderline then
                        Style := Style + [fsUnderline];
                     if DefaultFontStrikeOut then
                        Style := Style + [fsStrikeOut];
                     Color := DefaultFontColor;
                     Charset := DefaultFontScript;
                  end;
               end;
               lvVMs.Items.EndUpdate;
               if cbEscapeKeyClosesMain.Checked <> EscapeKeyClosesMain then
                  if cbEscapeKeyClosesMain.Checked then
                     mmEsc.ShortCut := ShortCut(VK_ESCAPE, [])
                  else
                     mmEsc.ShortCut := 0;
               EscapeKeyClosesMain := cbEscapeKeyClosesMain.Checked;
               if (CurrLanguageFile <> TMyObj(cmbLanguage.Items.Objects[cmbLanguage.ItemIndex]).Text) or
                  ((xmlLanguage.ChildNodes[idxInterface].ChildNodes.FindNode('Language').ChildNodes.FindNode('Name').Text +
                  ', translated by ' + xmlLanguage.ChildNodes[idxInterface].ChildNodes.FindNode('Language').ChildNodes.FindNode('Author').Text) <>
                  cmbLanguage.Items[cmbLanguage.ItemIndex]) then
               begin
                  CurrLanguageFile := TMyObj(cmbLanguage.Items.Objects[cmbLanguage.ItemIndex]).Text;
                  ChangeCompLang;
               end;
               ExeVBPath := Trim(edtVBExePath.Text);
               GetVBVersion;
               UpdateVM := 2 * Integer(cbDirectly.Checked) + Integer(cbUseVboxmanage.Checked);
               ShowVBCPUVirtualizationOption := cbCPUVirtualizationOption.Checked;
               RemoveDrive := cbRemoveDrive.Checked;
               ExeQPath := Trim(edtQExePath.Text);
               QEMUDefaultParameters := Trim(edtDefaultParameters.Text);
               SaveCFG(CfgFile);
            end;
         end;
      finally
         frmOptions.Free;
         frmOptions := nil;
      end;
   except
   end;
   btnOptions.Down := False;
end;

procedure TfrmMain.mmHelpClick(Sender: TObject);
begin
   OpenInternetHelp(Self.Handle, DefSiteHelp);
end;

procedure TfrmMain.mmOptionsClick(Sender: TObject);
begin
   btnOptions.Click;
end;

function TfrmMain.FindCDROMLetter(const CDROMName: AnsiString): Char;
var
   objWMIService: OLEVariant;
   colItems: OLEVariant;
   colItem: OLEVariant;
   oEnum: IEnumvariant;
   iValue: LongWord;
   i, j: Integer;
   isFound: Boolean;
   strTemp: AnsiString;

   function GetWMIObject(const objectName: AnsiString): IDispatch;
   var
      chEaten: Integer;
      BindCtx: IBindCtx;
      Moniker: IMoniker;
   begin
      OleCheck(CreateBindCtx(0, bindCtx));
      OleCheck(MkParseDisplayName(BindCtx, StringToOleStr(objectName), chEaten, Moniker));
      OleCheck(Moniker.BindToObject(BindCtx, nil, IDispatch, Result));
   end;
begin
   Result := '0';
   if Succeeded(CoInitialize(nil)) then
      try
         try
            objWMIService := GetWMIObject(Format('winmgmts:\\%s\%s', ['.', 'root\CIMV2']));
            colItems := objWMIService.ExecQuery(Format('SELECT %s FROM %s', ['Caption', 'Win32_CDROMDrive']), 'WQL', 0);
            oEnum := IUnknown(colItems._NewEnum) as IEnumVariant;
            i := 0;
            isFound := False;
            while oEnum.Next(1, colItem, iValue) = 0 do
            begin
               if AnsiString(colItem.Properties_.Item('Caption', 0)) = CDROMName then
               begin
                  isFound := True;
                  Break;
               end;
               Inc(i);
            end;
            if not isFound then
               Exit;
            colItems := objWMIService.ExecQuery(Format('SELECT %s FROM %s', ['Drive', 'Win32_CDROMDrive']), 'WQL', 0);
            oEnum := IUnknown(colItems._NewEnum) as IEnumVariant;
            j := 0;
            while oEnum.Next(1, colItem, iValue) = 0 do
            begin
               if i = j then
               begin
                  strTemp := colItem.Properties_.Item('Drive', 0);
                  if (Length(strTemp) = 2) and (strTemp[2] = ':') and (strTemp[1] in ['A'..'Z']) then
                     Result := strTemp[1];
                  Break;
               end;
               Inc(j);
               if j > i then
                  Break;
            end;
         except
         end;
      finally
         CoUninitialize;
      end;
end;

procedure GetVBVersion;
type
   TBytes = array of Byte;
var
   Size, Handle: DWORD;
   Buffer: TBytes;
   FixedPtr: PVSFixedFileInfo;
   UseDll: Boolean;
begin
   WaitForVBSVC := True;
   VBSVC2x := True;
   UseDll := False;
   try
      if not WideFileExists(ExeVBPath) then
      begin
         WaitForVBSVC := False;
         VBSVC2x := False;
         Exit;
      end;
      Size := GetFileVersionInfoSizeW(PWideChar(ExeVBPath), Handle);
      if Size = 0 then
      begin
         Size := GetFileVersionInfoSizeW(PWideChar(WideExtractFilePath(ExeVBPath) + 'VirtualBox.dll'), Handle);
         if Size = 0 then
         begin
            WaitForVBSVC := False;
            VBSVC2x := False;
            Exit;
         end;
         UseDll := True;
      end;
      SetLength(Buffer, Size);
      if not UseDll then
      begin
         if not GetFileVersionInfoW(PWideChar(ExeVBPath), Handle, Size, Buffer) then
         begin
            WaitForVBSVC := False;
            VBSVC2x := False;
            Exit;
         end;
      end
      else if not GetFileVersionInfoW(PWideChar(WideExtractFilePath(ExeVBPath) + 'VirtualBox.dll'), Handle, Size, Buffer) then
      begin
         WaitForVBSVC := False;
         VBSVC2x := False;
         Exit;
      end;
      if not VerQueryValue(Buffer, '\', Pointer(FixedPtr), Size) then
      begin
         WaitForVBSVC := False;
         VBSVC2x := False;
         Exit;
      end;
      if LongRec(FixedPtr.dwFileVersionMS).Hi <= 3 then
      begin
         WaitForVBSVC := False;
         VBSVC2x := False;
         Exit;
      end
      else if LongRec(FixedPtr.dwFileVersionMS).Hi >= 5 then
      begin
         WaitForVBSVC := False;
         VBSVC2x := False;
         Exit;
      end;

      case LongRec(FixedPtr.dwFileVersionMS).Lo of
         0..1:
            begin
               WaitForVBSVC := False;
               VBSVC2x := False;
            end;
         2: VBSVC2x := False;
         3:
            if LongRec(FixedPtr.dwFileVersionLS).Hi >= 11 then
            begin
               WaitForVBSVC := False;
               VBSVC2x := False;
            end;
      else
         WaitForVBSVC := False;
         VBSVC2x := False;
      end;
   except
   end;
end;

procedure TfrmMain.mmRefreshClick(Sender: TObject);
var
   i, j: Integer;
begin
   FindDrives;
   j := 1;
   lvVMs.Items.BeginUpdate;
   while j < lvVMs.Columns.Count do
   begin
      if lvVMs.Columns[j].Tag = 3 then
         Break;
      Inc(j);
   end;
   if j < lvVMs.Columns.Count then
      for i := 0 to High(VMEntries) do
         if VMentries[i].FirstDriveName = '' then
            lvVMs.Items[i].SubItemImages[j - 1] := -1
         else if VMentries[i].FirstDriveFound then
            lvVMs.Items[i].SubItemImages[j - 1] := 4
         else
            lvVMs.Items[i].SubItemImages[j - 1] := 5;
   if AddSecondDrive then
   begin
      j := 1;
      while j < lvVMs.Columns.Count do
      begin
         if lvVMs.Columns[j].Tag = 4 then
            Break;
         Inc(j);
      end;
      if j < lvVMs.Columns.Count then
         for i := 0 to High(VMEntries) do
            if VMentries[i].SecondDriveName = '' then
               lvVMs.Items[i].SubItemImages[j - 1] := -1
            else if VMentries[i].SecondDriveFound then
               lvVMs.Items[i].SubItemImages[j - 1] := 4
            else
               lvVMs.Items[i].SubItemImages[j - 1] := 5;
   end;
   lvVMs.Items.EndUpdate;
   lvVMs.Repaint;
end;

constructor TComponentDrive.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   FWindowHandle := Classes.AllocateHWnd(WndProc);
   DriveRegister;
end;

destructor TComponentDrive.Destroy;
begin
   UnregisterDeviceNotification(FHandle);
   Classes.DeallocateHWnd(FWindowHandle);
   inherited Destroy;
end;

procedure TComponentDrive.WndProc(var Msg: TMessage);
begin
   if Msg.Msg = WM_DEVICECHANGE then
   begin
      try
         WMDeviceChange(Msg);
      except
         Application.HandleException(Self);
      end;
   end
   else
      Msg.Result := DefWindowProc(FWindowHandle, Msg.Msg, Msg.wParam, Msg.lParam);
end;

procedure TComponentDrive.WMDeviceChange(var Msg: TMessage);
var
   i: Byte;
   j, k, l: Integer;
   H: Cardinal;
   sz: Double;
   Mask: DWORD;
   hVolume, hDrive: THandle;
   dwBytesReturned: DWORD;
   sdn: STORAGE_DEVICE_NUMBER;
   strTemp, csz, mu: AnsiString;

   procedure Round3;
   var
      k, n: Integer;
   begin
      k := 0;
      if sz < 100 then
      begin
         while sz < 1000 do
         begin
            sz := sz * 10;
            Inc(k);
         end;
         Dec(k);
         csz := IntToStr(Round(sz / 10));
         if k <= 2 then
            Insert('.', csz, 4 - k)
         else
         begin
            for n := 1 to k - 2 do
               csz := '0' + csz;
            Insert('.', csz, 2);
         end;
      end
      else if sz > 1000 then
      begin
         while sz > 100 do
         begin
            sz := sz / 10;
            Inc(k);
         end;
         Dec(k);
         csz := IntToStr(Round(sz * 10));
         for n := 1 to k do
            csz := csz + '0';
      end
      else
         csz := IntToStr(Round(sz));
   end;

begin
   if (Msg.wParam = DBT_DEVICEREMOVECOMPLETE) and
      (PDevBroadcastHdr(Msg.lParam)^.dbch_devicetype = DBT_DEVTYP_DEVICEINTERFACE) then
   begin
      if frmMain.Showing then
      begin
         FindDrives;
         frmMain.lvVMs.Items.BeginUpdate;
         j := 1;
         while j < frmMain.lvVMs.Columns.Count do
         begin
            if frmMain.lvVMs.Columns[j].Tag = 3 then
               Break;
            Inc(j);
         end;
         if j < frmMain.lvVMs.Columns.Count then
            for i := 0 to High(VMEntries) do
               if VMentries[i].FirstDriveName = '' then
                  frmMain.lvVMs.Items[i].SubItemImages[j - 1] := -1
               else if VMentries[i].FirstDriveFound then
                  frmMain.lvVMs.Items[i].SubItemImages[j - 1] := 4
               else
                  frmMain.lvVMs.Items[i].SubItemImages[j - 1] := 5;
         if AddSecondDrive then
         begin
            j := 1;
            while j < frmMain.lvVMs.Columns.Count do
            begin
               if frmMain.lvVMs.Columns[j].Tag = 4 then
                  Break;
               Inc(j);
            end;
            if j < frmMain.lvVMs.Columns.Count then
               for i := 0 to High(VMEntries) do
                  if VMentries[i].SecondDriveName = '' then
                     frmMain.lvVMs.Items[i].SubItemImages[j - 1] := -1
                  else if VMentries[i].SecondDriveFound then
                     frmMain.lvVMs.Items[i].SubItemImages[j - 1] := 4
                  else
                     frmMain.lvVMs.Items[i].SubItemImages[j - 1] := 5;
         end;
         frmMain.lvVMs.Items.EndUpdate;
         frmMain.lvVMs.Repaint;
      end
      else
         FindDrivesScheduled := True;
   end
   else if (Msg.wParam = DBT_DEVICEARRIVAL) and
      (PDevBroadcastHdr(Msg.lParam)^.dbch_devicetype = DBT_DEVTYP_VOLUME) then
      if PDevBroadcastVolume(Msg.lParam)^.dbcv_flags = $0000 then
         if frmMain.Showing then
         begin
            Mask := PDevBroadcastVolume(Msg.lParam)^.dbcv_unitmask;
            i := 0;
            while i <= 25 do
            begin
               if (Mask and 1) = 1 then
               begin
                  try
                     hVolume := CreateFile(PAnsiChar('\\.\' + AnsiChar(i + Ord('A')) + ':'), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                  except
                     hVolume := INVALID_HANDLE_VALUE;
                  end;
                  if hVolume <> INVALID_HANDLE_VALUE then
                  begin
                     if ListOnlyUSBDrives and (not IsUSBDrive(hVolume)) then
                     begin
                        try
                           CloseHandle(hVolume);
                        except
                        end;
                        Exit;
                     end;
                     dwBytesReturned := 0;
                     try
                        if DeviceIoControl(hVolume, IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0, @sdn, sizeof(sdn), dwBytesReturned, nil) then
                        begin
                           if sdn.DeviceNumber = OSDrive then
                              Exit;
                           try
                              hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(sdn.DeviceNumber)), GENERIC_READ,
                                 FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                           except
                              hDrive := INVALID_HANDLE_VALUE;
                           end;
                           if hDrive <> INVALID_HANDLE_VALUE then
                           begin
                              strTemp := GetDriveVendorAndProductID(hDrive);
                              sz := GetDriveSize(hDrive) / 1073741824;
                              try
                                 CloseHandle(hDrive);
                              except
                              end;
                              if sz <= 0 then
                                 Continue
                              else
                              begin
                                 if sz < 1 then
                                 begin
                                    sz := sz * 1024;
                                    mu := ' MB';
                                 end
                                 else if sz > 1000 then
                                 begin
                                    sz := sz / 1024;
                                    mu := ' TB';
                                 end
                                 else
                                    mu := ' GB';
                                 Round3;
                                 strTemp := strTemp + ', ' + csz + mu;
                              end;
                              l := Length(strTemp);
                              H := 2166136261;
                              if l = 0 then
                              begin
                                 try
                                    CloseHandle(hDrive);
                                 except
                                 end;
                                 Continue;
                              end;
                              for j := 1 to l do
                                 H := (H xor Byte(strTemp[j])) * 16777619;
                              H := H and 255;
                              for j := 0 to High(FHash[H]) do
                              begin
                                 if (FHash[H][j][1] <> 1) or (Length(vmEntries[FHash[H][j][2]].FirstDriveName) <> l) then
                                    Continue;
                                 k := 1;
                                 while k <= l do
                                 begin
                                    if strTemp[k] <> vmEntries[FHash[H][j][2]].FirstDriveName[k] then
                                       Break;
                                    Inc(k);
                                 end;
                                 if k > l then
                                    vmEntries[FHash[H][j][2]].FirstDriveFound := True;
                              end;
                              if AddSecondDrive then
                                 for j := 0 to High(FHash[H]) do
                                 begin
                                    if (FHash[H][j][1] <> 2) or (Length(vmEntries[FHash[H][j][2]].SecondDriveName) <> l) then
                                       Continue;
                                    k := 1;
                                    while k <= l do
                                    begin
                                       if strTemp[k] <> vmEntries[FHash[H][j][2]].SecondDriveName[k] then
                                          Break;
                                       Inc(k);
                                    end;
                                    if k > l then
                                       vmEntries[FHash[H][j][2]].SecondDriveFound := True;
                                 end;
                           end
                           else
                              Exit;
                        end
                        else
                           FindDrives;
                     except
                        FindDrives;
                     end;
                     try
                        CloseHandle(hVolume);
                     except;
                     end;
                  end
                  else
                     FindDrives;
                  Break;
               end;
               Mask := Mask shr 1;
               Inc(i);
            end;
            if i > 25 then
               FindDrives;
            frmMain.lvVMs.Items.BeginUpdate;
            j := 1;
            while j < frmMain.lvVMs.Columns.Count do
            begin
               if frmMain.lvVMs.Columns[j].Tag = 3 then
                  Break;
               Inc(j);
            end;
            if j < frmMain.lvVMs.Columns.Count then
               for i := 0 to High(VMEntries) do
                  if VMentries[i].FirstDriveName = '' then
                     frmMain.lvVMs.Items[i].SubItemImages[j - 1] := -1
                  else if VMentries[i].FirstDriveFound then
                     frmMain.lvVMs.Items[i].SubItemImages[j - 1] := 4
                  else
                     frmMain.lvVMs.Items[i].SubItemImages[j - 1] := 5;
            if AddSecondDrive then
            begin
               j := 1;
               while j < frmMain.lvVMs.Columns.Count do
               begin
                  if frmMain.lvVMs.Columns[j].Tag = 4 then
                     Break;
                  Inc(j);
               end;
               if j < frmMain.lvVMs.Columns.Count then
                  for i := 0 to High(VMEntries) do
                     if VMentries[i].SecondDriveName = '' then
                        frmMain.lvVMs.Items[i].SubItemImages[j - 1] := -1
                     else if VMentries[i].SecondDriveFound then
                        frmMain.lvVMs.Items[i].SubItemImages[j - 1] := 4
                     else
                        frmMain.lvVMs.Items[i].SubItemImages[j - 1] := 5;
            end;
            frmMain.lvVMs.Items.EndUpdate;
            frmMain.lvVMs.Repaint;
         end
         else
            FindDrivesScheduled := True;
end;

procedure TComponentDrive.DriveRegister;
var
   dbi: DEV_BROADCAST_DEVICEINTERFACE;
   Size: Integer;
begin
   Size := SizeOf(DEV_BROADCAST_DEVICEINTERFACE);
   ZeroMemory(@dbi, Size);
   dbi.dbcc_size := Size;
   dbi.dbcc_devicetype := DBT_DEVTYP_DEVICEINTERFACE;
   dbi.dbcc_reserved := 0;
   dbi.dbcc_classguid := GUID_DEVINTERFACE_DISK;

   FHandle := RegisterDeviceNotification(FWindowHandle, @dbi, DEVICE_NOTIFY_WINDOW_HANDLE);
end;

procedure TfrmMain.AppException(Sender: TObject; E: Exception);
begin
   //
end;

procedure TfrmMain.AcceptFiles(var msg: TMessage);
var
   Buffer: array[0..MAX_PATH] of AnsiChar;
   strTemp: AnsiString;
   hVolume, hDrive: THandle;
   dwBytesReturned: DWORD;
   sdn: STORAGE_DEVICE_NUMBER;
   ErrorMode: Word;
begin
   Application.BringToFront;
   Repaint;
   case DragQueryFile(msg.WParam, $FFFFFFFF, nil, 0) of
      1:
         begin
            DragQueryFile(msg.WParam, 0, @Buffer, sizeof(Buffer));
            DragFinish(msg.WParam);
            strTemp := AnsiString(Buffer);
            if (Length(strTemp) = 3) and (strTemp[1] in ['A'..'Z']) and (strTemp[2] = ':') and
               (strTemp[3] = '\') then
            begin
               ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
               try
                  case GetDriveType(PAnsiChar(strTemp)) of
                     DRIVE_REMOVABLE, DRIVE_FIXED:
                        begin
                           try
                              hVolume := CreateFile(PAnsiChar('\\.\' + strTemp[1] + ':'), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                           except
                              hVolume := INVALID_HANDLE_VALUE;
                           end;
                           if hVolume <> INVALID_HANDLE_VALUE then
                           begin
                              if ListOnlyUSBDrives and (not IsUSBDrive(hVolume)) then
                              begin
                                 try
                                    CloseHandle(hVolume);
                                 except
                                 end;
                                 msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                 PostMessage(Handle, WM_USER + 1024, 0, 0);
                                 MessageBoxW(Handle,
                                    PWideChar(GetLangTextDef(idxMain, ['Messages', 'NotUSBDrive'], 'This is not a USB drive !')),
                                    PWideChar(msgBoxCaption),
                                    MB_OK or MB_ICONWARNING);
                                 Exit;
                              end;
                              dwBytesReturned := 0;
                              try
                                 if DeviceIoControl(hVolume, IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0, @sdn, sizeof(sdn), dwBytesReturned, nil) then
                                 begin
                                    if sdn.DeviceNumber <> OSDrive then
                                    begin
                                       try
                                          hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(sdn.DeviceNumber)), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                                       except
                                          hDrive := INVALID_HANDLE_VALUE;
                                       end;
                                       if hDrive <> INVALID_HANDLE_VALUE then
                                       begin
                                          try
                                             try
                                                CloseHandle(hDrive);
                                             except
                                             end;
                                             try
                                                DriveToAdd := sdn.DeviceNumber;
                                                btnAddClick(nil);
                                             finally
                                                DriveToAdd := -1;
                                             end
                                          except
                                          end;
                                       end
                                       else
                                       begin
                                          LastError := GetLastError;
                                          msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                          PostMessage(Handle, WM_USER + 1024, 0, 0);
                                          MessageBoxW(Handle,
                                             PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'ErrorAccessDrive'], [WideSysErrorMessage(LastError)], 'Error accessing the drive !'#13#10#13#10'System message: %s')),
                                             PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                                       end;
                                    end
                                    else
                                    begin
                                       msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                       PostMessage(Handle, WM_USER + 1024, 0, 0);
                                       MessageBoxW(Handle,
                                          PWideChar(GetLangTextDef(idxMain, ['Messages', 'CantUseOSDrive'], 'This is the OS drive, can''t use !')),
                                          PWideChar(msgBoxCaption),
                                          MB_OK or MB_ICONWARNING);
                                    end;
                                 end
                                 else
                                 begin
                                    LastError := GetLastError;
                                    msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                    PostMessage(Handle, WM_USER + 1024, 0, 0);
                                    MessageBoxW(Handle,
                                       PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'ErrorGetDriveNr'], [WideSysErrorMessage(LastError)], 'Error getting the drive number !'#13#10#13#10'System message: %s')),
                                       PWideChar(msgBoxCaption),
                                       MB_OK or MB_ICONWARNING);
                                 end;
                              except
                                 LastError := GetLastError;
                                 msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                 PostMessage(Handle, WM_USER + 1024, 0, 0);
                                 MessageBoxW(Handle,
                                    PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'ErrorAccessVolDrive'], [WideSysErrorMessage(LastError)], 'Error accessing the volume on drive !'#13#10#13#10'System message: %s')),
                                    PWideChar(msgBoxCaption),
                                    MB_OK or MB_ICONWARNING);
                              end;
                              try
                                 CloseHandle(hVolume);
                              except
                              end;
                           end
                           else
                           begin
                              LastError := GetLastError;
                              msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                              PostMessage(Handle, WM_USER + 1024, 0, 0);
                              MessageBoxW(Handle,
                                 PWideChar(GetLangTextFormatDef(idxMain, ['Messages', 'ErrorAccessVolDrive'], [WideSysErrorMessage(LastError)], 'Error accessing the volume on drive !'#13#10#13#10'System message: %s')),
                                 PWideChar(msgBoxCaption),
                                 MB_OK or MB_ICONWARNING);
                           end;
                        end
                  else
                     msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                     PostMessage(Handle, WM_USER + 1024, 0, 0);
                     MessageBoxW(Handle,
                        PWideChar(GetLangTextDef(idxMain, ['Messages', 'NotRemFixedLocalDrive'], 'This is not a removable or fixed local drive !')),
                        PWideChar(msgBoxCaption),
                        MB_OK or MB_ICONWARNING);
                     Exit;
                  end;
               finally
                  SetErrorMode(ErrorMode);
               end;
            end
            else
            begin
               msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
               PostMessage(Handle, WM_USER + 1024, 0, 0);
               MessageBoxW(Handle,
                  PWideChar(GetLangTextDef(idxMain, ['Messages', 'NotVolDrive'], 'Not a volume or drive !')),
                  PWideChar(msgBoxCaption),
                  MB_OK or MB_ICONWARNING);
            end;
         end;
   else
      DragFinish(msg.WParam);
      msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
      PostMessage(Handle, WM_USER + 1024, 0, 0);
      MessageBoxW(Handle,
         PWideChar(GetLangTextDef(idxMain, ['Messages', 'JustOneItem'], 'Just one item at a time !')),
         PWideChar(msgBoxCaption),
         MB_OK or MB_ICONWARNING);
   end;
end;

function CStyleEscapes(const InputText: WideString): WideString;
var
   i, j: Integer;
begin
   SetLength(Result, Length(InputText));
   i := 1;
   j := 1;
   while i <= Length(InputText) do
      if InputText[i] = '\' then
         if i = Length(InputText) then
         begin
            Result[j] := '\';
            Inc(i);
            Inc(j);
         end
         else
         begin
            case InputText[i + 1] of
               'r', 'R': Result[j] := #13;
               'n', 'N': Result[j] := #10;
               't', 'T': Result[j] := #9;
               '\':
                  begin
                     Result[j] := '\';
                     Inc(j);
                     Result[j] := '\';
                  end;
            else
               begin
                  Result[j] := '\';
                  Inc(j);
                  Result[j] := InputText[i + 1];
               end;
            end;
            Inc(i, 2);
            Inc(j);
         end
      else
      begin
         Result[j] := InputText[i];
         Inc(i);
         Inc(j);
      end;
   SetLength(Result, j - 1);
end;

function GetLangTextDef(const IntBaseParam: Integer; const StrParams: array of AnsiString; const DefStr: AnsiString): WideString;
var
   i: Integer;
   XN: IXMLNode;
begin
   try
      XN := frmMain.xmlLanguage.ChildNodes[idxInterface].ChildNodes[IntBaseParam];
      for i := 0 to High(StrParams) do
         XN := XN.ChildNodes.FindNode(StrParams[i]);
      Result := CStyleEscapes(XN.Text);
   except
      Result := WideString(DefStr);
   end;
end;

function GetLangTextFormatDef(const IntBaseParam: Integer; const StrParams: array of AnsiString; const VarRec: array of TVarRec; const DefStr: AnsiString): WideString;
var
   i: Integer;
   XN: IXMLNode;
begin
   try
      XN := frmMain.xmlLanguage.ChildNodes[idxInterface].ChildNodes[IntBaseParam];
      for i := 0 to High(StrParams) do
         XN := XN.ChildNodes.FindNode(StrParams[i]);
      Result := WideFormat(CStyleEscapes(XN.Text), VarRec);
   except
      try
         Result := WideFormat(WideString(DefStr), VarRec);
      except
         Result := 'Internal error';
      end;
   end;
end;

end.

